This file is not used anymore, and is only kept for historical purposes.
If you need a detailled list of changes, please use "git log".

2010-05-10  Mike Kestner  <mkestner@novell.com>

	* gtk/Gtk.metadata: mark Widget.CreatePangoLayout retval as owned.
	[Fixes #604050]

2010-03-25  Mike Kestner  <mkestner@novell.com>

	* gdk/Rectangle.custom: off-by-one in Right/Bottom. [Fixes #591148]

2009-12-28  Mike Kestner  <mkestner@novell.com>

	* glib/glue/Makefile.am: fix a copy/paste issue.
	* pango/glue/Makefile.am: move glue lib to -3 like the others.
	[Fixes #561148]

2009-11-30  Mike Kestner  <mkestner@novell.com>

	* */Makefile.am: standardize on - options over / options for 
	consistency.  Also assists with build on msys. [Fixes #550667]

2009-11-30  Mike Kestner  <mkestner@novell.com>

	* gtk/Widget.custom: add Path method overload.  [Fixes #521360]

2009-11-30  Mike Kestner  <mkestner@novell.com>

	* generator/Method.cs: support win32_utf8_variant attribute on methods.
	* glib/*.cs: support win32 utf8 variant methods.
	* gtk/*.custom: support win32 utf8 variant methods.
	* gtk/Gtk.metadata: mark some win32_utf8_variant methods.
	  [Fixes #550961] Adapted from a patch by Tor Lillqvist.

2009-11-28  Mike Kestner  <mkestner@novell.com>

	* glib/GException.cs: add Code and Domain props to expose the GError 
	  fields to interested users.  [Fixes #555675]

2009-11-23  Christian Hoff  <christian_hoff@gmx.net>

	* generator/Signal.cs: Return a GInterfaceAdapter in the signalargs's
	accessor properties instead of trying to return the implementor as stored in
	the arguments array.

2009-11-01  Mike Kestner  <mkestner@novell.com>

	* glib/Value.cs: avoid cast exceptions passing ints as objects on
	  gulong values.  [Fixes #539812]

2009-10-30  Mike Kestner  <mkestner@novell.com>

	* glib/GType.cs: avoid another exception on bogus assm.Locations.
	  [Fixes #546045]

2009-09-24  Christian Hoff  <christian_hoff@gmx.net>

	* gtk/Widget.custom: Use Glib.Value's GType.Long support.

2009-09-23  Mike Kestner  <mkestner@novell.com>

	* glib/Value.cs: support long and ulong gtypes. still can't construct
	generically, but can cast to long/ulong and access via Val prop.
	[Fixes #539812]

2009-09-23  Mike Kestner  <mkestner@novell.com>

	* generator/ReturnValue.cs: support metadata override of default return
	values.  Based on a patch from Sebastian Dröge. [Fixes #541299]

2009-09-22  Brad Taylor  <brad@getcoded.net>

	* glib/Idle.cs: 
	* glib/Timeout.cs: Don't try to remove the handler from the managed
	hashtable twice, add a comment explaining the need for the else branch.

2009-09-22  Brad Taylor  <brad@getcoded.net>

	* glib/Idle.cs: 
	* glib/Timeout.cs: Make sure to remove the unmanaged reference to the
	delegate when we're disposed or finalized.  In particular, this fixes a
	problem where GLib.Object's PerformQueuedUnrefs was being called after
	both the object and the handler had been GC'ed, resulting in a
	segfault.

2009-09-16  Mike Kestner  <mkestner@novell.com>

	* gtk/Gtk.metadata: hide StatusIcon.GetGeometry for custom impl.
	* gtk/StatusIcon.custom: custom GetGeometry implementation to avoid
	marshaling exceptions on win32.  [Fixes #518169]

2009-09-11  Mike Kestner  <mkestner@novell.com>

	* glib/Object.cs: add support for native instantiation of 
	managed types.
	* glib/ParamSpec.cs: add Flags ctor overload.
	* sample/NativeInstantiationTest.cs: new sample to test the
	unmanaged instantiation capability.
	Based on a patch from Sebastian Dröge [Fixes #499900]

2009-09-11  Christian Hoff  <christian_hoff@gmx.net>

	* gtk/Application.cs: Port the theming-relevant part of the
	SWF.Application.DoEvents code to avoid loading the assembly 
	at runtime on the Windows platform.

2009-09-03  Christian Hoff  <christian_hoff@gmx.net>

	* glib/Global.cs: Kill the calling convention field again.
	It breaks GLib 2.x compatibility in the generator and there is
	probably no need to make the calling convention configurable.
	* .cs, *.custom: Hardcode Cdecl calling convention instead of
	using GLib's field.

2009-09-02  Christian Hoff  <christian_hoff@gmx.net>

	* glib/Global.cs: Add a public constant field specifying the
	calling convention used by GLib and depending libraries.
	By now it's hardcoded to Cdecl as every non-Win32 runtime
	should ignore this attribute.
	* *.cs, *.custom: Use GLib.Global.CallingConvention for both
	pinvokes and callbacks. Plugs a stack leak on Win32. All
	pinvokes defaulted to StdCall and thus the stack was never
	cleaned up.

2009-08-30  Christian Hoff  <christian_hoff@gmx.net>

	Complete the major version jump. Gtk# 3 and 2 are now both
	installable within the same prefix.

	* */glue/Makefile.am: Produce *sharpglue-3 gluelibs.
	* *.custom, *.cs: pinvoke the new glue library.
	* *-2.0.pc.in: Rename to *-3.0.pc.in.

2009-08-30  Christian Hoff  <christian_hoff@gmx.net>

	* gtk/Object.custom: Deglue the floating reference API.
	We should consider moving all that stuff to GInitiallyUnowned
	as Gtk+ did several releases ago.

2009-08-30  Christian Hoff  <christian_hoff@gmx.net>

	* gtk/StatusIcon.custom: Use managed code to pass the address of
	gtk_status_icon_position_menu to gtk_menu_popup.

2009-08-19  Christian Hoff  <christian_hoff@gmx.net>

	* generator/*.cs: Add the "partial" keyword to each generated class, 
	struct and interface.

2009-08-19  Christian Hoff  <christian_hoff@gmx.net>

	* glib/MainContext.cs: Add API to create new MainContexts. Add a few
	missing methods.
	* glib/MainLoop.cs: Allow creating MainLoops in non-default MainContexts.
	[Fixes #526232]

2009-08-18  Christian Hoff  <christian_hoff@gmx.net>

	* sample/GtkDemo/Makefile.am: Resurrect local Mono.Cairo build.

2009-08-13  Christian Hoff  <christian_hoff@gmx.net>

	* gtk/Widget.custom: Set the activate/set_scroll_adjustments signal IDs
	from managed code. Use the gtk_widget_get_window accessor.
	* gtk/glue/widget.c: Remove the corresponding glue functions.

2009-08-13  Christian Hoff  <christian_hoff@gmx.net>

	* generator/IGeneratable.cs: Remove MarshalReturnType, ToNativeReturnType,
	FromNativeReturn and ToNativeReturn as they never returned something else
	than MarshalType, FromNative/AllocNative and CallByName, respectively.
	* generator/Signal.cs: Use AllocNative for IManualMarshalers.

2009-08-12  Christian Hoff  <christian_hoff@gmx.net>

	* configure.in.in: Detect GDK backend.
	* */*.dll.config.in: Link against the libs of the correct GDK backend
	instead of using x11 on Linux/win32 on Windows.
	Patch by Christian Hergert.	[Fixes 527840]

2009-08-07  Mike Kestner  <mkestner@novell.com>

	* configure.in.in: add new dir and autofu for it.
	* Makefile.am: add new dir
	* gapi/*: a small extension method library to add generation-related
	api to GType in 2.0. Access it with -pkg:gapi-2.0-compat to pick up
	the needed refs.
	* generator/GObjectVM.cs: generate new GType getter methods.
	* generator/ObjectGen.cs: generate new GType getter methods.
	* glib/GType.cs: change a few props to methods to make them extension
	method friendly for 2.0 compat.
	* glib/Object.cs: use new GType getter methods.
	* glib/Value.cs: use new GType getter methods.
	* gtk/Widget.custom: use new GetClassPtr method.

2009-08-07  Mike Kestner  <mkestner@novell.com>

	* generator/ObjectGen.cs: kill GType ctor generation.
	* glib/InitiallyUnowned.cs: kill obsolete GType ctor.
	* glib/Object.cs: kill obsolete GType ctor.
	* gtk/Gtk.metadata: kill disable_gtype_ctor rules.
	* gtk/Widget.cs: kill obsolete GType ctor.

2009-08-07  Mike Kestner  <mkestner@novell.com>

	* glib/Log.cs: rework the LogFunc marshaling and add SetDefaultHandler
	binding to override all domains easily. [Fixes #517857]

2009-08-07  Christian Hoff  <christian_hoff@gmx.net>

	* gtk/glue/clipboard.c: Kill as it is not used any more.

2009-08-07  Christian Hoff  <christian_hoff@gmx.net>

	* gtk/SelectionData.custom: Use gtk_selection_data_get_data instead
	of a glue func to access the data field.

2009-08-05  Christian Hoff  <christian_hoff@gmx.net>

	* sample/CustomcellRenderer.cs: Use GObject property registration
	instead of a CellDataFunc.

2009-08-05  Christian Hoff  <christian_hoff@gmx.net>

	* generator/InterfaceGen: Override CallByName to handle interface
	adaptors properly.	[Fixes #527478]

2009-08-01  Mike Kestner  <mkestner@novell.com>

	* glib/GType.cs: lock the types hash to support threaded access and 
	type registration.  Apparently gtype access/registration is threadsafe
	in glib.  [Fixes #526229]

2009-07-30  Mike Kestner  <mkestner@novell.com>

	* generator/InterfaceGen.cs: remove var keyword usage to fix build on
	.Net 2.0.  fix a couple mixed line endings as well.

2009-07-27  Mike Gorse  <mgorse@novell.com>

	* atk/Atk.metadata: Remove owned for Relation.GetTarget.

2009-07-26  Mike Kestner  <mkestner@novell.com>

	* bootstrap-for-the-insane: update the assembly versions and package
	version and kill the policies.  Give a little more helpful message of 
	doom.

2009-07-24  Christian Hoff  <christian_hoff@gmx.net>

	* parser/Makefile.am: Another build fix. Sigh...

2009-07-24  Christian Hoff  <christian_hoff@gmx.net>

	* generator/gapi3-codegen.in, parser/gapi3-fixup.in, parser/gapi3-parser.in:
	"svn add" a few missing files to resurrect the build.

2009-07-23  Christian Hoff  <christian_hoff@gmx.net>

	* configure.in.in, Makefile.include: Bump up GAPI version to 3.0.
	* bootstrap-2.14: Renamed to bootstrap-for-the-insane, added message
	of doom.	[Fixes #521449]

2009-07-21  Christian Hoff  <christian_hoff@gmx.net>

	* glib/GInterfaceAdapter.cs: Fix a leak related to GCHandles not being freed.
	Patch from Mike Kestner with a minor tweak by me. [Fixes #523306]

2009-07-13  Gabriel Burt  <gabriel.burt@gmail.com>

	* generator/GenBase.cs: Add AppendCustom override that you can pass the
	type name in, used to include .custom for Name + Adapter and Name +
	Implementor .custom files for interface gen.

	* generator/InterfaceGen.cs: Use the new AppendCustom override for the
	Name + Adapter.custom file, and add support for including custom file for
	the Name + Implementor interface; necessary to manually implement an
	interface method.

2009-07-12  Mike Kestner  <mkestner@novell.com>

	* glib/GType.cs: add ResolveType event and TypeResolutionHandler delegate
	declarations.  This mechanism supports the lazy registration of type mappings
	by bindings.  Patch from Sebastian with minor naming tweek.  [Fixes #497667]

2009-07-12  Mike Kestner  <mkestner@novell.com>

	* generator/Parameters.cs: another owned parameter patch from Sebastian.
	[Fixes #498498]

2009-07-12  Mike Kestner  <mkestner@novell.com>

	* glib/GType.cs: fail gracefully for non-studly-case typename lookups.
	[Fixes #515453]

2009-07-12  Mike Kestner  <mkestner@novell.com>

	* sample/Makefile.am: fix for cairo conflicts related to the switch to gmcs.
	* sample/GtkDemo/Makefile.am: fix for cairo conflicts related to the switch to gmcs.

2009-07-12  Mike Kestner  <mkestner@novell.com>

	* generator/ObjectBase.cs: add CallByName overload with ownership.
	* generator/Parameters.cs: support owned by callee parameters.
	Adapted from a patch by Maarten Bosmans. [Fixes #513680]

2009-07-10  Christian Hoff  <christian_hoff@gmx.net>

	* pango/Pango.metadata: Mark "ink_rect" and "logical_rect" parameters of Get*Extends
	methods as "out".  [Fixes #510105]

2009-07-02  Christian Hoff  <christian_hoff@gmx.net>

	* configure.in.in: Target .net 2.0 profile
	* gapi-cdecl-insert: Kill. We are now using the UnmanagedFunctionPointerAttribute
	for callbacks.
	* glib/CdeclCallback.cs: Mark obsolete.
	* generator/*.cs:
	* *.custom: Use [UnmanagedFunctionPointer (CallingConvention.Cdecl)] instead of
	[GLib.CDeclCallback].

2009-06-15  Christian Hoff  <christian_hoff@gmx.net>

	* gtk/Widget.custom: Don't use [MarshalAs] for struct fields since
	that is not supported in the .net framework

2009-06-08  Christian Hoff  <christian_hoff@gmx.net>

	* generator/Signal.cs: Fix indexing of the signal arguments array for
	"out" and "ref" parameters.  [Fixes #508572]

2009-05-28  Aaron Bockover  <abockover@novell.com>

	* generator/EnumGen.cs: Fix enum generator to properly parse integer
	values with type modifier suffixes (UL, L, U), and not accidentally
	munge named values that happen to end in one of these suffixes

2009-05-18  Stephane Delcroix  <sdelcroix@novell.com>

	* configure.in.in:
	* bootstrap-generic:
	* bootstrap-2.14: check for mono >= 2.2. not that it requires it to
	build, but the generated bindings need it to run.

2009-05-13  Sebastian Dröge  <sebastian.droege@collabora.co.uk>

	* glib/Value.cs: return int object value for GType.Enum values if
	the explicit gtype is not found.  [Fixes #503060]

2009-05-13  Sebastian Dröge  <sebastian.droege@collabora.co.uk>

	* glib/ValueArray.cs: use type specific PtrToStructure marshaling to
	avoid ArgumentExceptions.  [Fixes #503467]

2009-05-13  Sebastian Dröge  <sebastian.droege@collabora.co.uk>

	* glib/Value.cs: Add support for ValueArrays inside GLib.Values.
	* glib/ValueArray.cs: Add GType property to get the ValueArray GType.
	[Fixes #503048]

2009-05-12  Mike Kestner  <mkestner@novell.com>

	* glib/Value.cs: explicit exception for unknown props.
	[Fixes #502043] Patch by Sebastian Dröge.

2009-05-12  Mike Kestner  <mkestner@novell.com>

	* glib/ValueArray.cs: make ctor(IntPtr) public for binding usage. 
	[Fixes #503189] Patch by Sebastian Dröge.

2009-05-12  Mike Kestner  <mkestner@novell.com>

	* gtk/Application.cs: add the theme initialization workaround for 
	windows.  Hopefully we can find a better solution that doesn't
	involve loading SWF.  [Fixes #471682]

2009-05-06  Mike Kestner  <mkestner@novell.com>

	* gtk/RadioMenuItem.custom: implement subclassing for group/label 
	ctor.  [Fixes #320971]

2009-05-06  Mike Kestner  <mkestner@novell.com>

	* gtk/PaperSize.custom: add static props for Letter and the other
	named papers.  [Fixes #324687]

2009-05-06  Mike Kestner  <mkestner@novell.com>

	* glib/Idle.cs: add a Remove overload for consistency.
	* glib/Timeout.cs: add a Remove overload for consistency.
	[Fixes #356138]

2009-05-06  Mike Kestner  <mkestner@novell.com>

	* generator/EnumGen.cs: support 1L long values or explicit types.

2009-05-06  Mike Kestner  <mkestner@novell.com>

	* generator/ReturnValue.cs: null-term array marshaling for vms.
	* generator/VirtualMethod.cs: use ToNative return type in native 
	callbacks.
	[Fixes #501294] Patch by Sebastian Dröge.

2009-05-06  Mike Kestner  <mkestner@novell.com>

	* generator/FieldBase.cs: mangle compound typenames for glue.
	[Fixes #501329] Patch by Sebastian Dröge.

2009-05-06  Mike Kestner  <mkestner@novell.com>

	* generator/VirtualMethod.cs: refactoring to reuse retval prop.
	[Fixes #501307] Patch by Sebastian Dröge.

2009-05-05  Mike Kestner  <mkestner@novell.com>

	* glib/GType.cs: ensure threading is initialized in cctor.
	* gtk/Application.cs: ditto.

2009-05-04  Christian Hoff  <christian_hoff@gmx.net>

	* generator/ClassField.cs: Derive from StructField.
	* generator/ObjectBase.cs: Implement validation mechanism for
	class structures. If the structure contains bitfields or fields
	of unknown types, we cannot generate it in managed code.
	* generator/GObjectVM.cs: Fall back to glue if the class structure
	cannot be generated.	[Fixes #498051]

2009-05-03  Mike Kestner  <mkestner@novell.com>

	* glib/Object.cs: revert to old LookupType behavior when Handle is
	not set.  [Fixes #500417]

2009-05-03  Stephane Delcroix  <sdelcroix@novell.com>

	* glib/Idle.cs:
	* glib/Timeout.cs: add Add() overloads taking a priority
	* glib/Makefile.am: 
	* glib/Priority.cs: Priority enum, used as argument for the new Add
	overloads

2009-05-02  Mike Kestner  <mkestner@novell.com>

	* gtk/Gtk.metadata: updates for new RecentItems prop.
	* gtk/Makefile.am: add new custom.
	* gtk/RecentManager.custom: obsolete Items prop impl.
	[Fixes #387754]

2009-05-02  Mike Kestner  <mkestner@novell.com>

	* configure.in.in: forward port of a win32 fix from 2-12-branch.

2009-05-01  Mike Kestner  <mkestner@novell.com>

	* glib/Object.cs: get gtype from instance data.
	* glib/Value.cs: use instance NativeType when initing for props.
	[Fixes #500157] Patch by Sebastian Dröge.

2009-04-28  Mike Kestner  <mkestner@novell.com>

	* generator/Parameters.cs: ref parameter marshaling fix.
	[Fixes #498472] Patch by Sebastian Dröge.

2009-04-27  Christian Hoff  <christian_hoff@gmx.net>

	* gtk/Widget.custom: Implement signal registration for the
	Activate, SettScrollAdjustments and key binding signals
	in managed code.

2009-04-25  Mike Kestner  <mkestner@novell.com>

	* generator/OpaqueGen.cs: support abstract opaque classes,
	though I have no idea why anyone would want one.
	[Fixes #494212] Revised patch from Sebastian Dröge.

2009-04-25  Mike Kestner  <mkestner@novell.com>

	* parser/gapi-fixup.cs: add remove-attr and change-node-type
	fixup rules.  [Fixes #494194]

2009-04-25  Mike Kestner  <mkestner@novell.com>

	* generator/OpaqueGen.cs: support declaring managed ifaces.
	[Fixes #494193] Revised patch from Sebastian Dröge.

2009-04-24  Stephane Delcroix  <sdelcroix@novell.com>

	* generator/Ctor.cs: Read the name attribute for constructors
	converted to static factory methods.

2009-04-21  Christian Hoff  <christian_hoff@gmx.net>

	* glib/Value.cs: Fixes for fundamental GType support. Patch
	provided by Sebastian Dröge.

2009-04-21  Christian Hoff  <christian_hoff@gmx.net>

	* gtk/Widget.custom: Deglued implementation of StyleGetProperty.

2009-04-16  Christian Hoff  <christian_hoff@gmx.net>

	* glib/Value.cs: Support for additional fundamental GTypes. Invoke
	constructor of corresponding managed type to convert a GValue into
	its managed representation and a SetGValue method to do that vice
	versa. Patch contributed by Sebastian Dröge.

2009-04-15  Andrés G. Aragoneses  <aaragoneses@novell.com>
 
        * atk/Makefile.am
        * glib/Makefile.am: take advantage of the same InternalsVisibleTo
        because the moon assemblies will be monomerged.

2009-04-15  Andrés G. Aragoneses  <aaragoneses@novell.com>

	* atk/Makefile.am
	* glib/Makefile.am
	* Makefile.include: Added new 'moonlight' target, to build with
	smcs.

2009-04-14  Christian Hoff  <christian_hoff@gmx.net>

	* gtk/Adjustment.custom: Deglued implementation of SetBounds.
	* gtk/glue/Adjustment.c: Kill.

2009-04-13  Christian Hoff  <christian_hoff@gmx.net>

	Add support for virtual methods(vm) to the generator.

	* parser/gapi2xml.pl: Generate a class_struct element with
	all members of the class structure. Dump the first (instance)
	parameter for signal and vm elements. Bump up parser version.
	* generator/GObjectVM.cs: Added. Support for GObject virtual methods.
	* generator/DefaultSignalHandler.cs: Signal specific part of vm
	generation.
	* generator/InterfaceVM.cs: New class for interface vms.
	* generator/ObjectBase.cs: Parse the class struct.

2009-04-09  Mike Kestner  <mkestner@novell.com>

	* glib/ListBase.cs: fix g_object_unref dllimport lib.
	[Fixes #493128]

2009-04-05  Christian Hoff  <christian_hoff@gmx.net>

	* gtk/Target.custom: custom implementation of TableNewFromList.
	* gtk/TargetList.custom: use Target.TableNewFromList method
	to convert the TargetList to a TargetEntry array.
	* gtk/glue/targetlist.c: deleted.

2009-03-28  Christian Hoff  <christian_hoff@gmx.net>

	* gtk/TextBuffer.custom: Use the right overload of Marshal.Copy
	[Fixes #480010]

2009-03-19  Christian Hoff  <christian_hoff@gmx.net>

	* parser/gapi2xml.pl: Introduce a "parser_version" attribute.
	* generator/GenBase.cs: Implement a property to access the
	attribute's value.

2009-03-17  Mike Kestner  <mkestner@novell.com>

	* bootstrap-generic: expose LIBTOOLIZE env variable to support
	building on mac osx with glibtoolize.  [Fixes #480559]

2009-03-17  Christian Hoff  <christian_hoff@gmx.net>

	* gdk/Property.custom: add new overloads to the Get method
	for the most common property types
	* gdk/Global.custom: Use the new overloads of Property.Get instead of glue

2009-03-16  Mike Kestner  <mkestner@novell.com>

	* gtk/NodeSelection.cs: use new Adapter prop on NodeStore.
	* gtk/NodeStore.cs: some encapsulation rework.
	* gtk/NodeView.cs: use new Adapter prop on NodeStore. new methods
	to support manipulation of the view by TreeNode, like scrolling
	and cell bounds lookups.  
	* gtk/TreeView.cs: use new Adapter prop on NodeStore.
	* doc/en/Gtk/NodeView.xml: new doc updates. 
	Patch provided by Vladimir Giszpenc.  [Fixes #480067]

2009-03-07  Mike Kestner  <mkestner@novell.com>

	* configure.in.in: add --disable-glade-sharp configure option
	to explicitly disable the conditional build.  [Fixes #423131]

2009-03-04  Christian Hoff  <christian_hoff@gmx.net>

	* gtk/NodeStore.cs: reimplement NodeStore as a managed TreeModel using GInterface implementation
	* gtk/glue/nodestore.c: kill

2009-02-27  Stephane Delcroix  <sdelcroix@novell.com>

	* gdk/Gdk.metadata:
	* gdk/PixbufFormat.custom:
	* gdk/Makefile.am: deprecate IsDisabled in favor of the Disabled
	property

2009-02-27  Stephane Delcroix  <sdelcroix@novell.com>

	* gdk/Gdk.metadata: fix GdkPixbufFormat mime_types and extensions

2009-02-24  Christian Hoff  <christian_hoff@gmx.net>

	* glib/Value.cs: Change the pad fields handling again as the 
	previous approach didn't work on Win32.   [Fixes #478578]

2009-02-17  Christian Hoff  <christian_hoff@gmx.net>

	* sample/gtk-gio/MountOperation.cs:
	* gtk/Builder.custom:
	* glib/Value.cs: Resurrect build for MS .NET Framework

2009-02-06  Christian Hoff  <christian_hoff@gmx.net>

	* gtk/Gtk.metadata: Fix TreeModel.EmitRowsReordered signature

2009-01-29  Mike Kestner  <mkestner@novell.com>

	* generator/OpaqueGen.cs: generate a finalizer for classes which
	have free or unref methods and ensure it runs on the gui thread.
	* glib/Opaque.cs:  remove finalize handling.
	Fixes a 'resurrection' issue with the previous 419777 fix.

2009-01-29  Andrés G. Aragoneses  <aaragoneses@novell.com>

	* atk/Object.custom: add binding for "focus-event" signal:
	http://library.gnome.org/devel/atk/unstable/AtkObject.html#AtkObject-focus-event

2009-01-27  Mike Kestner  <mkestner@novell.com>

	* glib/Opaque.cs:  ensure we are running on the gui thread when we
	dispose from the finalizer.  [Fixes #419777]

2009-01-26  Mike Kestner  <mkestner@novell.com>

	* glib/Value.cs:  make the pad fields a blink explicitly sized struct
	instead to avoid alignment issues on x86. [Fixes #469135]

2009-01-23  Mike Kestner  <mkestner@novell.com>

	* Makefile.include:
	* doc/Makefile.am:
	* glib/Makefile.am:
	* gtkdotnet/Makefile.am: parallel make patches from Diego Pettenò  
	and Bertrand Lorentz. [Fixes #421063]

2009-01-13  Brad Taylor  <brad@getcoded.net>

	* atk/Atk.metadata: Bind GetRunAttributes and GetDefaultAttributes as
	Atk.Attribute[] instances instead of GLib.SList. [Fixes #393565]

2009-01-13  Mike Kestner  <mkestner@novell.com>

	* gdk/glue/event.c: kill
	* gdk/glue/selection.c: kill
	* gdk/Selection.cs: hardcode the primary, secondary, and clipboard
	atom definitions instead of using glue to access their macros.
	* gdk/Event*.cs: rewrite to use layout structures instead of glue
	for field accessors.  Also enable writing for all fields.
	[Fixes #323373]

2009-01-12  Mike Kestner  <mkestner@novell.com>

	* glib/Opaque.cs (GetOpaque): return null for IntPtr.Zero.

2009-01-12  Mike Kestner  <mkestner@novell.com>

	* configure.in.in: don't hardcode CC when cross-compiling.
	* gapi-cdecl-insert: monodis support on mono.
	* Makefile.am: add a cross-compile bundling target.  The goal is to
	build a .zip which can be extracted on win32 to run candle and light,
	avoiding cygwin to produce installers.  Hopefully some day wix will
	run on linux.

2009-01-08  Mike Kestner  <mkestner@novell.com>

	* cairo/Makefile.am: use mono.snk to sign the Mono.Cairo assembly
	so that it's compatible with mono built versions.  Initial patch
	from Christian Hoff with a few tweaks.

2009-01-08  Mike Kestner  <mkestner@novell.com>

	* generator/InterfaceGen.cs: generate Adapters for consume_only ifaces
	too.  This seems unusual, but is primarily to produce at least one
	'generic' implementation of every interface and a GetObject method
	so that the marshaling code can always return an object which
	implements the interface, even if no public object wrapper exists for
	the underlying c GObject type.

2009-01-08  Mike Kestner  <mkestner@novell.com>

	* generator/ReturnValue.cs: map gfilename* list elements to type
	ListBase.FilenameString so they are marshaled correctly.
	* glib/Marshaller.cs: handle FilenameStrings in ListPtrToArray.
	* gtk/Gtk.metadata: FileChooser.GetFilenames and ListShortcutFolders
	return type mangling to avoid custom implementations.
	* gtk/FileChooser*.custom: kill manual Filenames and ShortcutFolders.

2009-01-08  Stephane Delcroix  <sdelcroix@novell.com>

	* gio/Gio.metadata: change AppInfo's CanRemoveSupportsType to a
	property.

2009-01-08  Stephane Delcroix  <sdelcroix@novell.com>

	* gio/Gio.metadata: change AppInfo's ShouldShow, SupportsFiles and 
	SupportsUris to properties.

2009-01-07  Mike Kestner  <mkestner@novell.com>

	* generator/MethodBody.cs: avoid null ref when passing null to
	destroy notified callback parameters. [Fixes #464120]

2009-01-06  Mike Kestner  <mkestner@novell.com>

	* configure.in.in: update to use mdoc.
	* doc/Makefile.am: update to use mdoc.
	* doc/gtk-sharp-docs.source: add node element to conform to new
	monodoc layout model.

2009-01-05  Andrés G. Aragoneses  <aaragoneses@novell.com>

	* GType.cs: 
	* Value.cs: Revert r122505.
	[Reasoning on #448009]

2009-01-06  Stephane Delcroix  <sdelcroix@novell.com>

	* gtk/Gtk.metadata: fix gtk_icon_theme_lookup_by_gicon return-type 
	and name.

2009-01-06  Stephane Delcroix  <sdelcroix@novell.com>

	* gtk/Gtk.metadata: fix gicon property name for CellRendererPixbuf

2009-01-06  Stephane Delcroix  <sdelcroix@novell.com>

	* gtk/Gtk.metadata: fix gicon property, getter and setter for StatusIcon

2009-01-06  Stephane Delcroix  <sdelcroix@novell.com>

	* gtk/Gtk.metadata: rename SetFromGicon to SetFromIcon and GetGicon to
	GetIcon.

2009-01-06  Stephane Delcroix  <sdelcroix@novell.com>

	* gtk/Gtk.metadata: fix the gtk_image_get_gicon signature (pass as out)

2009-01-06  Stephane Delcroix  <sdelcroix@novell.com>

	* gtk/Gtk.metadata: rename the Gicon property of GtkImage to Icon.

2009-01-05  Andrés G. Aragoneses  <aaragoneses@novell.com>

	* GType.cs: convert GType.Is to a non-static function.
	* Value.cs: track API.
	[Last cosmetic bit from #448009]

2009-01-05  Stephane Delcroix  <sdelcroix@novell.com>

	* bootstrap-2.14:
	* bootstrap-generic:
	* configure.in.in: depend on glib/gio 2.18

2009-01-04  Mike Kestner  <mkestner@novell.com>

	* *: update to 2.14.  parser support for GSEALed fields. svn build
	now uses bootstrap-2.14.  integrate gio-sharp module.  

2009-01-04  Mike Kestner  <mkestner@novell.com>

	* glib/GType.cs: fix incorrect null check noticed by Christian Hoff.
	[Fixes #463445]

2009-01-02  Mike Kestner  <mkestner@novell.com>

	* configure.in.in: clarify the Mono.Cairo summary comment.

2008-12-22  Andrés G. Aragoneses  <aaragoneses@novell.com>

	* generator/InterfaceGen.cs: track API.
	* glib/GType.cs: simplify, avoiding a static method.
	* glib/Value.cs: reuse g_type_is_a.
	[Improves fix for #448009 in r121990]

2008-12-22  Andrés G. Aragoneses  <aaragoneses@novell.com>

	* generator/InterfaceGen.cs: use the new GLib API to detect
	instances that don't implement GInterfaces.
	* glib/GType.cs: add new API for checking if an IntPtr instance
	implements a certain GType.
	[Fixes #448009]

2008-12-20  Stephane Delcroix  <sdelcroix@novell.con>

	* glib/Timeout.cs: map AddSeconds ().

2008-12-19  Mike Kestner  <mkestner@novell.com>

	* generator/BoxedGen.cs: don't generate glue dependencies.
	* glib/*.cs: remove glibsharpglue usage except thread.c.
	* glib/glue/*.c: kill all but thread.c. need glib 2.20 to kill
	it eventually.
	* pango/Attr*.cs: kill glue usage.
	* pango/glue/*.c: kill all but generated.c. it's next.
	* gtk/TreeIter.custom: kill a dumb glibsharpglue usage.

2008-12-12  Mike Kestner  <mkestner@novell.com>

	* bootstrap-2.12: tagged for 2.12.7.  Bump svn version.
	* audit/base: update base apiinfo's for 2.12 stable api.

2008-12-08  Andrés G. Aragoneses  <aaragoneses@novell.com>

	* glib/Signal.cs: Improve protection against invalid signals.

2008-12-02  Stephane Delcroix  <sdelcroix@novell.com>

	* generator/Ctor.cs:
	* generator/Method.cs:
	* generator/MethodBase.cs: refactor the Protection from Method to
	MethodBase, generate ctors with the correct protection too.

2008-12-01  Mike Kestner  <mkestner@novell.com>

	* gtk/Gtk.metadata: automarshal TreeSelection.GetSelectedRows.
	* gtk/TreeSelection.custom: kill GetSelectedRows customization.
	[Fixes #450689]

2008-12-01  Mike Kestner  <mkestner@novell.com>

	* gtk/Gtk.metadata: automarshal TreeView.Columns.
	* gtk/TreeView.custom: kill Columns customization.
	[Fixes #450685]

2008-11-28  Mike Kestner  <mkestner@novell.com>

	* generator/Signal.cs: remove ref int workaround now that we fallback
	to signal-specific marshalers for G_TYPE_POINTER using signals.
	Fixes #450119.

2008-11-26  Stephane Delcroix  <sdelcroix@novell.com>

	* gtk/Image.custom:
	* gtk/Gtk.metadata: obsolete Image.FromPixbuf, FromAnimation,
	FromFile setters in favor of already existing Pixbuf, Animation and
	File.

2008-11-26  Mike Kestner  <mkestner@novell.com>

	* bootstrap-2.12: bump svn version.
	* cairo/Makefile.am: policy config is hard-coded, not generated.

2008-11-26  Mike Kestner  <mkestner@novell.com>

	* configure.in.in: prepend CFLAGS environment setting to AC_SUBST.
	Patch from Diego Petteno.  [Fixes #443175]

2008-11-25  Mike Kestner  <mkestner@novell.com>

	* glib/Value.cs: fix for 'IntPtr as object' value construction.

2008-11-24  Andrés G. Aragoneses  <aaragoneses@novell.com>

	* atk/Makefile.am:
	* atk/SelectionAdapter.custom: new method for firing selection-changed
	( http://library.gnome.org/devel/atk/stable/AtkSelection.html#AtkSelection-selection-changed )

2008-11-21  Mike Kestner  <mkestner@novell.com>

	* glib/ManagedValue.cs: rework to ref count a ManagedValue instance
	and pass a GCHandle to it around, instead of taking out multiple
	gchandles on the managed target itself.

2008-11-21  Stephane Delcroix  <sdelcroix@novell.com>

	* glib/Global.cs: implement Global.ApplicationName for localized
	application name.

2008-11-21  Stephane Delcroix  <sdelcroix@novell.com>

	* Makefile.am:
	* glib/Format.cs: new class to map the g_format methods

2008-11-15  Mike Kestner  <mkestner@novell.com>

	* gdk/Event.cs: add EventOwnerChange to GetEvent.
	* gdk/EventOwnerChange.cs: manual subclass of Gdk.Event.
	* gdk/Gdk.metadata: hide EventOwnerChange.
	* gdk/Makefile.am: add EventOwnerChange.cs.
	* gdk/gdk-symbols.xml: add EventOwnerChange.

2008-11-15  Mike Kestner  <mkestner@novell.com>

	* gtk/Gtk.metadata: mark the SpinButton::Output signal as manually
	marshaled to avoid a compat break.  The old manual marshaler expected
	and int RetVal and the new signal closure more accurately expects a
	bool.  Since returning 1 previously worked, we need to revert to the
	int expectation, even though bool is technically more correct.

2008-11-14  Brad Taylor  <brad@getcoded.net>
	
	* glib/Object.cs: Bind g_object_notify.
	* doc/en/GLib/Object.xml: Document new API.

2008-11-05  Mike Kestner  <mkestner@novell.com>

	* atk/atk-api-2.12.raw: regen
	* gtk/gtk-api-2.12.raw: regen
	* generator/Signal.cs: reinstate old custom marshaler generation and
	generate custom marshaling when 'manual' attr is set.
	* parser/gapi2xml.pl: set manual attr on sigs that have G_TYPE_POINTER
	parameters since the generic closure can't cope with them.

2008-11-05  Mike Kestner  <mkestner@novell.com>

	* gtk/Builder.custom: #if the new API for 2.14 for now so it
	doesn't get confused as stable API yet.

2008-11-04  Mike Gorse  <mgorse@novell.com>

	* glib/PtrArray.cs, glib/glue/ptrarray.c, glib/Makefile.am,
	  glib/glue/Makefile.am, glib/gtype.cs, generator/SymbolTable.cs,
	  generator/ReturnValue.cs: Add PtrArray.
	* glib/Marshaller.cs: Add PtrArrayToArray.

	* atk/Atk.metadata: Specify GetTarget return type.

	* atk/Object.custom, atk/glue/object.c: Support overriding
	  RefRelationSet.

2008-11-03  Stephane Delcroix  <sdelcroix@novell.com>

	* gtk/Gtk.metadata:
	* gtk/StatusIcon.custom: Obsolete the duplicated properties.

2008-10-29  Mike Kestner  <mkestner@novell.com>

	* glib/Signal.cs : custom marshaling hooks
	* glib/SignalClosure.cs : support for custom marshalers.

2008-10-28  Stephane Delcroix  <sdelcroix@novell.com>

	* gtk/Gtk.Metadata: hide ConnectSignals.

	* gtk/Builder.Custom: connect the signals, and the objects.
	GetObjectRaw method: allows very neat object inheritance.

2008-10-27  Stephane Delcroix  <sdelcroix@novell.com>

	* glib/ListBase.cs: DataMarshal: create the right object for *Adapter
	list items.

2008-10-08  Mike Gorse  <mgorse@novell.com>

	* atk/Object.custom: Pass Handle in EmitChildrenChanged (fix critical)

2008-10-24  Mike Kestner  <mkestner@novell.com>

	* glib/GType.cs: register IntPtr.

2008-10-22  Peter Johanson  <peter@peterjohanson.com>

	* gtk/TreeModelAdapter.custom:
	* gtk/TreeModelFilter.custom:
	* gtk/TreeModelSort.custom:
	* gtk/TreeStore.custom: Don't trigger any gtk+ critical
	warnings when the 'rows-reodered' signal is fired.

2008-10-21  Mike Kestner  <mkestner@novell.com>

	* tagged 2.12.5.

2008-10-21  Mike Kestner  <mkestner@novell.com>

	* cairo/*: add a policy assembly for 1.0 defering to 2.0.

2008-10-13  Brad Taylor  <brad@getcoded.net>

	* Makefile.am:
	* configure.in.in:
	* gtk-sharp-2.0-lib.wxs.in:
	* gtk-sharp-2.0-dev.wxs.in: Replace version numbers in wxs files,
	  import gtk-sharp-2.0-dev.wxs.

2008-10-13  Mike Kestner  <mkestner@novell.com>

	* Makefile.am: installer target
	* gtk-sharp-2.0-lib.wxs: new installer config file

2008-10-12  Andrés G. Aragoneses  <aaragoneses@novell.com>

	Fixes BNC#426876.
	* generator/InterfaceGen.cs: throw ArgumentNullException in
	the Adapter's constructor that receives an implementor.

2008-10-09  Mike Kestner  <mkestner@novell.com>

	* cairo/*.cs: flatten source hierarchy to simplify win32 build.
	* sample/Makefile.am: fix a ref issue with local cairo.

2008-10-09  Mike Kestner  <mkestner@novell.com>

	* configure.in.in: magic for local Mono.Cairo build.
	* cairo/*: a local build of Mono.Cairo for .Net-only builds on win32.
	* */Makefile.am: use local Mono.Cairo where necessary.

2008-10-09  Mike Kestner  <mkestner@novell.com>

	* configure.in.in: kill dead config.in.
	* sample/CairoSample.cs: some dispose handling and cleanup.
	* sample/cairo-sample.exe.config.in: kill, no pinvoke needed now.
	* sample/GException.cs: GException test sample.
	* sample/GtkCairo.cs: kill, replaced by Gdk.CairoHelper.Create.
	* sample/Makefile.am: cleanup.

2008-10-08  Mike Gorse  <mgorse@novell.com>

	* Atk/Makefile.am, Atk/ObjectFactory.custom, Atk/glue/Makefile.am,
	  Atk/glue/object_factory.c: Add ObjectFactory.custom and
	  glue/object_factory.c.

2008-10-02  Mike Gorse  <mgorse@novell.com>

	* Atk/Makefile.am, Atk/Hyperlink.custom, Atk/glue/Makefile.am,
	  Atk/glue/hyperlink.c: Add Hyperlink.custom and glue/hyperlink.c.

2008-09-30  Mike Kestner  <mkestner@novell.com>

	* generator/EnumGen.cs:
	* generator/InterfaceGen.cs:
	* generator/StructBase.cs: fix build breakage in prev commit.

2008-09-30  Stephane Delcroix  <sdelcroix@novell.com>

	* generator/CallbackGen.cs:
	* generator/ClassGen.cs:
	* generator/EnumGen.cs:
	* generator/GenBase.cs:
	* generator/InterfaceGen.cs:
	* generator/Method.cs:
	* generator/OpaqueGen.cs:
	* generator/StructBase.cs:
	* generator/ObjectGen: check for the internal attribute
	* generator/Method.cs: check for the accessibility attribute;

2008-09-24  Mike Gorse  <mgorse@novell.com>

	* atk/Atk.metadata: Mark rect in GetRangeExtents as out.

2008-09-24  Mike Kestner  <mkestner@novell.com>

	* glib/GType.cs: kill the FindTypeInReferences recursive loading
	algorithm and instead do a name-based search through the references
	of loaded assemblies only.  Fixes the original bug #400595 and it
	hopefully will have fewer sideeffects that the recursive loading
	approach.

2008-09-24  Mike Kestner  <mkestner@novell.com>

	* glib/GType.cs: just fail on location null or empty instead of
	checking the assembly type.  Avoids failures on the ms runtime.

2008-09-23  Mike Kestner  <mkestner@novell.com>

	* bootstrap-2.12: bump svn version after tag.

2008-09-23  Mike Gorse <mgorse@novell.com>

	* atk/Makefile.am: add atk/atk.h to glue_includes.
	* atk/glue/Makefile.am: Compile atk/glue/generated.c.

2008-09-23  Andrés G. Aragoneses  <aaragoneses@novell.com>

	Fixes BNC#384475.
	* atk/Object.custom: Provide a new overload that receives an
	enum instead of an ulong, for a friendlier managed API.

2008-09-18  Mike Kestner  <mkestner@novell.com>

	* bootstrap-2.12: bump svn version.
	* generator/Signal.cs: add a workaround for G_TYPE_POINTER usage
	in the GtkEditable::text_inserted signal.  The signal parameter
	received by the closure will be an IntPtr, which we then have to
	use to read/write the value directly from unmanaged memory.
	[Fixes #427588]

2008-09-18  Mike Kestner  <mkestner@novell.com>

	* generator/LPGen.cs: remove WIN64LONGS hackery.
	* generator/LPUGen.cs: remove WIN64LONGS hackery.
	* generator/SymbolTable.cs: for WIN64LONGS, map them directly to
	  (u)int SimpleGens instead of using the LP generatables.

2008-09-16  Jeffrey Stedfast  <fejj@novell.com>

	* generator/Property.cs (IsDeprecated): Allow "1" or "true".

	* generator/Method.cs (.ctor): Allow "1" or "true".

	* generator/ClassBase.cs: Allow a value of "true" to work the same
	as "1" for the deprecated and abstract attributes.

	* generator/ObjectGen.cs (Generate): Remove the extra generated
	space if the class isn't abstract.

2008-09-12  Zoltan Varga  <vargaz@gmail.com>

	* glib/GType.cs (FindTypeInReferences): Put a try-catch around the assembly
	loading as failure to load a referenced assembly is not really an error.

2008-09-12  Mike Gorse <mgorse@novell.com>

	* atk/Object.custom, atk/glue/object.c: Support GetIndexInParent.

2008-09-09  Mike Kestner  <mkestner@novell.com>

	* generator/ReturnValue.cs: warning cleanup.
	* gtk/Gtk.metadata: warning cleanup.

2008-09-09  Zoltan Varga  <vargaz@gmail.com>

	* glib/GType.cs (FindTypeInReferences): Skip dynamic assemblies.

2008-09-08  Mike Kestner  <mkestner@novell.com>

	* glib/GType.cs: beef up the referenced assembly loading code to
	handle assemblies located in the same directory as the referring
	assembly.  Fixes #423450.

2008-09-05  Andrés G. Aragoneses  <aaragoneses@novell.com>

	Fixes BNC#387220.
	* glib/glue/signal.c: New glue file to call g_signal_query().
	* glib/glue/Makefile.am: Add signal.c.
	* glib/Signal.cs: check return type prior to emitting.

2008-08-28  Andrés G. Aragoneses  <aaragoneses@novell.com>

	* atk/Util.custom: unregister get_root function when the setter
	receives null. Partial fix for BNC#411444.

2008-08-27  Mike Kestner  <mkestner@novell.com>

	* generator/ManagedCallString.cs: use existing Parameters.IsHidden
	method to check for hidden user data. 

2008-08-27  Mike Kestner  <mkestner@novell.com>

	* generator/ManagedCallString.cs: revert last change.  There are a
	lot of "broken" callback sigs out there which expose user data because
	it's not in the last parameter in the list.  I don't think we can 
	reasonably make a change to hide all those at this point.  This change
	at least hides all the user_data which comes right before a GError 
	param at the end of the list.  I need to follow up with a change which
	handles data parameters in any parameter position, but allows the user
	to mark "exposed" data params for compatibility reasons.
	* generator/Parameters.cs: hide data params which are at the end of a
	list behind an error param.
	* gtk/Gtk.metadata: mark an array parameter on 
	TextBufferDeserializeFunc.

2008-08-27  Mike Kestner  <mkestner@novell.com>

	* glib/Signal.cs: multiple dispose guarding for closures.

2008-08-27  Mike Kestner  <mkestner@novell.com>

	* generator/ManagedCallString.cs: fixes for data parameter hiding
	in native to managed callback generation.

2008-08-20  Mike Kestner  <mkestner@novell.com>

	* glib/Object.cs:
	* glib/Signal.cs: fix a couple 2.0-isms.  Patch from Christian Hoff.

2008-08-20  Mike Kestner  <mkestner@novell.com>

	* bootstrap-2.12: bump svn version after tag.

2008-08-20  Mike Kestner  <mkestner@novell.com>

	* generator/ReturnValue.cs: use new ListPtrToArray marshaler for
	lists with known element types.
	* glib/Marshaller.cs: new ListPtrToArray marshaller with more
	aggressive list disposal.
	* gtk/Container.custom: remove manual Children impl.  Use Children
	in GetEnumerator instead of pinvoking directly.
	* gtk/Gtk.metadata: remove hidden attr and add element type and owned 
	for Container.GetChildren to generate it properly.

2008-08-20  Mike Kestner  <mkestner@novell.com>

	Patch from Christian Hoff fixing bug #396195.
	* generator/Property.cs: handle interface adapter values.
	* generator/InterfaceGen.cs: register the gtype so mapping occurs
	automatically for interface adapters.  New GetObject overload to
	handle already wrapped objects more efficiently.
	* glib/Value.cs: handle set_Val for interface adapter objects.

2008-08-19  Brad Taylor  <brad@getcoded.net>
	
	* atk/Object.custom: Add method to allow emission of
	  visible-data-changed signal.

	* atk/TextChangedDetail.cs: 
	* atk/TextAdapter.custom: Add method to allow emission of text-changed
	  signal.

2008-08-13  Mike Kestner  <mkestner@novell.com>

	* atk/Atk.metadata: switch Value methods to ref params since atk
	actually checks for initialized values instead of just treating it
	like uninitialized memory.  Makes for uglier API, but avoids crashes
	in unfortunate memory content scenarios.

2008-08-04  Mike Kestner  <mkestner@novell.com>

	* gtk/IconTheme.custom: elements and the list returned by
	ListIcons are owned.

2008-08-04  Mike Kestner  <mkestner@novell.com>

	* gtk/Gtk.metadata: mark IconTheme.LoadIcon return as owned.

2008-07-23  Mike Kestner  <mkestner@novell.com>

	* atk/Atk.metadata: map some out params on Atk.Value.  They
	were unusable in their existing form.

2008-07-08  Mike Kestner  <mkestner@novell.com>

	Patch from Christian Hoff with a few minor tweaks.
	* generator/CallbackGen.cs: refactor to use ManagedCallString
	and drop a ton of redundant, half-baked code.
	* generator/ManagedCallString.cs: add Unconditional setup
	method for stuff that has to happen before the try block.
	Add "drop_first" concept so it can be reused by CallbackGen
	which doesn't drop first params.
	* generator/Signal.cs: use Unconditional method for prep.
	* generator/VirtualMethod.cs: use Unconditional method for prep.
	* gtk/Gtk.metadata: mark a ref param. [Fixes #394352]
	
2008-06-28  Mike Kestner  <mkestner@novell.com>

	* gtk/Gtk.metadata: mark ListStore.Reorder array param.
	* gtk/ListStore.cs: compat obsolete method, though the old one 
	was useless.

2008-06-28  Mike Kestner  <mkestner@novell.com>

	* glib/Marshaller.cs: some 64 bit fixes for time_t marshaling
	issue found by Federico.

2008-06-28  Mike Kestner  <mkestner@novell.com>

	* gtk/TreeSelection.custom: use list marshaler to avoid O(n^2)
	copy from old custom code.  [Fixes #404669]

2008-06-28  Mike Kestner  <mkestner@novell.com>

	* gtk/Gtk.metadata: mark a const string. [Fixes #404630]

2008-06-27  Mike Kestner  <mkestner@novell.com>

	* gtk/Gtk.metadata: fix a couple out params.

2008-06-20  Mike Kestner  <mkestner@novell.com>

	* glib/Value.cs: Patch from Christian Hoff.  Support for byte and
	sbyte values.

2008-06-17  Mike Kestner  <mkestner@novell.com>

	* glib/SignalClosure.cs: post back the gvalues after the closure is
	invoked using a new Update method on GLib.Value.  This only impacts
	boxed types, since they are the only "value types" passed by ref in
	the signal marshaling environment.  We can't call set_boxed on the
	value to update it, since that allocs new memory, we need to marshal
	the updated struct out to the existing native memory address using
	g_value_get_boxed.
	* glib/Value.cs (Update): new update method for writing values to
	an existing boxed type instance instead of allocating a new native
	struct.  Fixes #398929.

2008-06-17  Mike Kestner  <mkestner@novell.com>

	* glib/GType.cs (LookupType): traversed referenced assemblies to
	find types in currently unloaded assemblies.  Fixes #400595.

2008-06-16  Andrés G. Aragoneses <aaragoneses@novell.com>

	* atk/Object.custom:
	* atk/glue/object.c:
	Simplified code for previous issue (recommendation from mkestner).

2008-06-16  Mike Kestner  <mkestner@novell.com>

	* glib/glue/object.c: fixes for object, boxed, and gtype
	property paramspec creation. Patch provided by Christian Hoff.

2008-06-09  Andrés G. Aragoneses <aaragoneses@novell.com>

	* atk/Object.custom:
	* atk/glue/object.c:
	Temporary workaround for infinite recursion issue.

2008-06-06  Andrés G. Aragoneses <aaragoneses@novell.com>

	* glib/glue/thread.c: Fix a warning.

2008-06-06  Mike Kestner  <mkestner@novell.com>

	Initial Patch submitted by Christian Hoff with some small
	style alterations and a round trip sample by me.  Supports the 
	registration of managed properties with the GType system, so 
	that things like custom cell renderers can be accessed via the
	native property system from treeview.

	* glib/glue/object.c : property registration related glue.
	* glib/Object.cs: implement managed property registration.
	* glib/PropertyAttribute.cs: add new props and ctor for managed
	property registration.
	* sample/PropertyRegistration.cs: little test app to test round-
	tripping of registered properties.
	* sample/Makefile.am: add new sample.

2008-06-06  Mike Kestner  <mkestner@novell.com>

	* atk/Object.custom: use 'as StateSet' instead of cast to avoid
	cast exceptions in the null case. Apparently it's not an exception
	any more, according to folks on #monodev.  I still prefer as for
	GetObject 'casting'.

2008-06-06  Andres G. Aragoneses <aaragoneses@novell.com> 

	* atk/Object.custom:
	* atk/glue/object.c: Implement virtual method OnRefStateSet().

2008-05-30  Mike Kestner  <mkestner@novell.com>

	* gdk/Pixbuf.custom: don't use the autogenerated PixbufDestroyNative
	delegate type since is has a byte[] parameter that blows up.

2008-05-30  Mike Kestner  <mkestner@novell.com>

	* gtk/Object.custom:
	* gtk/glue/object.c: remove the destroy override.  it doesn't work.

2008-05-28  Mike Kestner  <mkestner@novell.com>

	* gtk/Object.custom: move Dispose call to a vm override so that
	it runs after all signals and native overrides have run.
	* gtk/glue/object.c: destroy override implementation.

2008-05-28  Lluis Sanchez Gual  <lluis@novell.com>

	* gtk/Object.custom: If all destroy handlers have been
	unregistered, remove the hashtable entry since it is
	not needed anymore.

2008-05-27  Mike Kestner  <mkestner@novell.com>

	* generator/Method.cs (GenerateBody): when generating value type
	methods, we should demarshal the 'this' memory before any ref or
	out parameters in the event that someone passes 'this' as a param.
	That will ensure that an updated value coming back from the native
	side ends up in the memory location.

2008-05-22  Mike Kestner  <mkestner@novell.com>

	* gtk/Widget.custom: guard against MissingIntPtrCtorException in
	the Activate and SetScrollAdjustments funky signal VM impl. Can't
	use SignalClosure easily.  Could be reworked more cleanly at some
	point.  Or not.

2008-05-21  Mike Kestner  <mkestner@novell.com>

	* gtk/Object.custom (OnDestroyed): ensure Dispose runs even if
	no Destroyed handlers are connected.

2008-05-21  Mike Kestner  <mkestner@novell.com>

	* gtk/Application.cs (CurrentEvent): use Event.GetEvent to retrieve
	an explicit event subclass.

2008-05-15  Mike Kestner  <mkestner@novell.com>

	* kill the makefile.win32 build system.  it has been unmaintained
	for quite some time, replaced by the auto* build in cygwin.

2008-05-14  Andres G. Aragoneses <aaragoneses@novell.com> 

	* atk/Object.custom: Track API changes in GLib.Signal.
	* glib/Signal.cs: AddEmissionHook binding (for closing #386950), and
	  change API of Emit to mimic the detailed_signal pattern.
	* glib/GType.cs: GType.FromName: new wrapper for native call.
	* glib/ObjectManager.cs: Use the new FromName managed method.

2008-05-08  Mike Kestner  <mkestner@novell.com>

	* atk/atk-api-2.12.raw: reparsed.
	* gdk/gdk-api-2.12.raw: reparsed.
	* gtk/gtk-api-2.12.raw: reparsed.
	* parser/gapi2xml.pl: fixes for signal and vm order needed for 
	proper interface struct layout. [Fixes #386802]

2008-05-07  Stephane Delcroix  <sdelcroix@novell.com>

	* gtk/Object.custom: swap the event removing and destroy calls.

2008-05-07  Andres G. Aragoneses  <aaragoneses@novell.com>

	* atk/Object.custom, atk/glue/object.c: Remove unneeded
	return types (I don't  know why gcc ever let this compile...).

2008-05-06  Mike Kestner  <mkestner@novell.com>

	* glib/Object.cs: revert the connection optimization from r102349.
	It breaks under the current CellRenderer implementation which probably
	can't be reworked compatibly to take advantage of this code.
	* glib/SignalClosure.cs: use IntPtr.ToInt64 instead of (long) since
	the cast apparently has issues on bleeding edge mono.

2008-05-06  Mike Kestner  <mkestner@novell.com>

	* gtk/Gtk.metadata: mark Rc.DefaultFiles accessors as null_term_array.

2008-05-02  Mike Kestner  <mkestner@novell.com>

	* generator/GenerationInfo.cs:  refactor glue writer implementation
	so that GlueEnabled means there is a valid glue writer available.
	Avoids crashes in scenarios where an unwriteable glue path is provided
	to the generator.  Generate a glue function which scans the type
	hierarchy of an object for the most-derived unmanaged ancestor so
	that we can invoke class methods on it, avoiding infinite recursions.
	* generator/Signal.cs: revamp the default handler vm overriding 
	mechanism.  When class fields exist which can be directly hooked into,
	we now generate glue to override and chain up to unmanaged base funcs.
	This avoids some strangeness in the g_signal_override_class_closure
	and g_signal_chain_from_overridden reported in #332300 and also lays
	the groundwork for automated generation of non-signal VMs.
	* gtk/Gtk.metadata: block signal glue generation for a few types which 
	don't seem to install headers.

2008-05-02  Mike Kestner  <mkestner@novell.com>

	* glib/Object.cs: Don't bother hooking VM into the class field
	if another managed ancestor has already done so.  Add a LogFunc
	printing a stack trace for the GObject log domain if GTK_SHARP_DEBUG
	is set in the environment.  It's a bit noisy to do unconditionally.

2008-05-02  Mike Kestner  <mkestner@novell.com>

	* gtk/Object.custom: some NULL guarding in Dispose and 
	Destroy handling.

2008-05-02  Mike Kestner  <mkestner@novell.com>

	* atk/Atk.metadata: hide Global.AddGlobalEventListener.
	* atk/Global.custom: AddGlobalEventListener impl.
	* atk/Util.custom: AddGlobalEventListenerHandler prop.
	[Fixes the rest of #365437]

2008-05-01  Mike Kestner  <mkestner@novell.com>

	* gtk/gtk-api-2.12.raw: regen, removes some private printing API.
	* source/gtk-sharp-2.12-sources.xml: hide some private printing API.

2008-05-01  Mike Kestner  <mkestner@novell.com>

	* generator/InterfaceGen.cs: use CName and mangle it.  ClassFieldName
	is not guaranteed to be set now.
	* generator/Signal.cs: read ClassFieldName from the api xml.  Move 
	glue writer lookup inside the block to avoid exceptions for now.

2008-04-30  Mike Kestner  <mkestner@novell.com>

	* generator/InterfaceGen.cs:
	* generator/Signal.cs: use generic signal marshaling instead of
	generating signature specific marshaling callbacks.
	* glib/glue/closure.c: glue for new closure impl.
	* glib/Object.cs: open up a couple hashes internally. 
	* glib/Signal.cs: hook in closure based connection and expose
	EmissionHook functionality for atk usage.
	* glib/SignalClosure.cs: new generic signal marshaling mechanism.
	* glib/ToggleRef.cs: null guarding in Target and let Signal remove
	itself from hash when it disposes itself.

2008-04-30  Mike Kestner  <mkestner@novell.com>

	* parser/gapi2xml.pl: put class struct field in the signal elems.
	* atk/atk-api-2.12.raw:
	* gdk/gdk-api-2.12.raw:
	* gtk/gtk-api-2.12.raw:

2008-04-28  Mike Kestner  <mkestner@novell.com>

	* glib/Value.cs : Add GParam support and beef up the Boxed
	type marshaling to support types with New methods via reflection.

2008-04-28  Mike Kestner  <mkestner@novell.com>

	* glib/GType.cs : Add a few missing static fields.

2008-04-24  Mike Kestner  <mkestner@novell.com>

	* gdk/Window.custom (Destroy): take a normal ref for the native
	method to release, and Dispose our toggle ref.  Fixes #382186.

2008-04-24  Andres G. Aragoneses  <aaragoneses@novell.com>

	* glib/Signal.cs: Remove unneeded cast.

2008-04-24  Andres G. Aragoneses  <aaragoneses@novell.com>

	* atk/Object.custom: custom protected method for firing
	the ChildrenChanged signal.
	* glib/Signal.cs: first implementation of a managed
	method for emitting signals.

2008-04-19  Mike Kestner  <mkestner@novell.com>

	* gtk/glue/statusicon.c: fix time parameter usage.  Not even sure
	how that compiled.  I <3 C.

2008-04-17  Mike Kestner  <mkestner@novell.com>

	* atk/glue/misc.c: glue for vms and singleton setup.
	* atk/Misc.custom: add OnThreadsEnter, OnThreadsLeave, and
	SetSingletonInstance members for Bridge implementors.
	[More of #365437]

2008-04-17  Mike Kestner  <mkestner@novell.com>

	* glib/Object.cs: add Harden method to reduce the reflection 
	overhead in Gnome.Program.

2008-04-17  Mike Kestner  <mkestner@novell.com>

	* glib/ToggleRef.cs: Add a Harden method to switch to a standard
	ref and just leak it.
	* gtk/Application.cs: revert the QuitPrepare stuff since it didn't
	always work.

2008-04-17  Mike Kestner  <mkestner@novell.com>

	* gtk/TreeModelAdapter.custom:
	* gtk/TreeModelFilter.custom:
	* gtk/TreeModelSort.custom: reworked patch from Christian Hoff to
	throw NotImplementedException for SetValue methods.  Those should 
	never have been added to the interface, and it's better to throw
	an exception than have infinite recursion kill the program.
	[Fixes #379542]

2008-04-16  Mike Kestner  <mkestner@novell.com>

	* gtk/Gtk.metadata: hide PrintContext.get_CairoContext.
	* gtk/PrintContext.custom: manual get_cairo_context implementation.
	Mono.Cairo assumes it is wrapping owned references, so we need to 
	take a ref out on the returned cairo_t pointer.
	* sample/GtkDemo/DemoPrinting.cs: dispose the CairoContext in
	to be a good citizen and avoid warnings.

2008-04-15  Mike Kestner  <mkestner@novell.com>

	* generator/ReturnValue.cs: use new GLib.Opaque.OwnedCopy for owned
	opaque return values.
	* glib/Opaque.cs: introduce OwnedCopy property to support returning
	owned opaque instances from native to managed callbacks. 
	[Fixes #374641]

2008-04-15  Mike Kestner  <mkestner@novell.com>

	* gtk/Gtk.metadata: hide GtkKey_ for manual impl.
	* gtk/Key.cs: manual implementation to manage delegate wrapper
	persistence.  [Fixes #378989]

2008-04-15  Mike Kestner  <mkestner@novell.com>

	* gtk/FileSystemModel.custom: remove dead file. 

2008-04-15  Mike Kestner  <mkestner@novell.com>

	* glib/Marshaller.cs: marshal null string arrays as a null IntPtr[].
	[Fixes #378514]

2008-04-14  Mike Kestner  <mkestner@novell.com>

	* gtk/Application.cs: add QuitPrepare event for Gnome.Program usage.

2008-04-08  Marek Habersack  <mhabersack@novell.com>

	* generator/InterfaceGen.cs: added a check for null obj in the
	generated GetObject method.

2008-04-04  Mike Kestner  <mkestner@novell.com>

	* atk/Atk.metadata: add a few more owned refs.

2008-04-04  Mike Kestner  <mkestner@novell.com>

	* glib/Global.cs: renamed from Program.cs.  Program.Name is now 
	Global.ProgramName to try to avoid clashes with existing Gnome.Program
	usage.
	* gtk/Application.cs: s/GLib.Program.Name/GLib.Global.ProgramName.

2008-04-04  Mike Kestner  <mkestner@novell.com>

	* atk/Atk.metadata: markup all the Ref* methods to indicate owned refs.
	* generator/ReturnValue.cs: Add owned object ToNative handling.
	* generator/VirtualMethod.cs: Split ToNative call from managed method
	invocation to avoid duplicate calls in null checking scenarios.
	* glib/Object.cs: add OwnedHandle property for use by language binding
	code which needs to pass owned refs to native methods.

2008-04-04  Mike Kestner  <mkestner@novell.com>

	* atk/Object.custom: take out a ref on the return value of
	OnRefChild.  Also add some null guarding and default to IntPtr.Zero
	on exceptions.

2008-04-01  Mike Kestner  <mkestner@novell.com>

	* generator/InterfaceGen.cs: support "generic" interface
	implementations like those exposed by gio.  This is specifically for
	libraries which return GTypes which are not exposed by the library
	but which implement GInterfaces which are exposed by the library.

2008-03-28  Andres G. Aragoneses  <aaragoneses@novell.com>

	* atk/Object.custom: custom properties for overriding class methods.
	* atk/Makefile.am: include Object.custom.
	* atk/glue/object.c: glue to override class methods.
	* atk/glue/Makefile.am: include object.c.

2008-03-27  Andres G. Aragoneses  <aaragoneses@novell.com>

	* glib/Program.cs: Add new static class for utility property, moving
	the code to call g_set_prgname() from gtk/Application.cs to here,
	and changing return value of g_set_program_name from bool to void.
	* gtk/Application.cs: Use Program.Name as a replacement of 
	calling the native function g_set_prgname().
	* glib/Makefile.am: add Program.cs.

2008-03-21  Mike Kestner  <mkestner@novell.com>

	* bootstrap-2.12: bump svn version
	* generator/CallbackGen.cs: add dnotify support to invoker.
	Store and respond with incoming UserData params. Start using 
	__prefixed private vars to avoid collisions with parameters, 
	like the 'result' params in gio.
	* generator/ManagedCallString.cs: use new data/dnotify invoker
	ctors.
	* generator/MethodBody.cs:
	* generator/Parameters.cs: don't link "out" length params to 
	preceding strings.
	* generator/VMSignature.cs: don't require UserData to be last
	param, since it can have things like error after it.

2008-03-21  Mike Kestner  <mkestner@novell.com>

	* gtk/Gtk.metadata: s/GtkDestroyNotify/GDestroyNotify in vms too.

2008-03-14  Mike Kestner  <mkestner@novell.com>

	* pango/AttrList.custom: pass copies of the attrs to insert*
	since the list assumes ownership.
	* pango/Makefile.am: add new custom file.
	* pango/Pango.metadata: hide AttrList.Insert* for custom impl.

2008-03-12  Mike Kestner  <mkestner@novell.com>

	* glib/GType.cs: add an Init method for explicit initialization.

2008-03-04  Mike Kestner  <mkestner@novell.com>

	* bootstrap-2.12: update version to 2.12 and tag

2008-02-29  Mike Kestner  <mkestner@novell.com>

	* gdk/Event.cs: add New method for consistency with generated
	boxed types.  Will be used by GLib.Value in the future.

2008-02-29  Mike Kestner  <mkestner@novell.com>

	* generator/ReturnValue.cs: null-term array handling.
	* glib/Marshaller.cs: marshaling methods for null-term arrays.

2008-02-29  Mike Kestner  <mkestner@novell.com>

	* sample/Action.cs: qualify Action usage.
	* sample/GtkDemo/DemoApplicationWindow.cs: qualify Action usage.
	* sample/GtkDemo/DemoUIManager.cs: qualify Action usage.

2008-02-29  Mike Kestner  <mkestner@novell.com>

	* configure.in.in: atk checks and SUBSTs.
	* atk/Util.custom: custom properties for overriding class methods.
	* atk/glue/util.c: glue to override class methods.

2008-02-26  Mike Kestner  <mkestner@novell.com>

	* generator/ByRefGen.cs: fix mismatched alloc/free.

2008-02-22  Mike Kestner  <mkestner@novell.com>

	* gdk/Pixbuf.custom: add destroy notification and pin byte[] to
	avoid GC complications.  Add a couple new convenience ctors as
	well. [Fixes #362951]

2008-02-21  Mike Kestner  <mkestner@novell.com>

	* glib/Source.cs: rework proxy removal to avoid boxing profile.
	* glib/Idle.cs: save src_id in proxy to facilitate removal.
	* glib/Timeout.cs: save src_id in proxy to facilitate removal.
	[Fixes #359561]

2008-02-07  Mike Kestner  <mkestner@novell.com>

	* generator/ReturnValue.cs: null term array marshaling.
	* glib/Marshaller.cs: new marshalers for null-terminated string 
	arrays. [Fixes #342113]

2008-02-07  Mike Kestner  <mkestner@novell.com>

	* generator/Parameters.cs: fix off-by-1 in null term array marshaling.

2008-02-06  Mike Kestner  <mkestner@novell.com>

	* gdk/Gdk.metadata: mark ApplyEmbeddedOrientation return as owned.

2008-01-30  Mike Kestner  <mkestner@novell.com>

	* generator/ClassBase.cs: null check ifaces in recursive method
	and signal lookup.

2008-01-29  Mike Kestner  <mkestner@novell.com>

	* generator/ManagedCallString (Setup): use error param name instead
	of hardcoding error.

2008-01-29  Mike Kestner  <mkestner@novell.com>

	* generator/VirtualMethod (CName): mangle the name.
	* generator/SymbolTable.cs (MangleName): add 'remove' and 'foreach'
	mappings.  Should probably just get a C# keyword list and map all of
	them instead of onesy twoseys.
	Fixes for tnymail binding generation.

2008-01-24  Lluis Sanchez Gual  <lluis@novell.com>
 
	* glade/XML.custom: due to a recent Mono fix (bug #322762),
	  Type.GetFields does not return private fields from base classes
	  anymore, so the BindFields now has to go through the class
	  hierarchy to get all fields.

2008-01-23  Mike Kestner  <mkestner@novell.com>

	* bootstrap-2.12: update version and tag 2.11.91.

2008-01-22  Mike Kestner  <mkestner@novell.com>

	* glib/Object.cs: expose an internal ToggleRef prop.
	* glib/Signal.cs: use ToggleRef for lookups instead of Object. Add
	a Free method and release connections and gchandles.
	* glib/ToggleRef.cs: add signal hash and release signals on free.

2008-01-17  Mike Kestner  <mkestner@novell.com>

	* glib/Object.cs: remove ref from Objects hash prior to releasing it.

2008-01-17  Mike Kestner  <mkestner@novell.com>

	* glib/ToggleRef.cs: check for null reference in IsAlive.

2008-01-17  Mike Kestner  <mkestner@novell.com>

	* generator/Property.cs: missing Parent null check needed for direct
	GLib.Object subclasses.  Suggested by mario@gnome.cl.  [Fixes #321536]
	
2008-01-17  Mike Kestner  <mkestner@novell.com>

	* sample/Assistant.cs: new Gtk.Assistant sample.
	* sample/Makefile.am: hook in new sample.

2008-01-11  Mike Kestner  <mkestner@novell.com>

	* bootstrap-2.12: update version to 2.11.90.
	* configure.in.in: incorporate build service patch.
	* glib/glib-sharp-2.0.pc.in: add cflags for new api.xml.
	* glib/Makefile.am: install api.xml to correct dir.

2008-01-07  Mike Kestner  <mkestner@novell.com>

	* generator/SymbolTable.cs: map "unsigned long" to LPUGen.

2008-01-02  Mike Kestner  <mkestner@novell.com>

	* gtk/MoveFocusHandler.cs: obsolete event types.
	* gtk/TextView.custom: obsolete move-focus signal. 
	* gtk/Window.custom: obsolete move-focus signal. 
	Compat fixes for removal of signals from gtk+ API. [Fixes #350770]

2007-12-17  Mike Kestner  <mkestner@novell.com>

	* parser/gapi_pp.pl: parse 'typedef struct\n{' properly.

2007-12-12  Mike Kestner  <mkestner@novell.com>

	* generator/Parameters.cs: fix marshaling for ArrayCount params where
	casting is required, like gsize/size_t count parameters.

2007-12-11  Mike Kestner  <mkestner@novell.com>

	* parser/gapi2xml.pl: fix tightloop in single-line prop declarations.

2007-12-06  Mike Kestner  <mkestner@novell.com>

	* * : update to 2.12 API.

2007-12-04  Mike Kestner  <mkestner@novell.com>

	* generator/SymbolTable.cs: add goffset mapping.

2007-12-04  Mike Kestner  <mkestner@novell.com>

	* configure.in.in: check for default off_t size
	* generator/SymbolTable.cs: map off_t based on configure check.
	* generator/Makefile.am: add OFF_T_FLAGS to compile.

2007-12-03  Mark Probst  <mark.probst@gmail.com>

	* generator/SymbolTable.cs: Added "where" to the list of mangled
	names.

2007-11-29  Mike Kestner  <mkestner@novell.com>

	* parser/gapi_pp.pl: collapse embedded multiline function fields 
	to a single line.  [Fixes #344853]

2007-11-29  Mike Kestner  <mkestner@novell.com>

	* generator/MethodBase.cs: move Name stuff from subclasses.
	Check for (G|S)et<UpperCaseLetter> in new Has props.
	* generator/Method.cs:
	* generator/VirtualMethod.cs: refactor out Name stuff. Use
	new Has(G|S)etterName props.
	* pango/Pango.metadata: workaround Has/Hash collision with
	the old broken getter check. [Fixes #344954]

2007-11-29  Mike Kestner  <mkestner@novell.com>

	* glib/Signal.cs: ignore GCHandles with null targets since
	their object has been collected.  [Fixes #344250 again]

2007-11-28  Mike Kestner  <mkestner@novell.com>

	* glib/Object.cs: take ref using method param to avoid
	NREs. [Fixes #344250]

2007-11-16  Mike Kestner  <mkestner@novell.com>

	* glib/Object.cs: use toggle refs for all objects.
	de-obsolete Data hash.  Add internal Signals hash.
	* glib/Signal.cs: switch to weak gchandles.
	* glib/WeakObject.cs: kill.

2007-11-16  Eskil Bylund  <eskil@letterboxes.org>

	* gtk/ListStore.custom:
	* gtk/TreeStore.custom: Implement InsertWithValues.
	* gtk/Gtk.metadata: Deprecate the old generated method.
	[Fixes #325040]

2007-11-12  Mike Kestner  <mkestner@novell.com>

	* sample/TreeModelDemo.cs: lt/gt typo bugfix [Fixes #333653]

2007-11-12  Mike Kestner  <mkestner@novell.com>

	* generator/SymbolTable.cs: remove GCallback mapping.
	* glib/GCallback.cs: kill, bad idea.

2007-11-12  Mike Kestner  <mkestner@novell.com>

	* glib/IOChannel.cs: IOChannel wrapper implementation.
	* glib/Makefile.am: build new files.
	* glib/Marshaller.cs: new string array marshaling methods.
	* glib/Spawn.cs: g_spawn* wrapper implementation.
	* sample/SpawnTests.cs: tests for the new GLib.Process class
	and a cursory exercise of IOChannel for SpawnAsyncWithPipes.

2007-11-09  Mike Kestner  <mkestner@novell.com>

	* generator/Parameters.cs: support for null_term_array attribute.

2007-11-08  Mike Kestner  <mkestner@novell.com>

	* glib/Marshaller.cs: new null-terminated string[] marshaler from
	Mono.Unix with adaptations by Michael Hutchinson.

2007-11-02  Mike Kestner  <mkestner@novell.com>

	* glib/SList.cs:
	* glib/List.cs: add Array dup of object[] ctor since we
	are passing typed arrays from generated code.

2007-11-02  Mike Kestner  <mkestner@novell.com>

	* generator/Method.cs: need to use on the Base method name to 
	lookup complements and determine if the method is a getter or setter
	when an explicit interface method name is used.

2007-10-24  Mike Kestner  <mkestner@novell.com>

	* generator/SymbolTable.cs: mappings for GCallback and GSourceFunc.
	* glib/GCallback.cs: GCallback declaration.
	* glib/Source.cs: GSourceFunc declaration.

2007-10-24  Mike Kestner  <mkestner@novell.com>

	* generator/VirtualMethod.cs: clean up compiler warning and duplicate
	call.

2007-10-24  Mike Kestner  <mkestner@novell.com>

	* generator/InterfaceGen.cs: generate an Implementor prop on the
	adapters to obtain the underlying object.

2007-10-22  Mike Kestner  <mkestner@novell.com>

	* configure.in.in: add a win64 check and a compiler define for
	handling win64 32bit longs.
	* generator/LPGen.cs: use int to marshal on win64.
	* generator/LPUGen.cs: use uint to marshal on win64.
	* generator/SymbolTable.cs: remove fixme.

2007-10-16  Mike Kestner  <mkestner@novell.com>

	* gtk/CellRenderer.custom : marshal GTypes as IntPtr like the
	generator does.
	* gtk/Container.custom : ditto.  [Fixes comment #8 on 327058]

2007-10-15  Mike Kestner  <mkestner@novell.com>

	* generator/InterfaceGen.cs : gen Handle props as overrides.
	* glib/GInterfaceAdapter.cs : add abstract Handle prop.
	* glib/Value.cs: add ctor (GInterfaceAdapter).

2007-10-04  Peter Johanson  <peter@peterjohanson.com>

	* gtk/Gtk.metadata: Make the public fields on Gtk.Rcstyle writeable.

2007-10-04  Mike Kestner  <mkestner@novell.com>

	* glib/DestroyNotify.cs: add CDeclCallback to the delegate.
	* glib/Signal.cs: use DestroyHelper.
	* gdk/Input.custom: use DestroyHelper.
	* gtk/Quit.custom: remove new on DestroyHelper handler.
	* gtk/TreeModelFilter.custom: remove new on DestroyHelper handler.
	* gtk/TreeViewColumn.custom: remove new on DestroyHelper handler.

2007-10-02  Mike Kestner  <mkestner@novell.com>

	* generator/*.cs: implement the interfaces on the adapters too.
	Generate an Implementor interface for users which exposes the 
	methods to implement.  Register based on the Implementor sub-iface.
	* gtk/*Adapter.custom: custom implementations for the custom
	interface members.
	* gtk/TreeIter.custom: make UserData public.
	* sample/TreeModelDemo.cs: sample for implementing a TreeModel
	interface.

2007-10-01  Mike Kestner  <mkestner@novell.com>

	* generator/OpaqueGen.cs: disable Copy generation fix until I can
	figure out why it breaks DnD.

2007-10-01  Mike Kestner  <mkestner@novell.com>

	* gtk/TreePath.custom: use Marshal.Copy to copy indices array.

2007-10-01  Mike Kestner  <mkestner@novell.com>

	* glib/Object.cs: add ctor (), which invokes CreateNativeObject
	to allow direct subclasses that do all the registration automatically.

2007-09-21  Mike Kestner  <mkestner@novell.com>

	* generator/*.cs: add DefaultValue prop for obtaining a
	sane value when we need to return a value but something bad has 
	happened such that we can't get a real value.  Needed for iface
	signal marshaling, among other places we're partially working 
	around it now.

2007-09-19  Mike Kestner  <mkestner@novell.com>

	* generator/InterfaceGen.cs: remove some dead code from a previous
	implementation attempt.

2007-09-19  Mike Kestner  <mkestner@novell.com>

	* generator/VirtualMethod.cs: refactor delegate generation into
	GenerateCallback and add [CDeclCallback] which was missing.
	* generator/InterfaceGen.cs: kill GenerateDelegates.  They are now
	generated by VirtualMethod.GenerateCallback.

2007-09-14  Mike Kestner  <mkestner@novell.com>

	* generator/CallbackGen.cs (GenInvoker): null check the sig field
	and set it up.  This can happen when generating the marshaling types
	from dependent libraries instead of via the Generate method. 

2007-09-11  Mike Kestner  <mkestner@novell.com>

	* gtk/Gtk.metadata: virtual_method rules for GInterface generation.
	* generator/ReturnValue.cs (ToNative): new method for the virtual
	method generation.
	* generator/Parameters.cs (FromNative): null guarding.
	* generator/ManagedCallString.cs: rework for interface method
	generation including callback and error param support.
	* generator/CallbackGen.cs: Invoker support. new class that deals
	with persistence of native and wrapper delegates in native to managed
	callback method signatures.
	* generator/VirtualMethod.cs: support for generation of interface
	methods, and all the funky parameters that come with that.
	* generator/InterfaceGen.cs: Fill out the adapter implementation.
	* generator/MethodBody.cs: Initialize overload. Extend ThrowsException
	to support GError outside the last parameter slot.
	* glib/GInterfaceAttribute.cs: New attribute to mark interfaces and
	obtain adapter type.
	* glib/Object.cs (AddInterfaces): interface registration method.
	* glib/GInterfaceAdapter.cs: New abstract class for interface
	adapter generation.
	* glib/Makefile.am: add new files.

2007-09-11  Mike Kestner  <mkestner@novell.com>
  
 	* gtk/Object.custom (Destroy): add a null check to avoid 
	Gtk criticals.  The destroy case seems to be problematic with
	a bunch of existing code, so this turns it into a noop.

2007-09-06  Mike Kestner  <mkestner@novell.com>
  
 	* AssemblyInfo.cs.in : add IgnoreClassInitializers attr to all.
 	* generator/ObjectGen.cs : add custom-attr generation for objects.
 	* glib/ClassInitializerAttribute.cs : obsolete
 	* glib/IgnoreClassInitializersAttribute.cs : new assembly attr
 	to avoid a blind GetMethods reflection.
 	* glib/Makefile.am : add files
 	* glib/TypeInitializerAttribute.cs : new attr to specify init
 	method to be run at type registration.
 	* gtk/Widget.custom : remove the ClassInitializerAttr.
 	* gtk/Gtk.metadata : add a custom-attr node to GtkWidget.
 	* sample/Subclass.cs : use the IgnoreClassInitializers attr.
 	
2007-08-14  Mike Kestner  <mkestner@novell.com>

	* gtk/Gtk.metadata : kill a few "new" warnings in FileChooser 
	implementors.

2007-08-14  Mike Kestner  <mkestner@novell.com>

	* glib/ListBase.cs : add AllocNativeElement method and an
	Append (object) method that uses it.
	* glib/List.cs : add object[] ctor using new append method.
	* glib/SList.cs : add object[] ctor using new append method.
	These are needed to return G(S)List* values as virtual method
	return values.

2007-08-13  Mike Kestner  <mkestner@novell.com>

	* generator/MethodBody.cs : finally kill the s/out ref/ref/ hack.
	* generator/Parameter.cs : ditto.

2007-08-13  Mike Kestner  <mkestner@novell.com>

	* generator/ByRefGen.cs : implement IManualMarshaler.
	* generator/Parameter.cs : use StructParameter for ByRefGen.

2007-08-13  Mike Kestner  <mkestner@novell.com>

	* generator/*.cs : switch to IntPtr marshaling for struct types
	in the managed to native direction.
	* gtk/*.custom : adjust to new gapi struct pinvoke sigs.

2007-08-01  Mike Kestner  <mkestner@novell.com>

	* generator/CallbackGen.cs : use Parameters.NativeCallbackSignature.
	* generator/Ctor.cs : use Parameters.ImportSignature prop.
	* generator/ImportSignature.cs : kill
	* generator/MethodBase.cs : kill ImportSignature prop.
	* generator/Method.cs : use Parameters.ImportSignature prop.
	* generator/NativeCallbackSignature.cs : kill
	* generator/Parameters.cs : add ImportSig and NativeCallbackSig.
	* generator/Signal.cs : use Parameters.NativeCallbackSignature prop.
	* generator/VirtualMethod.cs : use Parameters.ImportSignature prop.

2007-07-31  Mike Kestner  <mkestner@novell.com>

	* generator/Ctor.cs : Validate before generating and adjust protection
	on a couple private methods.
	* generator/Parameters.cs : remove unused var to kill warning.

2007-07-30  Mike Kestner  <mkestner@novell.com>

	* generator/MethodBody.cs : refactor finish logic into parameter.
	* generator/Parameters.cs : refactor finish logic into parameter and
	fix some failures to marshal ref params post call.

2007-07-27  Mike Kestner  <mkestner@novell.com>

	* generator/OpaqueGen.cs : only generate Copy override for methods
	with no parameters.  Fixes a gnome-sharp build problem.

2007-07-26  Mike Kestner  <mkestner@novell.com>

	* parser/gapi2xml.pl : beef up error message for signal vm parse.
	[Fixes #82149]

2007-07-24  Mike Kestner  <mkestner@novell.com>

	* bootstrap-2.10 : bump version and tag 2.10.2. 

2007-07-20  Mike Kestner  <mkestner@novell.com>

	* gtk/Calendar.custom : workaround invalid states in widget when
	raising month_changed signals.  [Fixes #78524]

2007-07-20  Mike Kestner  <mkestner@novell.com>

	* gtk/gtk-api-2.10.raw : refresh.
	* parser/gapi_pp.pl : combine lines that end in '\' before sending
	them through the pattern matching.  [Fixes #79214]

2007-07-19  Mike Kestner  <mkestner@novell.com>

	* generator/OpaqueGen.cs : override the new Copy vm if a Copy method
	exists for the type.
	* glib/Opaque.cs : add a virtual method to allow subclasses with
	Copy methods to override.  Use the method in GetOpaque for unowned
	instantiations to try to obtain an owned instance. [Fixes #82037]
	
2007-07-18  Mike Kestner  <mkestner@novell.com>

	* gdk/EventExpose.cs : return a pointer from the get_area glue
	pinvoke to avoid VS crashes on win32.
	* gdk/glue/event.c : return a GdkRectangle* to avoid stack imbalance
	on VS debugger.  [Fixes #82098]

2007-07-17  Mike Kestner  <mkestner@novell.com>

	* gtk/Gtk.metadata : map TreeModelFilter ctor param to prop to
	avoid subclass ctor exception. [Fixes #82115]

2007-07-17  Mike Kestner  <mkestner@novell.com>

	* generator/CallbackGen.cs : make GError** signatures fatal to
	avoid compilation problem in gmime-sharp.

2007-07-12  Mike Kestner  <mkestner@novell.com>

	* generator/StructBase.cs : use typeof to pass type to PtrToStruct
	to avoid an instantiation and method call.  Duh.

2007-07-10  Mike Kestner  <mkestner@novell.com>

	* generator/ImportSignature.cs : use Parameter.NativeSignature 
	prop and refactor out some GError handling.
	* generator/MethodBody.cs : Refactor logic into Parameters.
	* generator/Parameters.cs : add ArrayParameter, ArrayCountPair, and
	ErrorParameter subclasses to refactor spaghetti code in MethodBody.

2007-07-03  Mike Kestner  <mkestner@novell.com>

	* bootstrap-generic : use automake --foreign to make automake-1.10
	happy with gnu make function usage.

2007-06-25  Mike Kestner  <mkestner@novell.com>

	* gtk/StatusIcon.custom : present_icon is in the glue lib.

2007-06-25  Ankit Jain  <jankit@novell.com>

	* gdk/Gdk.metadata : hide Property.Get for manual impl.
	* gdk/Property.custom : manually marshal the data param in Get.

2007-06-19  Mike Kestner  <mkestner@novell.com>

	* gdk/Property.custom : obsolete compat overload for Change().
	* gdk/Gdk.metadata : array attr for Property.Change ().
	* gdk/Makefile.am : add custom file.

2007-06-18  Mike Kestner  <mkestner@novell.com>

	* bootstrap-2.10 : bump version and tag.

2007-06-05  Mike Kestner  <mkestner@novell.com>

	* glib/ManagedValue.cs (ReleaseWrapper): new method.
	* glib/Value.cs : release the ManagedValue wrapper to avoid leaks.
	[Fixes #81799]

2007-05-03  Wade Berrier  <wberrier@novell.com>

	* generator/gapi2-codegen.in:
	* parser/gapi2-fixup.in:
	* parser/gapi2-parser.in:
	Don't use 'which' anymore, as it doesn't work in all caes (ie: when symlinks are
	in the way)

2007-04-28  Mike Kestner  <mkestner@novell.com>

	* generator/NativeCallbackSignature.cs :
	* generator/Signal.cs : don't use ref IntPtr in native callback sigs
	for struct parameters.  Use IntPtr and StructureToPtr.  Fixes the 
	layout issues in MD introduced by the structure marshaling rework.

2007-04-24  Aaron Bockover  <abockover@novell.com>

	* gtk/Widget.custom (StyleGetProperty): return null if 
	gtksharp_widget_style_get_property returns FALSE (property 
	doesn't exist) [Fixes #81445]

	* gtk/glue/widget.c (gtksharp_widget_style_get_property): check 
	return of gtk_widget_class_find_style_property for NULL; function now
	returns TRUE if spec is not NULL, FALSE otherwise

2007-04-23  Brad Taylor  <brad@getcoded.net>
	
	* gtk/TreePath.custom: Override Equals and compare based upon the
	  underlying indicies, instead of the object reference.
	  [Fixes #81398]

2007-04-23  Mike Kestner  <mkestner@novell.com>

	* glib/Value.cs : add support for accessing generic struct boxed types
	as objects.  [Fixes #79224]

2007-04-20  Mike Kestner  <mkestner@novell.com>

	* generator/CallbackGen.cs : switch to NativeCallbackSignature.
	* generator/GenBase.cs : add NativeCallbackType member.
	* generator/IGeneratable.cs : add NativeCallbackType member.
	* generator/ManagedCallString.cs : add guarded post call struct
	marshaling back to the native struct.
	* generator/NativeCallbackSignature.cs : new parallel to ImportSignature
	but using NativeCallbackType instead of MarshalType.
	* generator/Signal.cs : switch vm and sig marshaler callbacks to 
	NativeCallbackSignature. Perform guarding post call struct marshaling
	back to the native struct.
	* generator/Parameters.cs : add NativeCallbackType member.
	* generator/SimpleBase.cs : add NativeCallbackType member.
	* generator/StructBase.cs : add NativeCallbackType member using IntPtr
	to support NULL handling.
	* gtk/NodeCellDataFunc.cs : update native marshaler sig.

2007-04-17  Mike Kestner  <mkestner@novell.com>

	* gtk/Gtk.metadata : hide TreeModel.RowsReordered signal so we can do
	a correct implementation while maintaining compat with the existing 
	broken "NewOrder" parameter.
	* gtk/ListStore.custom : manual RowsReordered signal implementation.
	* gtk/RowsReorderedHandler.cs : manual implementation for preserve compat
	in the Args class. Adds NewChildOrder to replace the broken ChildOrder.
	* gtk/TreeModel.custom : manual RowsReordered signal declaration.
	* gtk/TreeModelFilter.custom : manual RowsReordered signal implementation.
	* gtk/TreeModelSort.custom : manual RowsReordered signal implementation.
	* gtk/TreeStore.custom : manual RowsReordered signal implementation.
	[Fixes #78512]

2007-04-17  Ben Motmans  <ben.motmans@gmail.com>

	* doc/en/Gtk/Widget.xml:
	removed documentation for internal method

2007-04-17  Ben Motmans  <ben.motmans@gmail.com>

	* gtk/Widget.custom:
	StyleGetPropertyValue that returns a GLib.Value when StyleGetProperty cannot automatically cast the GLib.Value (eg: Gdk.Color)
	[Fixes #81253]
	* doc/en/Gtk/Widget.xml:
	Documentation for the new StyleGetPropertyValue method and improved documentation for StyleGetProperty
	* gtk/TreeView.custom:
	OddRowColor and EvenRowColor properties
	* doc/en/Gtk/TreeView.xml:
	documentation for OddRowColor and EvenRowColor properties

2007-04-12  Brad Taylor  <brad@getcoded.net>
	
	* doc/en/Gtk/Widget.xml: Documentation for OnActivate, but only because
	Mike asked so nicely.

2007-04-12  Mike Kestner  <mkestner@novell.com>

	* glib/Object.cs : do the Timeout switch in the finalizer
	instead of in Dispose, where it can cause problems if people
	override Dispose.
	* generator/ObjectGen.cs : don't generate finalizers for every
	subclass, just rely on the ~GLib.Object implementation.

2007-04-12  Mike Kestner  <mkestner@novell.com>

	* glib/Idle.cs :
	* glib/Timeout.cs : don't add the CDeclCallback attr to the
	public delegate type, since it causes a MissingMethod exception
	on win32.

2007-04-09  Brad Taylor  <brad@getcoded.net>

	* gtk/glue/widget.c:
	* gtk/Widget.custom: Bind activate_signal in GtkWidgetClass.
	[Fixes #81343]

2007-04-05  Mike Kestner  <mkestner@novell.com>

	* glib/ToggleRef.cs : flush a few leftover changes from a
	ToggleRef refinement.

2007-03-15  Mike Kestner  <mkestner@novell.com>

	* generator/CallbackGen.cs : generate try/catch blocks for
	native to managed marshallers.  [Fixes the rest of #80516]

2007-03-08  Mike Kestner  <mkestner@novell.com>

	* glib/Signal.cs : guard against NULL gchandles.
	* gdk/Input.custom : add try/catch blocks to native callbacks.
	* gtk/*.custom : ditto
	* gtk/NodeStore.cs : ditto

2007-03-08  Mike Kestner  <mkestner@novell.com>

	* glib/*.cs : add try/catch blocks to native callback
	methods for DestroyNotify, Copy/Free, and ToggleNotify handlers.  
	Raise UnhandledException events on catches.  

2007-03-06  Mike Kestner  <mkestner@novell.com>

	* generator/Signal.cs : add try/catch blocks to native callback
	virtual method delegate too.

2007-03-06  Mike Kestner  <mkestner@novell.com>

	* generator/Signal.cs : add try/catch blocks to native callback
	delegates so that exceptions are not propagated across the native
	boundary.  Now raises GLib.ExceptionManager.UnhandledException.
	* glib/ExceptionManager.cs : new class with UnhandledException
	event and a static method to raise it.
	* glib/Signal.cs : wrap the generic EventHandler callback delegate
	with try/catch blocks and raise the UnhandledException event.

2007-03-05  Mike Kestner  <mkestner@novell.com>

	* gtk/Application.custom : set prgname in Init methods so
	that WM_CLASS is more appropriate.  Programs using Gnome.Program
	already get a nice prgname, but Gtk.Application.Init apps were
	getting a path instead of a filename without extension.

2007-03-01  Brad Taylor  <brad@getcoded.net>

	* gtk/Dialog.custom: obsolete old, improperly bound
	  SetAlternateButtonOrderFromArray.
	* gtk/Gtk.metadata: fix binding of the
	  gtk_dialog_set_alternate_button_order_from_array. [Fixes #80706]

2007-03-01  Mike Kestner  <mkestner@novell.com>

	* generator/MethodBody.cs : handle set method conversion to 
	property for array parameters with preceding count params.

2007-02-21  Peter Johanson  <peter@peterjohanson.com>

	* gtk/glue/cellrenderer.c: revert to previous implementation of
	_base_ functions to maintain backward-stability. [Fixes #77949]

2007-02-16  Peter Johanson  <peter@peterjohanson.com>

	* gtk/CellRenderer*.custom: new custom overrides for VMs.
	* gtk/glue/cellrenderer.c: add GType parameters to the invoke methods
	so we can identify the correct vtable to invoke from.

2007-02-16  Mike Kestner  <mkestner@novell.com>

	* glib/Object.cs : switch to ToggleRefs for all items created with
	CreateNativeObject.  This gets all managed subclasses, with a little
	overhang into simple wrappers.
	* glib/ToggleRef.cs : new class to manage the weak to strong ref 
	transitions as a native object flips between shared and unshared
	ownership.
	* gtk/Object.custom : revamp of the Destroyed signal handling. 
	* gtk/Gtk.metadata : hide destroy signal so we can deal with it 
	manually. [Fixes the reopen note of #72018.]

2007-02-03  Mike Kestner  <mkestner@novell.com>

	* gtk/StatusIcon.custom : obsolete overload for backcompat on
	GetGeometry, and custom PresentMenu method to invoke new glue.
	* gtk/glue/statusicon.c : glue method to connect to gtk_menu_popup
	without having to go across the native/managed boundary multiple
	times using gtk_status_icon_position_menu wrapper.
	[Fixes #79500]

2007-02-02  Brad Taylor  <brad@getcoded.net>

	* gdk/Gdk.metadata: fix incorrect ref_count with Pixbuf's
	  RotateSimple method.

2007-01-09  Mike Kestner  <mkestner@novell.com>

	* generator/CallbackGen.cs : add PersistUntilCalled method generation
	to the wrapper class.  Holds a GCHandle for the wrapper which is Freed
	when the delegate is invoked.
	* generator/MethodBody.cs : add "async" case for delegate scope.  Use
	this scope to identify a callback parameter that needs to persist 
	until the native side calls back.  Only valid for single-invoke
	callbacks.
	* gtk/Gtk.metadata : mark Print.RunPageSetupDialogAsync done_cb param
	with the new async scope.

2007-01-09  Mike Kestner  <mkestner@novell.com>

	* sample/GtkDemo/DemoPixbuf.cs : use Marshal.Copy properly
	to avoid expose crashes. Revised from patch provided by
	Fabian Sturm.  [#78262]

2007-01-09  Mike Kestner  <mkestner@novell.com>

	* sample/GtkDemo/DemoIconView.cs : use Gtk.Stock icons to avoid
	crashes when the previous gnome icons aren't installed. [#78212]

2007-01-09  Bart Deleye  <bart.deleye@gmail.com>

	* parser/gapi_pp.pl : regex fix for tinymail parse.

2007-01-09  Brad Taylor  <brad@getcoded.net>
	
	* gdk/Pixbuf.custom: Properly dispose of PixbufLoaders when we're done
	  with them.

2006-12-28  Brad Taylor  <brad@getcoded.net>

	* sample/GtkDemo/Makefile.am:
	* sample/GtkDemo/DemoPrinting.cs: Fix build on Win32.

2006-08-21  Mike Kestner  <mkestner@novell.com>

	* bootstrap-2.10 : tag and bump version to 2.10.0. 

2006-08-10  Mikkel Kruse Johnsen <mikkel@linet.dk>

	* sample/GtkDemo/DemoPrinting.cs : new Gtk.Print sample.
	* sample/GtkDemo/Makefile.am : build new source.

2006-08-10  Mike Kestner  <mkestner@novell.com>

	* pango/Pango.metadata : add library attr to pango_cairo methods. 
	* pango/pango-sharp.dll.config.in : add libpangocairo mapping.

2006-08-10  Mike Kestner  <mkestner@novell.com>

	* pango/Pango.metadata : some pango_cairo fixup. 
	* pango/pango-api-2.10.raw : regen with pangocairo.h API.
	* sources/gtk-sharp-2.10-sources.xml : don't exclude pangocairo.h.

2006-08-10  Mike Kestner  <mkestner@novell.com>

	* parser/gapi2xml.pl : class parsing regex needs to handle protected
	comments too.

2006-08-07  Mike Kestner  <mkestner@novell.com>

	* gtk/Gtk.metadata : remainder of new API massaging for existing 
	types.
	* gtk/Printer.custom : new static method.
	* gtk/TextBuffer.custom : serialization API implementations.

2006-08-07  Mike Kestner  <mkestner@novell.com>

	* gtk/Gtk.metadata : mark an out param in Style.LookupColor. 
	Some tweaks to duplicated label api.

2006-08-07  Mike Kestner  <mkestner@novell.com>

	* gtk/Gtk.metadata : markup for new Clipboard Rich text funcs. 
	* gtk/Clipboard.custom : manually implement RequestRichText and
	WaitForRichText methods to deal with array marshaling and delegate
	persistence.

2006-08-04  Mike Kestner  <mkestner@novell.com>

	* gtk/Gtk.metadata : a few tweaks to the 2.10 API found in doc/
	audit pass.

2006-08-04  Mike Kestner  <mkestner@novell.com>

	* gdk/Screen.custom : manually implement FontOptions property so
	we can use reflection to access the internal Mono.Cairo ctor.
	* gdk/Gdk.metadata : list marshaling, method-to-property renames,
	and some hides form manual implementation.  Hide 
	gdk_atom_intern_static_string wrapper since it is pointless outside
	the context of C code.

2006-08-03  Mike Kestner  <mkestner@novell.com>

	* pango/pango-api-2.10.raw : regen for 1.12.x
	* sources/Makefile.am : use pango-1.12.3 for parse
	* sources/gtk-sharp-2.10-sources.xml : ditto

2006-08-01  Mike Kestner  <mkestner@novell.com>

	* gtk/Gtk.metadata : fix a couple of compat breaks against 2.8.
	* gtk/TreeModelFilter.cs : hand implement ConvertChildIterToIter
	to match the 2.8 version of the method.

2006-08-01  Mike Kestner  <mkestner@novell.com>

	* gtk/gtk-api-2.10.raw : reparsed
	* parser/gapi_pp.pl : put a newline after G_DEFINE_TYPE macros
	on the output and do a next if we shouldn't fall out of the 
	branch.

2006-07-29  Alp Toker  <alp@atoker.com>

	* sample/GstPlayer.cs: Remove the 2002 GStreamer sample. gst-sharp has
	long since found a new home.

2006-07-28  Mike Kestner  <mkestner@novell.com>

	* *: huge amounts of surgery to split off gnome-sharp module.
	Clean out all the gnome related stuff from the auto* files.
	make distcheck works on the leaner-meaner gtk-sharp module.

2006-07-27  Mike Kestner  <mkestner@novell.com>

	* bootstrap*: kill the 2.4/2.6/2.8 straps, they are on a 
	branch now. update 2.10 strap for new apis.
	* sources/Makefile.am : parse 2.16 sources for gnome libs.
	* sources/gtk-sharp-2.10-sources.xml : ditto.
	* parser/gapi-parser.cs : explicitly use an indented XML writer.
	* gnomevfs/gnome-vfs-api-2.16.raw: regen
	* gnomevfs/Gnomevfs.metadata: some build fixes
	* gnome/gnome-api-2.16.raw: regen
	* gnome/Gnome.metadata: some build fixes
	* sample/PrintSample.cs: remove new Gtk/Gnome ambiguities.

2006-07-27  Mike Kestner  <mkestner@novell.com>

	* gnome/PanelApplet.custom : hold UIVerbs in SetupMenu so the 
	callback delegates don't get GC'd.

2006-07-15  Mike Kestner  <mkestner@novell.com>

	* parser/gapi2xml.pl : regex fix needed for vfs 2.15.3 parse.

2006-07-15  Mike Kestner  <mkestner@novell.com>

	* sources/gtk-sharp-2.10-sources.xml : update to gnome 2.15.4
	sources for the 2.10 api build.
	* sources/Makefile.am : ditto.

2006-07-14  Mike Kestner  <mkestner@novell.com>

	* sources/gtk-sharp-2.10-sources.xml : update to gtk+-2.10.0 
	and pango-1.13.3
	* sources/Makefile.am : ditto.
	* gtk/Gtk.metadata : some hides and renames to fix build.
	* gdk/gdk-api-2.10.raw : refresh.
	* gtk/gtk-api-2.10.raw : refresh.
	* pango/pango-api-2.10.raw : refresh.

2006-07-14  Mike Kestner  <mkestner@novell.com>

	* sample/gnomevfs/Makefile.am : build fix for !ENABLE_GNOMEVFS.

2006-06-21 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* glade/HandlerNotFoundExeception.cs:
	* glade/XML.custom: provide a better error when the signature of a
	handler does not match the one of the event.

2006-05-10  Mike Kestner  <mkestner@novell.com>

	* bootstrap-2.10 : strap for the new 2.9.0 API.
	* generator/SymbolTable.cs : add GLib.InitiallyUnowned mapping.
	* glib/InitiallyUnowned.cs : new floating class "stub".
	* glib/Makefile.am : build new class.
	* gdk/gdk-api-2.10.raw: parse from 2.9.0
	* gtk/Gtk.metadata: cleanup conflicts in 2.10 API.
	* gtk/gtk-api-2.10.raw: parse from 2.9.0
	* pango/pango-api-2.10.raw: parse from 1.11.99
	* sources/Makefile.am : 2.10 parse setup and api-2.10 
	* sources/gtk_tree_model_signal_fix-2.10.patch : 2.10 patch.
	* sources/gtk-sharp-2.10-sources.xml : parse rules for 2.10

2006-05-08  Joe Shaw  <joeshaw@novell.com>

	* glib/ValueArray.cs: Don't immediately free ValueArrays; queue
	them up to be freed in the main thread by using a Timeout.  This
	fixes SMP deadlocks when the GValues contained therein aren't
	threadsafe (like GDK resources).  Fixes Novell bug #168650.

2006-05-04  Peter Johanson  <peter@peterjohanson.com>

	* gtk/glue/cellrenderer.c: Revert r59683, as it causes issues for
	overrides calling base.GetSize (), etc.

2006-05-03  Mike Kestner  <mkestner@novell.com>

	* gdk/Drawable.custom : remove manual DrawPoints impl.
	* gdk/Gdk.metadata : properly mark array and count params for
	Drawable.DrawPoints.

2006-05-02  Zac Bowling  <zac@zacbowling.com>

	* docs/en/Gdk/Drawable.xml
	* gdk/Drawable.custom
	* gdk/Gdk.metadata : Fix Drawable.DrawPoints points param signature.

2006-04-20  Peter Johanson  <peter@peterjohanson.com>

	* gtk/glue/cellrenderer.c: Make GetSize, Render, etc behave correctly
	for all cases. Fixes #77949.

2006-04-15  Zac Bowling	 <zac@zacbowling.com>
	
	* README.generator : Updated with link to GAPI guide on Wiki

2006-03-27  Mike Kestner  <mkestner@novell.com>

	* gnomevfs/MimeType.cs : remove string from all pinvoke sigs. now
	adheres to the const/non-const conventions specified in the vfs
	headers.  Fixes #77534.

2006-03-27  Mike Kestner  <mkestner@novell.com>

	* glib/ListBase.cs : deal with ownership of Opaque elements.
	* glib/Marshaller.cs : add a hack to deal with Opaque ownership in
	ListToArray marshaling.

2006-02-28  Mike Kestner  <mkestner@novell.com>

	* bootstrap-2.* : update for 2.x.2 releases.

2006-02-28  Mike Kestner  <mkestner@novell.com>

	* pango/Context.custom : use ReadIntPtr (ptr, offset) for 64 bit.
	* pango/FontFamily.custom : use ReadIntPtr (ptr, offset) for 64 bit.
	* pango/FontMap.custom : use ReadIntPtr (ptr, offset) for 64 bit.
	* pango/Layout.custom : use ReadIntPtr (ptr, offset) for 64 bit.

2006-02-28  Mike Kestner  <mkestner@novell.com>

	* gdk/Region.custom : 64 bit fix for ptr arithmetic. [Fixes #77658]

Tue Feb 28 09:44:23 CET 2006 Paolo Molaro <lupus@ximian.com>

	* gdk/Pixbuf.custom: use correct type for buffer_size in
	gdk_pixbuf_save_to_bufferv() (fixes bug# 77662).

2006-02-16  Mike Kestner  <mkestner@novell.com>

	* sample/gnomevfs/Makefile.am : make TestXfer conditional to a mono
	build since it uses Mono.GetOptions.  [Fixes #77497]

2006-02-03  Mike Kestner  <mkestner@novell.com>

	* sample/gnomevfs/TestVolume.cs : remove C# 2.0 usage.

2006-02-03  Mike Kestner  <mkestner@novell.com>

	* bootstrap-2.* : update for 2.x.1 releases.

2006-02-03  Mike Kestner  <mkestner@novell.com>

	* generator/Signal.cs : virtual method enum retvals must be case to 
	Enum before casting to their ultimate type.  Also dispose retval 
	gvalues to avoid reference leaks.

2006-01-31  Mike Kestner  <mkestner@novell.com>

	* gnome/About.custom : fix some nullterm issues in subclass 
	construction as reported on irc by latexer.

2006-01-31  Mike Kestner  <mkestner@novell.com>

	* gtk/Dialog.custom : null check a parent arg.  [Fixes #77400]

2006-01-22  Mike Kestner  <mkestner@novell.com>

	* configure.in.in : work around broken vte that doesn't
	advertise its gtk+ dependency to pkg-config. [Fixes #77323]

2006-01-21  Mike Kestner  <mkestner@novell.com>

	* generator/SymbolTable.cs : alias off_t to ssize_t as it is
	signed according to harold.  [Fixes #77016]

2006-01-21  Mike Kestner  <mkestner@novell.com>

	* gtk/RadioToolButton.custom : manually implement the GLib.List group
	ctors.  [Fixes #76992]

2006-01-17  Mike Kestner  <mkestner@novell.com>

	* gnome/Canvas.custom : add a ctor (bool is_aa) using the
	construct-only prop.
	[Fixes #77017]

2006-01-17  Wade Berrier  <wberrier@novell.com>

	* Have vte-sharp only depend on gtk-sharp instead of gnome-sharp
	* sample/VteTest.cs: use gtk# calls instead of gnome#
	* vte/vte-sharp-2.0.pc.in: depend on gtk-sharp instead of gnome-sharp
	* configure.in.in: Allow vte to be build if gnome isn't going to be built
	[Fixes #77182]

2006-01-13  Mike Kestner  <mkestner@novell.com>

	* glib/Marshaller.cs : subtract utc_offset when marshaling to time_t.
	[Fixes #77244]

2006-01-12  Mike Kestner  <mkestner@novell.com>

	* sources/MethodBody.cs : use Utf8.GetByteCount for hidden len params.
	[Fixes #77097]

2006-01-11  Mike Kestner  <mkestner@novell.com>

	* bootstrap-2.8 : bump version to 2.8.0

2005-12-30  Alp Toker  <alp@atoker.com>

	* Thread.cs: Add GLib.Thread.Supported, should be checked to avoid doing
	Thread.Init() twice (Mono runtime initialises GLib threads itself, MS
	runtime doesn't)
	* glue/thread.c: g_thread_supported() is a macro, so needs glue
	* glue/Makefile.am:
	* glue/makefile.win32: Update makefiles with new glue file.

2005-12-21  Lluis Sanchez Gual  <lluis@novell.com>

	* generator/FieldBase.cs: Properly convert marshalled value 
	to native value.
	* generator/CallbackGen.cs: Added parens to the result of ToNativeReturn,
	since it may have problems with the cast.

2005-12-16  John Luke  <john.luke@gmail.com>

	* samples/CairoSample.cs:
	* samples/GtkCairo.cs:
	* samples/Makefile.am: update the cairo sample, fixes bug #76324
	
2005-12-16  Mike Kestner  <mkestner@novell.com>

	* gdk/PixbufLoader.custom (InitFromAssemblyResource): move stream
	access code outside the try block so only the Load is cleaned up with 
	the finally block. Add some other arg checking. [Fixes #76997]

2005-12-13  Mike Kestner  <mkestner@novell.com>

	* sources/Makefile.am : move to stable gtk 2.8 versions.
	* sources/gtk-sharp-2.8-sources.xml : move to stable gtk 2.8 versions.
	* */*.raw : regenerate.
	* gdk/Gdk.metadata : hide a few gtk+ internal methods.
	* gtk/Gtk.metadata : hide a win32 internal enum.

2005-12-13  Mike Kestner  <mkestner@novell.com>

	* bootstrap-2.8 : bump version to 2.7.90.

2005-12-13  Mike Kestner  <mkestner@novell.com>

	* gconf/GConf/Makefile.am : add GAPI_CDECL_INSERT step.
	* gconf/GConf.PropertyEditors/Makefile.am : add GAPI_CDECL_INSERT step.

2005-12-13  Mike Kestner  <mkestner@novell.com>

	* configure.in.in : check for mono-cairo.pc.
	* Makefile.include : use AC_SUBST for cairo ref.
	* gdk/Gdk.metadata : s/Cairo.Graphics/Cairo.Context.

2005-12-12  Mike Kestner  <mkestner@novell.com>

	* gnomevfs/Gnomevfs.metadata : mark some const strings.
	[Fixes #76270]

2005-12-12  Mike Kestner  <mkestner@novell.com>

	* gdk/EventClient.cs : fix native long marshaling issue. Thanks to 
	 ed@catmur.co.uk for the bug report and investigation.
	[Fixes #76740]

2005-12-12  Itamar Rogel  <chastamar@yahoo.com>

	* NodeView.cs : add default ctor and NodeStore setter.
	[Fixes #76827]

2005-12-12  Mike Kestner  <mkestner@novell.com>

	* generator/Signal.cs : pass byte cnt for autogenerated string length
	parameters.  Thanks to Itamar Rogel for the report and a candidate
	patch. [Fixes #76952]

2005-12-10  Mike Kestner  <mkestner@novell.com>

	* gtk/gtk-api-2.8.raw : regenerated.
	* gtk/IconView.custom : manually implement a new interface method.
	* parser/gapi_pp.pl : more general G_DEFINE_TYPE_WITH_CODE parsing
	implementation.
	[Fixes #76266]

2005-12-10  Mike Kestner  <mkestner@novell.com>

	* gdk/gdk-symbols.xml : add GrabBroken mapping.
	* gdk/Event.cs : add GrabBroken to GetEvent.
	* gdk/EventGrabBroken.cs : manual Event subclass.
	* gdk/Gdk.metadata : hide new GrabBroken event.
	* gdk/Makefile.am : add new source file.

2005-12-09  Mike Kestner  <mkestner@novell.com>

	* pango/Pango.metadata : 2.8 API tweaks
	* gdk/Gdk.metadata : 2.8 API tweaks
	* gtk/Gtk.metadata : 2.8 API tweaks
	* gtk/IconView.custom : overloads for the weird ScrollToPath.
	* gtk/Makefile.am : add custom

2005-11-19  Mike Kestner  <mkestner@novell.com>

	* generator/ManualGen.cs (CallByName): add null handling.
	[Fixes #76540]

2005-11-15  Ben Maurer  <bmaurer@ximian.com>

	* gdk/Rectangle.custom: Fix up Intersect using p/invoke, per
	miguel's request.

2005-11-10  Mike Kestner  <mkestner@novell.com>

	* bootstrap-2.6 - renamed from bootstrap
	* bootstrap-2.8 : renamed from bootstrap-for-the-insane, removed
	message of doom, require Gtk 2.8. Change version to 2.7.1.

2005-10-31  Wade Berrier <wberrier@novell.com>

	* .pc and wrapper scripts: Use relative paths so gtk-sharp is 
	relocatable

2005-10-19  Mike Kestner  <mkestner@novell.com>

	* gtk/TextBuffer.custom : add some obsolete overloads for backward
	compat with some not-completely-unusable 1.0.x methods.

2005-10-19 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* glib/Object.cs: remove the fast path. It was causing troubles with
	MD.

2005-10-19  Mike Kestner  <mkestner@novell.com>

	* gnome/PrintContext.custom (SetFont): pass the font by handle, not
	ref.

2005-10-19  Mike Kestner  <mkestner@novell.com>

	* bootstrap : bump version for 2.6.0.
	* bootstrap-2.4 : bump version for 2.4.0.

2005-10-08  Miguel de Icaza  <miguel@novell.com>

	* gtk/Application.cs (Invoke): Use Timeout instead of Idle add to
	trigger the event on the Gtk thread.

2005-10-09  Mike Kestner  <mkestner@novell.com>

	* Makefile.include : reference Mono.Cairo.dll.
	* gdk/Gdk.metadata : add cairo_t symbol element.

2005-10-09  Mike Kestner  <mkestner@novell.com>

	* configure.in.in : string quote the POLICY_VERSIONS.
	* Makefile.include : multiple policy fixes.
	* */Makefile.am : multiple policy fixes.

2005-10-08  Mike Kestner  <mkestner@novell.com>

	* generator/Signal.cs : handle enum return values GTypes.
	* gtk/TextBuffer.custom : mark Text prop !GTK_SHARP_2_8.
	[Fixes #75885]

2005-10-08  Ben Maurer  <bmaurer@ximian.com>

	* glade/XML.custom: Do not look at inherited custom
	attrs. Increases performance.

	* glib/SignalAttribute.cs: Add AttributeUsage attr to increase
	perf and compiler checking

2005-10-07 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* glib/MainContext.cs: added a Depth property to p/invoke g_main_depth.
	* glib/Object.cs:
	(Dispose): immediately call g_object_unref without queueing when
	possible (MainContext.Depth > 0) and use Timeout.Add instead of Idle.Add
	to get our unref callback scheduled more reliably.

2005-10-05  Mike Kestner  <mkestner@novell.com>

	* bootstrap : bump version for beta3.
	* bootstrap-2.4 : bump version for beta3.

2005-09-27  Mike Kestner  <mkestner@novell.com>

	* glib/Opaque.cs : remove the Opaques hash.  As f-spot demonstrated,
	we cannot rely on a pointer continuing to point at the same type in
	memory, since there is no destroy notification for most opaques.
	* glib/Value.cs : use more explicit GetOpaque overload.
	* gtk/Style.custom : use more explicit GetOpaque overload.

2005-09-24	Christian Hergert <christian.hergert@gmail.com>

	* vte/Vte.metadata: Fix Vte.Terminal.SetColors to reflect proper mapping
	to vte_terminal_set_colors. palette is now Gdk.Color[].
	* sample/VteTest.cs: Update to work with fixed parameter.
	* doc/en/Vte/Terminal.xml: Update vte docs to reflect parameter fix.

2005-09-23  Mike Kestner  <mkestner@novell.com>

	* configure.in.in : expand glib-sharp-2.0.pc.
	* glib/glib-sharp-2.0.pc.in : new pc file template.
	* glib/Makefile.am : dist and install pc file.
	* gtk/gtk-sharp-2.0.pc.in : Require glib-sharp-2.0.

2005-09-21  Mike Kestner  <mkestner@novell.com>

	* bootstrap* : expose POLICY_VERSIONS variable.
	* configure.in.in : AC_SUBST new POLICY_VERSIONS.
	* Makefile.include : build/install policy assemblies.
	* policy.config.in : policy config skeleton.
	* */Makefile.am : ditto.

2005-09-19  Tambet Ingo  <tambet@ximian.com>

	* glib/Opaque.cs: Set owned property in any case. Generated code
	will set owned to false after unref.

2005-09-15  Mike Kestner  <mkestner@novell.com>

	* configure.in.in : make gtkhtml-3.8 check >= 3.8.0.
	[Fixes #76119]

2005-09-15  Mike Kestner  <mkestner@novell.com>

	* glade/Glade.metadata : mark Interface.toplevels private to allow
	manual implementation.
	* glade/Interface.custom : add manual impl for Toplevels and obsolete
	old toplevels impl.
	* glade/Makefile.am : add new custom.

2005-09-15  Mike Kestner  <mkestner@novell.com>

	* parser/gapi-fixup.cs : warn on unmatched rules.  reworked from a Dan
	Winship patch.  [Fixes #76088]

2005-09-08  Dan Winship  <danw@novell.com>

	* gtk/Gtk.metadata: Hide Gtk.Drag.SetIconDefault. Mark
	Gtk.TreeView.GetVisibleRect's arg as "out".

	* gtk/Drag.custom: gtk_drag_set_icon_default(ctx) should translate
	to Gtk.Drag.SetIconDefault(ctx), not Gtk.Drag.IconDefault = ctx.

	* gtk/TreeView.custom: add obsolete GetVisibleRect()

2005-09-07  Mike Kestner  <mkestner@novell.com>

	* bootstrap : bump version for beta2.
	* bootstrap-2.4 : bump version for beta2.

2005-09-07  Eric Butler <eric@extremeboredom.net>

	* gtk/NodeStore.cs : Add Clear() method
	* doc/en/Gtk/NodeStore.xml : Add documentation for above method

2005-09-07  Mike Kestner  <mkestner@novell.com>

	* configure.in.in : check for monodoc sources dir and warn if we are
	configuring for a different prefix.
	* doc/Makefile.am : add install targets.

2005-09-06  Mike Kestner  <mkestner@novell.com>

	* gtk/NodeStore.cs : fix recursive emit of row_inserted.

2005-09-02  Tambet Ingo  <tambet@ximian.com>

	* glib/Object.cs: Clean disposed flag from resurrected objects.

2005-09-02  Miguel de Icaza  <miguel@novell.com>

	* gtk/Application.cs (Invoke): Add new overloads to easily invoke
	methods on the executing thread.

2005-09-01  Miguel de Icaza  <miguel@novell.com>

	* gtk/Application.cs (Invoke): Add sugar to invoke a method on the
	main thread.

2005-09-02  Ben Maurer  <bmaurer@ximian.com>

	* sample/NodeViewDemo.cs: take advantage of the stuff below

	* gtk/TreeNodeValueAttribute.cs: Allow on props

	* gtk/TreeNodeAttribute.cs: Obsolete column count

	* gtk/NodeStore.cs: Change this to not need the TreeNodeAttribute
	column count. Handle fields as well as properties.

2005-08-30  Mike Kestner  <mkestner@novell.com>

	* gdk/Event.cs : add some null guarding to GetEvent.
	[Fixes #75642]

2005-08-30  Mike Kestner  <mkestner@novell.com>

	* parser/gapi_pp.pl : ignore ifndef *_H_ lines like in 1.0.x.
	[Fixes #75938]

2005-08-30  Mike Kestner  <mkestner@novell.com>

	* gtk/NodeStore.custom : recursively emit row_inserted for AddNode.
	[Fixes #75853]

2005-08-29  Mike Kestner  <mkestner@novell.com>

	* gtk/Widget.custom : add overloads for Modify* without a Gdk.Color
	param to reset color to default.  [Fixes #75913]

2005-08-28  Ben Maurer  <bmaurer@ximian.com>

	* configure.in.in: Enable doc building without mono-tools being
	built.

	* gtk/NodeSelection.cs: helper api

2005-08-27  Peter Williams  <peter@newton.cx>

	* gnome/Program.custom: Use a GLib.Argv in PersistentData to store
	a handle to argv, so that the unmanaged strings aren't freed out
	from under popt. This allows the popt context to actually be used.

2005-08-26  John Luke  <john.luke@gmail.com>

	* glib/Signal.cs: deal with obj.Handle == IntPtr.Zero
	to avoid assertions
	
2005-08-25  Mike Kestner  <mkestner@novell.com>

	* configure.in.in : move GACUTIL check forward ahead of a use.
	* Makefile.include : distcheck fixes
	* glib/Makefile.am : distcheck fixes
	* gtkdotnet/Makefile.am : distcheck fixes

2005-08-25  Mike Kestner  <mkestner@novell.com>

	* configure.in.in : add PLATFORM_WIN32 conditional. Borrow mono's 
	libtool s/cyg// hack. Improve/relocate System.Drawing check.
	* Makefile.include : add gapi-cdecl-insert handling for win32.
	* glib/Makefile.am : add gapi-cdecl-insert handling for win32.
	* gtkdotnet/Makefile.am : s/-r:System.Drawing/-r:System.Drawing.dll/.
	* sample/DrawingSample.cs : remove C# 2.0-isms.
	* sample/Makefile.am : s/-r:System.Drawing/-r:System.Drawing.dll/.

2005-08-25  Mike Kestner  <mkestner@novell.com>

	* bootstrap : bump version to 2.5.90.99
	* bootstrap-2.4 : bump version to 2.3.90.99

2005-08-25  Mike Kestner  <mkestner@novell.com>

	* sample/GtkDemo/DemoIconView.cs : remove C# 2.0-isms.
	* sample/opaquetest/OpaqueTest.cs : remove C# 2.0-isms.
	* sample/valuetest/ValueTest.cs : remove C# 2.0-isms.
	* sample/PolarFixed.cs : remove C# 2.0-isms.

2005-08-23  Ben Maurer  <bmaurer@novell.com>

	* glib/Object.cs: Escape names and ensure stuff is unique.

2005-08-23  Joe Shaw  <joeshaw@novell.com>

	* generator/SymbolTable.cs: Add "unsigned" as a type
	which maps to "uint".

	* parser/gapi2xml.pl: Handle "type const *" return types
	as well.  I think this is all of them!

2005-08-23  Joe Shaw  <joeshaw@novell.com>

	* parser/gapi2xml.pl: Fix a cut-and-paste error in handling
	"type const *" fields.

2005-08-23  Mike Kestner  <mkestner@novell.com>

	* parser/gapi2xml.pl : handle foo const * fields.
	* gnome/gnome-api-2.10.raw : regen.

2005-08-23  Mike Kestner  <mkestner@novell.com>

	* bootstrap-for-the-insane : restore the message of doom that was
	removed during the "bootstrap-generic" reorganization.

2005-08-22  Joe Shaw  <joeshaw@novell.com>

	* parser/gapi2xml.pl: Fix a minor bug handling "type const *"
	parameters.

2005-08-22  Ben Maurer  <bmaurer@novell.com>

	* gtk/TreeNode.cs: Add Interlocked.Increment rather than ++. This
	makes it safe to create tree nodes in a worker thread as long as
	you reparent them into the tree with another thread. Thanks to mk
	for allowing a bit of threadedness in :-).
	
	* gtk/NodeView.cs: Fix leak here. r=mkestner

2005-08-22  Mike Kestner  <mkestner@novell.com>

	* parser/gapi2xml.pl : handle "type const *" parameters.
	* gdk/gdk-api-2.8.raw : regened probably from one of danw's parser
	fixes.  [Fixes #75844]

2005-08-22  Dan Winship  <danw@novell.com>

	* generator/Property.cs (Generate): Mark properties [Obsolete] if
	they or their accessors are marked deprecated. (Affects
	Gtk.Entry.Editable, Gtk.FontSelection.Font,
	Gtk.Notebook.*TabBorder, Gtk.Object.UserData, and a bunch of old
	Gtk.ProgressBar properties).

	* gtk/Gtk.metadata: Hide Entry.Editable. Mark Notebook.Homogeneous
	deprecated.

	* gtk/Entry.custom: Implement Editable property with an Obsolete
	pointing to IsEditable.

2005-08-22  Dan Winship  <danw@novell.com>

	* generator/CallbackGen.cs (Validate, MarshalType): if validation
	fails, set MarshalType to "" to propagate that failure into
	methods that have args of this type. [Fixes #75851]

2005-08-15  Peter Williams  <peter@newton.cx>

	* bootstrap-generic: New script, handles bootstrapping stuff generically
	and saves bootstrap settings so we can regenerate configure.in from 
	configure.in.in.

	* bootstrap
	* bootstrap-2.4
	* bootstrap-for-the-insane: Modify to use bootstrap-generic

	* Makefile.am (configure.in): Add a rule to run bootstrap.status to
	regenerate configure.in if configure.in.in changes.

2005-08-15  Mike Kestner  <mkestner@novell.com>

	* bootstrap : update for 2.5.90 release. 
	* bootstrap-2.4 : update for 2.3.90 release. 

2005-08-15  Mike Kestner  <mkestner@novell.com>

	* gtk/glue/makefile.win32 : s/.c/.o typo.

2005-08-15  Mike Kestner  <mkestner@novell.com>

	* pango/makefile.win32 : process symbols file at fixup target.

2005-08-15  Mike Kestner  <mkestner@novell.com>

	* sample/opaquetest/Makefile.am : make clean fixes
	* sample/valtest/Makefile.am : make clean fixes

2005-08-15  Dan Winship  <danw@novell.com>

	* sample/opaquetest/Makefile.am (EXTRA_DIST): add missing files
	(generated/*.cs): fix for srcdir!=builddir
	* sample/valtest/Makefile.am (EXTRA_DIST): add missing files
	(Valobj.cs): fix for srcdir!=builddir

2005-08-15  Mike Kestner  <mkestner@novell.com>

	* glib/Object.cs : hold strong refs for managed subclasses and
	weakrefs for wrappers.
	* gtk/Object.custom : don't hold managed refs here, they are now held
	in GLib.Object.

2005-08-11  Dan Winship  <danw@novell.com>

	* parser/gapi2xml.pl (addFuncElems): if a struct or boxed type has
	a constructor or a ref, unref, or destroy method, then it must be
	a reference type, so mark it "opaque" but then also mark all of
	its fields public and writable.

	* */*-api*.raw: Regen

	* generator/Parser.cs (ParseNamespace): make the opaque attribute
	check actually look at the value of the attribute rather than just
	checking if it's there, so that you can change a struct's opaque
	attribute from "true" to "false" via metadata and have that work.

	* generator/BoxedGen.cs (Generate): do not generate the boxed's
	"Free" method (since it's guaranteed to crash when we pass it a
	stack pointer). If "Copy" is marked deprecated, create a
	deprecated no-op for it, otherwise just skip it (since otherwise
	it will just leak memory when we copy its result onto the stack).

	* pango/Pango.metadata: deprecate Pango.Color.Copy and
	Pango.Matrix.Copy. Hide some array fields in Pango.GlyphString
	that we've never generated correctly. Tweak Pango.LayoutLine
	fields to be the same as they used to be.

	* pango/GlyphItem.custom (glyphs, item):
	* pango/GlyphString.custom (Zero, New):
	* pango/Item.custom (Zero, New):
	* pango/LayoutRun.custom (glyphs, item): add deprecated API compat

	* gdk/Gdk.metadata: undo the parser's new opaquification of
	Gdk.Font; it's been deprecated since pre-gtk# times, and no one
	should be using it, so there's no point in fixing it now. Fix up a
	few other things to match how they used to be. Fix RgbCmap's
	constructor args.

	* gdk/RgbCmap.custom (Zero, New): deprecated API compat

	* gdk/PangoAttrEmbossed.custom:
	* gdk/PangoAttrStipple.custom (Zero, New, Attr): deprecated API
	compat
	(explicit operator ...): allow casting back and forth between
	Pango.Attribute. (We can't usefully make them real subclasses of
	Pango.Attribute, because there's no way for
	Pango.Attribute.GetAttribute() to be able to dtrt with them.)

	* gtk/Gtk.metadata: deprecate Gtk.Requisition.Copy,
	Gtk.TextIter.Copy, and Gtk.TreeIter.Copy. Mark the return value of
	TextView.DefaultAttributes as "owned". Mark TargetList's fields
	private so it stays how it used to be.

	* gtk/TextAttributes.custom (Zero, New): deprecated API compat

	* gnomevfs/Gnomevfs.metadata: remove a bunch of opaque
	declarations that the parser figures out on its own now.

	* art/Art.metadata:
	* glade/Glade.metadata:
	* rsvg/Rsvg.metadata: un-mark everything the parser marked opaque
	in these libraries, because all of the structs in question would
	still be unusably broken, so the API churn would be pointless.

2005-08-11  Dan Winship  <danw@novell.com>

	* generator/OpaqueGen.cs (Generate):
	* generator/StructBase.cs (Generate): Add the [Obsolete] attribute
	to deprecated structs/boxeds/opaques too. (Affects Gdk.Font,
	Gtk.Arg, Gtk.ItemFactoryEntry, Gnome.IconData, and [in 2.6]
	Gnome.Vfs.MimeAction)

2005-08-09  Dan Winship  <danw@novell.com>

	* configure.in.in: kill off all gda/gnomedb references.
	(Henceforth gda# and gnomedb# will be part of gda and gnomedb. Or
	maybe separate modules in Mono SVN. Not part of gtk-sharp though.)

	* Makefile.am (SUBDIRS): remove gda and gnomedb

	* gda/, gnomedb/: buh-bye

	* sources/Makefile.am: remove gda/gnomedb

	* sources/gda.patch, sources/gnomedb.patch: gone

2005-08-09  Dan Winship  <danw@novell.com>

	* generator/ClassBase.cs (Validate): Don't fully validate the
	parent class and interfaces (because we don't want to see the
	warnings about certain GtkWidget methods in every single library
	that defines a widget, etc). Instead, use the new
	ValidateForSubclass() method.
	(ValidateForSubclass): only validate the signals

	* generator/InterfaceGen.cs (ValidateForSubclass): for interfaces
	we need to validate the methods too.

	* generator/ObjectGen.cs (Generate): Check for interface method
	collisions against the class's own methods too, not just its other
	interfaces. Also, it's only a collision if the methods' signatures
	have the same types.

	* generator/Method.cs (GenerateDeclCommon): Strip "Get"/"Set" even
	in the context of "Gtk.TreeModel.GetNColumns"

	* generator/Signal.cs (GenDefaultHandlerDelegate): Use
	"{0}_managed" rather than "obj" for the internal variable name, to
	avoid compile problems with signals that have a parameter named
	"obj".

	* generator/SymbolTable.cs (MangleName): mangle "internal" to
	"_internal".

	* generator/CallbackGen.cs (GenWrapper): treat InterfaceGen return
	values the same as ObjectGen

2005-08-09  Dan Winship  <danw@novell.com>

	* generator/OpaqueGen.cs (Generate): Tweak the generated Ref/Unref
	a bit; only Ref the pointer if Owned is false (and then set it to
	true), and vice versa for Unref.

	* glib/Opaque.cs (Opaque): set owned before setting Raw, so
	that Raw will be reffed properly.
	(GetOpaque): Fix this up to dtrt in all cases with refcounted
	opaques.
	
	* gtk/TreeView.custom (GetPathAtPos): Use "GetOpaque(...)" rather
	than "new TreePath()"

	* sample/opaquetest/*: regression test for opaque free/ref/unref
	handling

	* sample/Makefile.am (SUBDIRS): add opaquetest

	* configure.in.in (AC_OUTPUT): add opaquetest files

2005-08-04  Dan Winship  <danw@novell.com>

	Change the way generatable validation works. Some generatable
	properties can't be set until Validate-time (eg, Method.IsGetter),
	but it's annoying for every potential user of those properties to
	have to make sure it has Validated the generatable first. So now
	we add an explicit Validate() step after everything is loaded but
	before anything is Generated, so that at Generation time,
	everything can be assumed to have been Validated.

	* generator/IGeneratable.cs: add "bool Validate()"

	* generator/CodeGenerator.cs (Main): after loading all of the
	generatables, DeAlias the SymbolTable, Validate() all the
	generatables, and discard any invalid ones.

	* generator/*.cs: Implement Validate() trivially in generatables
	that didn't implement it before. Move Validate() calls from
	Generate() to Validate(). Remove non-hierarchical Validate()
	calls.

	* generator/SymbolTable.cs: GPtrArray is IntPtr, not IntPtr[]
	
2005-08-04  Dan Winship  <danw@novell.com>

	* gtk/TargetList.custom: add an operator for casting to
	TargetEntry[], so you can use methods like
	TargetList.AddTextTargets() in situations where you need a
	TargetEntry[] rather than a TargetList.

	* gtk/glue/targetlist.c: glue for that

2005-08-04  Mike Kestner  <mkestner@novell.com>

	* generator/Ctor.cs : call Finish and HandleException for static ctor
	method bodies. [Fixes #75493]

2005-08-03  Mike Kestner  <mkestner@novell.com>

	* bootstrap : use gnome and vfs 2.10 api.
	* bootstrap-2.4 : use gnome and vfs 2.6 api.
	* bootstrap-for-the-insane : use gnome and vfs 2.10 api for now.
	* configure.in.in : substitute GNOME_REQUIRED_VERSION.
	* gnome/gnome-api.raw : rename to gnome-api-2.6.raw.
	* gnome/gnome-api-2.10.raw : new 2.10 parse.
	* gnomevfs/gnome-vfs-api.raw : rename to gnome-api-2.6.raw.
	* gnomevfs/gnome-vfs-api-2.10.raw : new 2.10 parse.
	* gnomevfs/Gnomevfs.metadata : mark MimeApplication opaque.
	* sources/Makefile.am : split gnome parse for 2.6/2.10.
	* sources/gtk-sharp-2.4-sources.xml : parse GNOME 2.6.
	* sources/gtk-sharp-2.6-sources.xml : parse GNOME 2.10.
	* sources/gtk-sharp-2.8-sources.xml : parse GNOME 2.10 for now.

2005-08-02  Dan Winship  <danw@novell.com>

	* generator/Property.cs (Generate): cast GLib.Values to
	System.Enum before casting them to an enum type, to fix the build
	with csc 1.1.

2005-07-29  Dan Winship  <danw@novell.com>

	Automatic memory management for opaque types [#49565]
	
	* glib/Opaque.cs (Owned): new property saying whether or not gtk#
	owns the memory.
	(Opaque): Set Owned to true in the void ctor and false in the
	IntPtr one.
	(GetOpaque): add a new overload that can also create opaques, a la
	GLib.Object.GetObject.
	(Ref, Unref, Free): empty virtual methods to be overridden by
	subclasses.
	(set_Raw): Unref() and possibly Free() the old value, Ref() the
	new one.
	(~Opaque, Dispose): set Raw to IntPtr.Zero (triggering Free/Unref
	if needed)

	* parser/gapi2xml.pl (addReturnElem): if the method is named Copy
	and returns a pointer, set the "owned" attribute on the
	return-type.

	* */*-api.raw: Regen
	
	* generator/HandleBase.cs (FromNative): Add new
	FromNative/FromNativeReturn overloads that takes a "bool owned"
	param. Implement the 1-arg FromNative and FromNativeReturn in
	terms of that.

	* generator/ObjectBase.cs (FromNative): Implement HandleBase's new
	overload. Use the two-arg version of GLib.Object.GetObject when
	"owned" is true.

	* generator/OpaqueGen.cs (Generate): Pull out Ref, Unref, and
	Free/Destroy/Dispose methods and handle them specially by
	overriding Opaque.Ref, .Unref, and .Free appropriately. (If any
	of the methods are marked deprecated, output a deprecated
	do-nothing method as well, to save us from having to write all
	those deprecated methods by hand.)
	(FromNative): use GetOpaque, passing "owned".

	* generator/ReturnValue.cs (FromNative): if the value is a
	HandleBase, pass Owned to its FromNative().

	* generator/Parameters.cs (Owned): new property (for use on out
	params)
	(FromNative): Call FromNative() on the generatable, handling Owned
	in the case of HandleBase.

	* generator/ManagedCallString.cs:
	* generator/MethodBody.cs:
	* generator/Signal.cs: use param.FromNative() rather than
	param.Generatable.FromNative(), to get ownership right.

	* */*.metadata: Mark opaque ref/unref/free methods deprecated
	(except where we were hiding them before). Add "owned" attributes
	to return values and out params as needed.

	* pango/AttrIterator.custom (GetFont): work around a
	memory-management oddity of the underlying method.

	* pango/AttrFontDesc.cs (AttrFontDesc): copy the passed-in
	FontDescriptor, since the attribute will assume ownership of it.

	* gtk/TreeView.custom (GetPathAtPos): set the "owned" flag on the
	returned TreePaths.

	* gtk/TargetList.custom: Remove refcounting stuff, which is
	now handled automatically

	* gtk/NodeStore.cs (GetPath): clear the Owned flag on the created
	TreePath so that the underlying structure doesn't get freed when
	the function returns

	* gtkhtml/HTMLStream.custom (Destroy): hide this and then
	reimplement it by hand to keep OpaqueGen from using it in
	Dispose(), since calling it after an HTMLStream.Close() will
	result in a crash.

2005-08-01  Todd Berman  <tberman@off.net>

	* gtk/Gtk.metadata: Change the Gtk.Style.Paint* methods to use a
	Gdk.Drawable instead of a Gdk.Window
	* doc/en/Gtk/Style.xml: Update the documentation for the above
	change.

2005-07-28  Mike Kestner  <mkestner@novell.com>

	* bootstrap-for-the-insane : beginnings of 2.8 binding.
	* */*-api-2.8.raw : 2.8 api files.
	* gdk/Gdk.metadata : work around #define used in Pixbuf props in 2.7.
	* parser/gapi2xml.pl : collision guarding for privatestruct defs.
	* sources/gtk-sharp-2.8-sources.xml : parse for 2.8.
	* sources/Makefile.am : api-2.8, get-2.8-sources, etc...

2005-07-28  Dan Winship  <danw@novell.com>

	* sources/gtk-sharp-2.4-sources.xml: 
	* sources/gtk-sharp-2.6-sources.xml: exclude a bunch of
	gnome-print stuff that is not part of gnome-print's public API.

	* gnome/gnome-api.raw: regen

	* gnome/Gnome.metadata: remove some no-longer-needed metadata

	* gnome/GPFontEntry.custom: 
	* gnome/GPPath.custom: no longer needed

	* gnome/FontFamily.cs: moved from FontFamily.custom, since there's
	no longer any non-custom portion of this.

2005-07-27  Dan Winship  <danw@novell.com>

	* gtk/ComboBoxEntry.custom: add an "Entry" property to cleanly
	fetch the ComboBoxEntry's Gtk.Entry

2005-07-27  Dan Winship  <danw@novell.com>

	* parser/gapi2xml.pl (addParamsElem): deal with G_CONST_RETURN in
	params... some functions use that to mark const "out" params. In
	fact, let's use it as a hint to mark them pass_as="out" too...

	* pango/pango-api-2.4.raw: 
	* pango/pango-api-2.6.raw: 
	* gtk/gtk-api-2.6.raw: Regen, fixing pango_script_iter_get_range
	and gtk_image_get_icon_name.

	* pango/Pango.metadata: 
	* pango/ScriptIter.cs: Alas, exposing GetRange makes it clear that
	PangoScriptIter is really weird and we weren't wrapping it
	correctly before anyway, so mark the whole thing hidden and wrap
	it by hand.

2005-07-25  Mike Kestner  <mkestner@novell.com>

	* gnome/Gnome.metadata : mark IconList.GetIconFilename retval const.
	[Fixes #75530]

2005-07-21  Dan Winship  <danw@novell.com>

	* glib/Value.cs: Obsolete the EnumWrapper and UnwrappedObject
	constructors and casts. Add a new Enum cast.
	(Val): Handle Pointer values. Change the handling of Enum/Flags
	values to return the value directly rather than returning an
	EnumWrapper. Remove the Char (ie, "byte") handling since there
	aren't any char properties in all of gtk-sharp and the generator
	mistakenly converts them to strings anyway.

	* glib/EnumWrapper.cs: 
	* glib/UnwrappedObject.cs: Mark these Obsolete.

	* glib/glue/type.c (gtksharp_get_parent_type,
	gtksharp_get_type_name_for_id): 
	* glib/glue/value.c (gtksharp_value_get_value_type): Remove some
	unneeded glue methods.

	* generator/Ctor.cs (Generate):
	* generator/Property.cs (Generate): Simplify the enum and object
	property glue to not use EnumWrapper or UnwrappedObject.

	* sample/valtest/*: a regression test for GLib.Value

	* configure.in.in: add sample/valtest

2005-07-21  Dan Winship  <danw@novell.com>

	* parser/gapi2xml.pl (parseInitFunc): handle interface properties
	as well as class properties

	* gtk/gtk-api-2.4.raw: 
	* gtk/gtk-api-2.6.raw: Regen (adding properties to GtkFileChooser).

	* generator/Property.cs (GenerateDecl): new method to generate
	just a property declaration (for an interface).
	(Generate): Add an "implementor" arg as with Method.Generate.

	* generator/InterfaceGen.cs (Generate): Generate properties. Also,
	validate methods *before* checking if they should be ignored,
	since certain Method properties aren't set until Validate-time.

	* generator/*.cs: misc minor changes/reorg for the above.

2005-07-19  Todd Berman  <tberman@off.net>

	* gtk/TreeSelection.custom: Add an overload for GetSelected to remove
	the need to always pass in that damn TreeModel.
	* doc/en/Gtk/TreeSelection.xml: Add documentation for the new
	overload.

2005-07-19  Dan Winship  <danw@novell.com>

	* parser/gapi2xml.pl (addParamsElem): change the handling of
	anonymous function pointer types in method signatures. Before, we
	added a <callback> child to the <parameters> node, but the
	generator just ignored it. Now we add the callback (with a made-up
	name) to the toplevel node, and add an ordinary <param> node
	referencing it to the <parameters> node. Also, if the last param
	of the callback is a gpointer, rename it from "arg#" to "data" so
	it will be treated correctly (as the user data passed from the
	calling method). [Fixes #66241]

	* art/art-api.raw: 
	* gdk/gdk-api-2.4.raw: 
	* gdk/gdk-api-2.6.raw: Regen

	* generator/Parameters.cs (IsHidden): loosen the definition of
	hideable user_data; it doesn't have to occur at the end of the
	parameter list, as long as there's a callback arg before it.

	* generator/MethodBody.cs (GetCallString): Use Parameters.IsHidden
	to decide whether or not to squash user_data params, rather than
	trying to duplicate its logic. As a side effect, this also causes
	a handful of methods that take non-hidden IntPtr arguments to
	start actually passing those arguments to C rather than always
	passing IntPtr.Zero.

	* generator/Method.cs (Equals, GetHashCode): Remove unnecessary
	and possibly erroneous hashing overrides.

	* gtk/Gtk.metadata: Hide Gtk.Container.ForeachFull, since it's
	useless and wasn't in gtk# 1.0

	* gtk/Menu.custom (Popup):
	* gtk/TextIter.custom (ForwardFindChar, BackwardFindChar):
	* gnome/App.custom (CreateMenusInterp, InsertMenusInterp,
	CreateToolbarInterp):
	* gnome/Client.custom (RequestInteractionInterp):
	* gnome/Popup.custom (MenuDoPopupModal, MenuDoPopup): Add
	[Obsolete] compat overloads for methods that have now lost a
	useless IntPtr.

2005-07-19  Dan Winship  <danw@novell.com>

	* generator/Parameters.cs: Remove the AllowComplexRefs flag.
	(They're always allowed now.)

	* generator/Signal.cs (GenVirtualMethod): Fix up the use of CSType
	vs MarshalType in the ref/out-handling code so that this can
	marshal any type.

2005-07-18  Dan Winship  <danw@novell.com>

	* parser/gapi2xml.pl: Change a few instances of
	"last if ($line =~ /^}/);" to
	"last if ($line =~ /^(deprecated)?}/);" to prevent runaway
	parsing (in particular in libgnomeui).

	* sources/gtk-sharp-2.4-sources.xml: 
	* sources/gtk-sharp-2.6-sources.xml: exclude a handful of
	libgnomeui files that were omitted in gtk# 1.0 due to the parser
	bug, but which are entirely deprecated anyway. (Some of them
	showed up in earlier 1.9/2.4/2.6 releases but are going away again
	now.)

	* gnome/gnome-api.raw: Regen

	* gnome/Gnome.metadata: Hide a few more things that should be
	hidden, remove a few rules that aren't needed any more. Keeping
	hiding GnomeIconTheme though and using the old by-hand IconTheme
	for the moment, since the by-hand one isn't compatible with the
	autogenerated one.

	* gnome/IconData.cs: kill this, use the autogenerated version

2005-07-13  Dan Winship  <danw@novell.com>

	* sources/gtk-sharp-2.4-sources.xml: 
	* sources/gtk-sharp-2.6-sources.xml: remove some gnome-vfs files:
	gnome-vfs-method and gnome-vfs-transform, because they're
	internal/part of the module API, and gnome-vfs-file-size.h,
	because it's generated and shouldn't be in the source tarball (and
	we don't parse it right anyway).

	* gnomevfs/gnome-vfs-api.raw: Regen

	* gnomevfs/gnomevfs-symbols.xml: add GnomeVFSFileOffset

	* gnomevfs/Gnomevfs.metadata: remove a whole bunch of callback
	types that are only used from methods and structs that we hide.
	
2005-07-08  Mike Kestner  <mkestner@novell.com>

	* */*.raw : regen.
	* parser/gapi2xml.pl : access comment doesn't have to start at
	beginning of line.

2005-07-08  Mike Kestner  <mkestner@novell.com>

	* pango/*.raw : regen.
	* sources/gtk-sharp-2.4-sources.xml : exclude some xft and fc files.
	* sources/gtk-sharp-2.6-sources.xml : exclude some xft and fc files.

2005-07-07  Dan Winship  <danw@novell.com>

	* gnome/Gnome.metadata: opaquify ModuleInfo and hide the types
	that are only used inside ModuleInfo, so we don't marshal the
	function pointers into (incorrect) delegates.

	* gnome/Modules.cs: 
	* gnome/Program.custom: update for ModuleInfo being a class rather
	than a struct now

2005-07-02  Mike Kestner  <mkestner@novell.com>

	* generator/StructField.cs : fix name exception throw conditional.

2005-07-02  Mike Kestner  <mkestner@novell.com>

	* generator/CallbackGen.cs : implement new IAccessor iface so that
	callback fields on structs can now be accessed.
	* generator/ClassBase.cs : remove/abstract some methods incorrectly
	located here.
	* generator/ClassGen.cs : implement methods previously inherited from
	ClassBase incorrectly.
	* generator/HandleBase.cs : new base class for native ptr wrappers.
	Implements new IAccessor interface and code moved from ClassBase.
	* generator/IAccessor.cs : new iface to generate field/prop accessors.
	* generator/InterfaceGen.cs : derive from new ObjectBase.
	* generator/LPGen.cs : implement IAccessor.
	* generator/LPUGen.cs : implement IAccessor.
	* generator/ObjectBase.cs : new base class for Object/Iface types.
	* generator/ObjectGen.cs : derive from new ObjectBase.
	* generator/OpaqueGen.cs : derive from HandleBase.
	* generator/StructField.cs : refactor Generate method using new
	IAccessor interface.
	* */*.custom : add obsolete impls for some existing c_cased struct
	field accessors that are now StudlyNamed.

2005-07-02  Mike Kestner  <mkestner@novell.com>

	* generator/CallbackGen.cs : remove an old workaround that put
	the native wrapper class into the implementor's *Sharp namespace.
	Use new ImportSignature sig.
	* generator/ImportSignature.cs : don't mangle the callback wrapper
	namespace any more. Remove impl_ns ctor param and field.
	* generator/MethodBase.cs : use new MethodBody and ImportSignature
	ctor sigs.
	* generator/MethodBody.cs : drop the impl_ns ctor param.
	* generator/Signal.cs : use new ImportSignature ctor sig.
	* generator/VirtualMethod.cs : use new ImportSignature ctor sig.

2005-07-01  Mike Kestner  <mkestner@novell.com>

	* generator/Parameters.cs : init allow_complex_refs to true to fix
	build.

2005-06-30  Dan Winship  <danw@novell.com>

	* generator/Parameters.cs (AllowComplexRefs): new property for
	whether or not to allow "complex" ref/out args.
	(Validate): update for that

	* generator/Signal.cs: set AllowComplexRefs false on the params.
	(Validate): fix the messages
	(GenCallback, GenEventHandler): properly handle ref/out args, by
	manually pointerifying them (except for boxed args, which are
	already pointers).

	* glib/Marshaller.cs (StructureToPtrAlloc): Rename from
	PtrToStructureAlloc, since it wraps Marshal.StructureToPtr.

2005-06-28  Mike Kestner  <mkestner@novell.com>

	* gtk/ComboBox.custom : add ctor (string[]).
	* gtk/ComboBoxEntry.custom : add ctor (string[]).
	* sample/test/TestComboBox.cs : simple new ComboBox tester.
	* sample/test/WidgetViewer.cs : button for simple new ComboBox tester.

2005-06-27  Mike Kestner  <mkestner@novell.com>

	* gnome/CanvasBpath.custom : a BPath property to wrap the ugly Bpath
	IntPtr prop.  [Fixes #75381]

2005-06-24  Mike Kestner  <mkestner@novell.com>

	* atk/Atk.metadata : couple of small api cleanups.

2005-06-24  Mike Kestner  <mkestner@novell.com>

	* gtk/Gtk.metadata : remove the one reference to FileChooserEmbed.
	* gtk/gtk-api-2.*.raw : regen.
	* sources/gtk-sharp-2.*-sources.xml : exclude FileChooserEmbed files.

2005-06-23  Mike Kestner  <mkestner@novell.com>

	* generator/ReturnValue.cs : support owned and elements_owned for lists.
	* glib/List.cs : add ctor overloads for memory mgmt.
	* glib/ListBase.cs : add ctor overloads for memory mgmt. Dispose
	elements if specified.
	* glib/SList.cs : add ctor overloads for memory mgmt.
	* gnome/Gnome.metadata : unhide and generate a List prop.
	* gnomevfs/Gnomevfs.metadata : unhide and generate a List prop.
	* gtk/FileChooser.custom : new. add hidden props.
	* gtk/FileChooserButton.custom : new. impl hidden props.
	* gtk/FileChooserDialog.custom : remove some List props and use the
	GLib.Marshaller for the remaining ones..
	* gtk/FileChooserWidget.custom : remove some List props and use the
	GLib.Marshaller for the remaining ones..
	* gtk/Gtk.metadata : unhide and let the generator do some List props.

2005-06-23  Mike Kestner  <mkestner@novell.com>

	* gconf/GConf/Client.cs : support add/remove of a single notify handle
	to multiple directories.  [Fixes #55877]

2005-06-22  Mike Kestner  <mkestner@novell.com>

	* sample/GladeTest.cs : add a menu item signal connect to test for the
	problem described in bug#74946.
	* sample/test.glade : add menubar.

2005-06-22  Mike Kestner  <mkestner@novell.com>

	* sample/GtkDemo/DemoHyperText.cs : replace PersistentData usage that
	breaks on csc.
	* sample/GtkDemo/DemoTreeStore.cs : fix a 2.0 usage.

2005-06-22  Mike Kestner  <mkestner@novell.com>

	* generator/ManagedCallString.cs : don't assume ref for structs.
	* generator/VMSignature.cs : don't assume ref for structs.

2005-06-21  Mike Kestner  <mkestner@novell.com>

	* generator/ConstStringGen.cs : override ToNativeReturn ().
	* generator/ClassBase.cs : use fully qualified interface names for
	conflicting implementations.

2005-06-20  Mike Kestner  <mkestner@novell.com>

	* parser/gapi2xml.pl : fix const foo * const * fields/params.
	[Fixes #75266]

2005-06-17  Mike Kestner  <mkestner@novell.com>

	* Makefile.include : add included apis as deps on the generation
	target to force regen if dependency lib api changes.
	* pango/Analysis.custom : new custom to implement the ExtraAttrs
	property.  [Fixes #74668]
	* pango/Makefile.am : add new custom file.

2005-06-17  Mike Kestner  <mkestner@novell.com>

	* bootstrap : use assembly version 2.6.0.0.
	* bootstrap-2.4 : use assembly version 2.4.0.0.
	* configure.in.in : substitute the assembly version.

2005-06-14  Mike Kestner  <mkestner@novell.com>

	* gtk/Gtk.metadata : add nodes for all the *Set props on TextTag.
	[Fixes #75219]

2005-06-10  Dan Winship  <danw@novell.com>

	* parser/gapi2xml.pl (addPropElem): Distinguish CONSTRUCT ("must
	be set at construct time") and CONSTRUCT_ONLY ("can only be set at
	construct time") properties, rather than marking them all
	"construct-only".

	* gnome/gnome-api.raw: 
	* gtk/gtk-api-2.4.raw: 
	* gtk/gtk-api-2.6.raw: Regen, causing a few formerly-read-only
	properties to become writable.

2005-06-10  Mike Kestner  <mkestner@novell.com>

	* glade/XML.custom : add a try block on field autoconnect to make it
	easier to catch type mismatches and such.  Suggestion from Gonzalito.

2005-06-09  Lluis Sanchez  <lluis@novell.com>

	* glib/Marshaller.cs: Added null check in FilenamePtrToString.

2005-06-08  Mike Kestner  <mkestner@novell.com>

	* generator/SimpleBase.cs : off-by-one in namespace join.
	* glib/ListBase.cs : support IntPtr element_type.
	* gnomevfs/FileInfo.cs : make it ManualGen friendly.
	* gnomevfs/*.cs : rework for FileInfo api changes.
	* gnomevfs/Gnomevfs.metadata : make FileInfo a manual symbol.
	* gnomevfs/Uri.custom : rework for FileInfo api changes.
	* gnome/Makefile.am : add gnomevfs dependency to pick up some more api
	symbols.
	* gnome/gnome-sharp-2.0.pc.in : advertise the vfs dep.
	[Fixes #71060]

2005-06-08  Mike Kestner  <mkestner@novell.com>

	* generator/ReturnValue.cs : don't write a sem in FromNative.
	* glib/ListBase.cs : handle GLib.Object explicit element types.
	* glib/Marshaler.cs : only copy lists if Count > 0.
	* gtk/Gtk.metadata : unhide Window.ListToplevels with a proper element
	type for automatic list to array marshaling.
	* gtk/Window.custom : kill manual ListToplevels impl.

2005-06-08  Mike Kestner  <mkestner@novell.com>

	* generator/ReturnValue.cs : improved list to array marshaling.
	* glib/Marshaller.cs : added ListToArray ().
	* gnomevfs/Gnomevfs.metadata : mark element_type on
	Mime.GetAllApplications. [Fixes #71888]

2005-06-06  Mike Kestner  <mkestner@novell.com>

	* generator/ImportSignature.cs : fix native delegate namespacing hack.
	* gnomevfs/gnome-vfs-api.raw : regen.
	* gnomevfs/Gnomevfs.metadata : replace all the type renames with a
	namespace rename.  remove-node several manually implemented callback
	types and broken generated types for now.
	* gnomevfs/Async.cs : use Opaque.Handle.
	* gnomevfs/Handle.cs : kill. replaced by generated GLib.Opaque type.
	* gnomevfs/Makefile.am : kill Handle.cs.
	* gnomevfs/Sync.cs : use Opaque.Handle.
	* sources/gtk-sharp-2.6-sources.xml : s/Gnome.Vfs/GnomeVFS.

2005-06-06  Mike Kestner  <mkestner@novell.com>

	* Makefile.include : depend on gapi-fixup.exe for the api target.
	* parser/gapi-fixup.cs : remove-node rule handling.

2005-06-06  Dan Winship  <danw@novell.com>

	* sample/GtkDemo/DemoRotatedText.cs (RotatedTextExposeEvent): Use
	Gdk.PangoRenderer.GetDefault() like the C gtk-demo rather than
	creating a new Gdk.PangoRenderer. [Fixes #74865]

	* gdk/Gdk.metadata: fix return type of Gdk.PangoRenderer.GetDefault

	* glib/GType.cs (cctor): call g_type_init(). (Avoids debug spew
	when monodocer updates doc/en/GLib/GType.xml.)

2005-06-02  Mike Kestner  <mkestner@novell.com>

	* gtk/gtk-api-2.6.raw : regen.
	* parser/gapi_pp.pl : add G_DEFINE_TYPE_WITH_CODE handling.
	* parser/gapi2xml.pl : add G_DEFINE_TYPE_WITH_CODE parsing.
	[Fixes #74833]

2005-06-02  Mike Kestner  <mkestner@novell.com>

	* glib/ListBase.cs : add a nested class to support filename encoded
	string element marshaling.
	* gtk/Gtk.metadata : mark the filenames and folders as filename
	encoded.
	* gtk/FileChooserDialog.custom : use new ListBase.FilenameString type
	for list element type of filenames and folders.
	* gtk/FileChooserWidget.custom : use new ListBase.FilenameString type
	for list element type of filenames and folders.
	[Fixes #72701]

2005-06-02  Mike Kestner  <mkestner@novell.com>

	* generator/ConstFilenameGen.cs : new generatable for filename encoded
	const string marshaling
	* generator/Makefile.am : add new file
	* generator/SymbolTable.cs : add new gfilename types.
	* glib/Marshaller.cs : add new filename-encoded string marshalers.
	* gtk/FileSelection.custom : use FilenamePtrToString to marshal.
	* gtk/Gtk.metadata : map the FileSelector filename types to my new
	imaginary gfilename type.  [Fixes #74963]

2005-06-02  Mike Kestner  <mkestner@novell.com>

	* gtk/Object.custom : only connect to Destroyed for managed subclasses
	and let the wrappers get disposed by the GC.

2005-06-01  Mike Kestner  <mkestner@novell.com>

	* glib/Value.cs : handle enum/flags types in Val.
	[Fixes #75112]

2005-06-01  Dan Winship  <danw@novell.com>

	* glib/Value.cs: Add a constructor and an explicit cast for
	string[] (using a G_TYPE_STRV boxed value).

	* generator/SymbolTable.cs (SymbolTable): Map GStrv to string[].
	(The mapping relies on the above GLib.Value magic, so it only
	works correctly for properties, but that's ok, because GStrv isn't
	a real type anyway and only shows up in the api files for
	G_TYPE_STRV properties.) Makes the Gtk.AboutDialog Artists,
	Authors, and Documenters properties show up.

	* gtk/Gtk.metadata: hide
	AboutDialog.Get/SetArtists/Authors/Documenters, which can't be
	used to implement the Artists/Authors/Documenters properties,
	because the generated code doesn't know to NULL-terminate the
	arrays.

2005-05-31  Mike Kestner  <mkestner@novell.com>

	* glib/Object.cs : rework the weakref release mechanism to avoid a
	couple "resurrection" issues.

2005-05-25  Mike Kestner  <mkestner@novell.com>

	* configure.in.in : remove crosspkgdir arg that causes trouble with
	newer pkgconfigs.

2005-05-24  Dan Winship  <danw@novell.com>

	* parser/gapi2xml.pl: Make the enum value parser do the right
	thing with parenthesized values ("FOO = (1 << 2)") and within-type
	aliases ("GTK_ANCHOR_N = GTK_ANCHOR_NORTH"). Make it intentionally
	do the wrong thing with unparsable values (outputting them as-is
	into the api file) so that we are forced to fix them with metadata
	rather than silently getting incorrect values.

	* gdk/gdk-api-2.4.raw: 
	* gdk/gdk-api-2.6.raw (PixdataType): Now recognized as flags,
	not enum

	* gtk/Gtk.metadata: hide the enums ArgFlags and RcTokenType (which
	are not used by any wrapped API, and which formerly contained
	entirely wrong values).

	* gtk/gtk-api-2.4.raw: 
	* gtk/gtk-api-2.6.raw (AnchorType, SelectionMode): update with
	values for aliases

	* gnome/Gnome.metadata: fix value of Gnome.PrintButtons.Cancel

	* gnome/gnome-api.raw (PrintUnitBase, PaperSelectorFlags,
	PrintDialogFlags, PrintDialogRangeFlags): Now recognized as flags,
	with values.

2005-05-24  John Luke  <john.luke@gmail.com>

	* configure.in.in: remove doc/updater/Makefile to fix build

2005-05-23  Mike Kestner  <mkestner@novell.com>

	* configure.in.in : add monodocer-fu.

2005-05-21  Mike Kestner  <mkestner@novell.com>

	* audit : add a compatibility auditing framework.
	* audit/base/*.apiinfo : initial checkin of 1.0.10 API for diffs.
	* audit/extract-missing.cs : XPath tool to grab presence='missing'.
	* audit/get-apidiff.pl : diffs api-infos to the base.
	* audit/get-apiinfo.pl : drives a module-wide api-info extraction.
	* audit/get-missing.pl : drives the extract-missing.exe tool.
	* audit/makefile : all and check targets. no dist support.
	* audit/mono-api-info.cs: copied from mcs/tools/corcompare.
	* audit/mono-api-diff.cs: copied from mcs/tools/corcompare.

2005-05-17  Jordi Mas i Hernandez  <jordi@ximian.com>

	* gnome/About.custom: fixes exception when passing null argument

2005-05-16  Mike Kestner  <mkestner@novell.com>

	* makefile.win32 : remove 1.0 csc, default to 1.1.
	* gtk/TreeEnumerator.cs : remove C# 2.0 usage.
	* gtk/glue/makefile.win32 : remove duplicated cellrenderer.o.
	* vte/glue/Makefile.am : use VTE_DEPENDENCIES_CFLAGS.
	* */makefile.win32 : add glue args to generation target.

2005-05-16  Mike Kestner  <mkestner@novell.com>

	* configure.in.in : expand new vte glue makefile.
	* vte/glue/Makefile.am : add GTK_CFLAGS to fix build. Remove
	win32 dist files.

2005-05-16  Dan Winship  <danw@novell.com>

	* generator/StructBase.cs: update field-generation logic a bit

	* generator/CodeGenerator.cs: add a --glue-includes flag

	* generator/GenerationInfo.cs: Accept glue_includes value from
	Main and output it to the glue_filename.

	* generator/FieldBase.cs (Ignored): handle more ignorable cases.
	(CheckGlue): New method to figure out what kind of glue we'll need
	for a field.
	(GenerateImports): generate appropriate imports per CheckGlue.
	(GenerateGlue): Generate C glue for accessing a struct field;
	either a fully-C-based accessor, or a method to just return the
	field's offset in the struct.
	(Generate): Use the generated glue to read the field.

	* generator/PropertyBase.cs (CType): if the field is a single bit,
	set its type to gboolean.

	* generator/ObjectGen.cs (Generate):
	* generator/OpaqueGen.cs (Generate): Call GenFields.

	* generator/StructField.cs: Use FieldBase's glue-generation code
	to handle bitfields. [#54489]

	* generator/ObjectField.cs: Generates accessors for public fields
	of objects and opaque structs. [#69514]

	* generator/ClassBase.cs (ClassBase): Parse <fields> nodes and
	create ObjectField objects.
	(GenFields): Output field properties
	(IgnoreMethod): Ignore Get/Set methods that duplicate fields

	* generator/Makefile.am (sources): update

	* {gdk,gnome,gtk,pango}/*.metadata: Mark some additional fields as
	public. Rename/retype some fields for consistency with earlier
	hand-coded bindings.

	* {gdk,gnome,gtk,pango}/*.custom: Remove custom methods that can
	now be autogenerated.

	* {gdk,gnome,gtk,pango}/glue/*.c: Remove glue methods that can now
	be autogenerated
	
	* {gdk,glade,gnome,gtk,pango,vte}/Makefile.am
	* {gdk,glade,gnome,gtk,pango,vte}/glue/Makefile.am
	* {gdk,gnome,gtk,pango}/glue/makefile.win32: Update

2005-05-15  Ben Maurer  <bmaurer@ximian.com>

	* bootstrap (GTK_SHARP_VERSION): Bump so that Todd's md tarballs
	work. Not yet tagged...

2005-05-13  Mike Kestner  <mkestner@novell.com>

	* gtk/Object.custom : hold refs for all managed subclasses. Release on
	Destroy. Dispose plain wrappers on Destroy also.
	* gtk/Widget.custom : remove the parent set hack since it's "handled"
	on Gtk.Object now.  All this will get fixed properly when we have
	access to owen's toggle_refs.

2005-05-13  Mike Kestner  <mkestner@novell.com>

	* generator/MethodBody.cs : don't create a new destroy notify
	delegate, just use GLib.DestroyHelper.NotifyHandler directly.

2005-05-11  Mike Kestner  <mkestner@novell.com>

	* glib/Object.cs : mark Dispose virtual.
	* gtk/Object.cs : release the Destroy handler in Dispose.

2005-05-11  Mike Kestner  <mkestner@novell.com>

	* configure.in.in : s/-g/-debug

2005-05-11  Mike Kestner  <mkestner@novell.com>

	* gtk/Gtk.metadata : hide IconTheme.GetIconSizes.
	* gtk/IconTheme.custom : implement GetIconSizes because of its zero
	terminated array return value. 2.6 only.  [Fixes #74844]

2005-05-11  Mike Kestner  <mkestner@novell.com>

	* pango/Makefile.am : add file.
	* pango/Units.cs : new class to wrap PANGO_SCALE and PANGO_PIXELS.
	* pango/glue/units.c : accessors for the macros.
	* pango/glue/Makefile.am : build it.
	* pango/glue/makefile.win32 : build it on win.
	[Fixes #74837]

2005-05-11  Eric Butler  <eric@extremeboredom.net>

	* gtk/Gtk.metadata : add IEnumerable iface to ListStore.
	* gtk/ListStore.cs : add GetEnumerator.
	* gtk/Makefile.am : add file.
	* gtk/TreeEnumerator.cs : root node enumerator for a TreeModel.

2005-05-11  Mike Kestner  <mkestner@novell.com>

	* gtk/Widget.custom : manual ListMnemonicLabels implementation to
	return a Widget[].  [Fixes #74786]

2005-05-11  Mike Kestner  <mkestner@novell.com>

	* generator/ObjectGen.cs : default empty assembly names for the
	mapper.  [Fixes #74769]

2005-05-10  Mike Kestner  <mkestner@novell.com>

	* gtk/Object.custom : Dispose on a Destroyed event.
	* gtk/Widget.custom : rework the parent_set hack to go direct to
	the native signal instead of using the event so we avoid rewrapping of
	already destroyed parents.

2005-05-10  Mike Kestner  <mkestner@novell.com>

	* gdk/Pixbuf.custom : use non-obsolete PixbufLoader.Write overload.
	* gdk/PixbufLoader.custom : add obsolete PixbufLoader.Write overload
	for the uint case for backcompat. Update other uses to the new ulong
	overload.
	* sample/GtkDemo/DemoImage.cs : use PixbufLoader.Write (byte[])
	overload.

2005-05-09  Mike Kestner  <mkestner@novell.com>

	* glib/Object.cs : add a try/catch block to g_object_unref calls to
	help identify "extra unref" bugs when exceptions occur.

2005-05-06  John Luke  <john.luke@gmail.com>

	* pango/Makefile.am: add Matrix.custom
	* pango/Matrix.custom: add Pango.Matrix.Identity field
	which is the equivalent of PANGO_MATRIX_INIT
	* sample/GtkDemo/DemoRotatedText.cs: use Pango.Matrix.Identity
	* doc/en/Pango/Matrix.xml: add docs	for Pango.Matrix.Identity
										
2005-05-06  Mike Kestner  <mkestner@novell.com>

	* configure.in.in : always enable debug build in maintainer_mode.

2005-05-06  Mike Kestner  <mkestner@novell.com>

	* gdk/Pixbuf.custom : move the GetCallingAssembly invocations back out
	the the public methods.
	* gdk/PixbufLoader.custom : ditto.

2005-05-06  Mike Kestner  <mkestner@novell.com>

	* bootstrap :
	* bootstrap-2.4 : use ln instead of cp for api files so reparsing
	causes rebuilds.
	* sources/gtk-sharp-2.6-sources.xml : moved from gtk-sharp-sources.xml
	plus fixed the pango, atk, and gdk raw filenames.
	* sources/gtk-sharp-2.4-sources.xml : sources file for 2.4 api.
	* sources/Makefile.am : added 2.4/2.6 targets for api and get-source
	with make api/get-source-code getting/parsing both versions.
	* */*.raw : regenerate

2005-05-06  Jose Faria  <spigaz@gmail.com>

	* gdk/Pixbuf.custom : new width/height ctor overloads.
	* gdk/PixbufLoader.custom : new width/height ctor overloads.

2005-05-04  Mike Kestner  <mkestner@novell.com>

	* autogen.sh : error out with bootstrap help message.
	* bootstrap : replaces autogen.sh for the 2.5.x release line.
	* bootstrap-2.4 : replaces autogen.sh for the 1.9.x release line.
	* configure.in.in : renamed from configure.in and added substitution
	for version, dependencies, CFLAGS and CSFLAGS.
	* README : bootstrap docs
	* */*-api.raw : moved to api-2.6.raw for bootstrapping.
	* */*-api-2.4.raw : added 2.4 api files for bootstrapping.
	* */glue/Makefile.am : add GTK_SHARP_VERSION_CFLAGS.
	* pango/Attribute.cs : add a #if GTK_SHARP_2_6 block.
	* pango/glue/attribute.c : add a couple #ifdef GTK_SHARP_2_6 blocks.
	* sample/GtkDemo/* : make the 2.6 demos conditional.

2005-05-04  Mike Kestner  <mkestner@novell.com>

	* glib/Signal.cs : s/DestroyNotify/SignalDestroyNotify to fix mcs 1.0
	compilation.
	* gdk/Input.custom : ditto.

2005-05-04  Todd Berman  <tberman@off.net>

	* glade/XML.custom: Store the callback wrapper so it doesn't get GC'd.

2005-05-04  Dan Winship  <danw@novell.com>

	* parser/gapi2xml.pl: make note of _get_type methods for enums

	* */*-api.xml: Regen, adding gtype="..." to many enum types

	* generator/EnumGen.cs (Generate): if the enum has the
	"gtype" property, add a GTypeAttribute pointing to an internal
	FooGType class whose GType property can be used to get the enum's
	GType.

	* generator/ObjectGen.cs:
	s/ObjectManager.RegisterType/GType.Register/

	* glib/GTypeAttribute.cs: attribute for indicating a property that
	will return the GType of a type (particularly for enums, which
	can't have GType properties added to them).

	* glib/GType.cs: renamed from Type.cs to match the type name
	(public static readonly GType ...): add a few missing types.
	(Register): moved from ObjectManager.RegisterType
	(LookupGType): moved from TypeConverter.LookupType and extended to
	handle GTypeAttribute. Also, fix mappings for sbyte/byte/char, and
	return specific GTypes for Object subclasses rather than always
	returning GType.Object.	[Fixes #74699]
	(LookupType): moved from ObjectWrapper.LookupType
	(ToString): return the type name
	
	* glib/Object.cs (RegisterGType):
	s/ObjectManager.Register/GType.Register/
	(LookupGType): Make this protected internal so GType can access
	it.

	* glib/ObjectManager.cs (RegisterType): deprecate in favor of
	GType.Register.
	(LookupType): moved to GType
	
	* glib/TypeConverter.cs (LookupType): now a deprecated wrapper
	around GType.LookupGType.

	* glib/Value.cs: Use GType casts rather than TypeConverter

	* gtk/NodeStore.cs (ScanType):
	* gtk/ListStore.custom (ListStore): 
	* gtk/TreeStore.custom (TreeStore): Use (GType) cast rather than
	TypeConverter. Remove the error check and exception, since the
	cast never returns GType.Invalid. (The check probably predates
	GLib.ManagedValue.)

	* gnome/PanelAppletFactory.cs (Register): Use a GType cast rather
	than GLib.Object.LookupGType (which is no longer accessible after
	an mcs bugfix)

	* sample/GtkDemo/DemoIconView.cs (CreateStore): use the Type[]
	constructor rather than the GType[] constructor, since it
	translates typeof(Gdk.Pixbuf) correctly now.

2005-05-04  Dan Winship  <danw@novell.com>

	* generator/Parameters.cs (Parameters.Validate): If the parameters
	end with "callback, gpointer, GDestroyNotify", then mark the
	callback as having "notified" Scope.
	(Parameters.IsHidden): Hide user_data and GDestroyNotify after a
	callback.
	(Parameter.Scope): make this settable
	(Parameter.IsDestroyNotify): new test

	* generator/MethodBody.cs (Initialize): Handle "notified" callback
	scope (using a GCHandle and GLib.DestroyHelper.NotifyHandler)

	* generator/CallbackGen.cs (GenWrapper): Add a static
	"GetManagedDelegate" method to the wrapper type, to translate a
	native delegate back to its corresponding managed delegate.
	(FromNative): use GetManagedDelegate.

	* generator/ReturnValue.cs (Validate): We handle callback return
	values now

	* generator/SymbolTable.cs: marshal GDestroyNotify as
	GLib.DestroyNotify

	* glib/DestroyNotify.cs: Moved from gtk

	* gtk/Gtk.metadata: globally change GtkDestroyNotify to
	GDestroyNotify, but then change back the ones that are exposed in
	the API. Un-hide lots of methods we can correctly autogenerate
	now.

	* gtk/DestroyHelper.cs: moved to glib

	* gtk/*.custom: remove methods that are autogenerated now, add
	Obsolete wrappers where needed, replace Gtk.DestroyHelper usage
	with GLib.DestroyHelper.

	* gdk/Gdk.metadata: 
	* gnome/Gnome.metadata: Turn Gdk.Drawable.SetData and
	Gnome.IconList.SetIconDataFull's GDestroyNotify args into
	gpointers so the generated API stays the same as it used to be.

	* rsvg/Handle.custom: implement deprecated SetSizeCallback

	* sample/GtkDemo/DemoIconView.cs (CreateSort): update for API
	changes

2005-05-03  Mike Kestner  <mkestner@novell.com>

	* parser/gapi2xml.pl : parse const * const * Foo () properly.
	[Fixes #74710]

2005-05-02  Dan Winship  <danw@novell.com>

	* generator/Parameters.cs (IsHidden): method to check if a
	parameter should be hidden in the managed sig (eg, because it's
	user_data, or it's the length of the preceding array/string, etc).
	(VisibleCount): the number of parameters that will actually be
	exposed in the managed signature.
	(IsAccessor): test VisibleCount, not Count
	(AccessorReturnType, AccessorName): deal with the fact that the
	accessor parameter might not be the first one.

	* generator/CallbackGen.cs:
	* generator/Signature.cs: use Parameters.IsHidden.

	* generator/Method.cs (Initialize): set is_set based on
	VisibleCount, not Count.
	(Validate): call base.Validate() before Initialize() so that
	VisibleCount will be correct in Initialize.

	* generator/MethodBody.cs (GetCallString, CallArrayLength,
	Initialize): update to deal with accessors with multiple args.

	* gtk/Clipboard.custom (SetText): implement as an Obsolete variant
	of the Text property

	* gtk/IconTheme.custom (SearchPath, SetSearchPath): obsolete
	SetSearchPath, implement a setter on SearchPath instead.

	* gtk/ListStore.custom (SetColumnTypes):
	* gtk/TreeStore.custom (SetColumnTypes): implement as an Obsolete
	variant of the ColumnTypes property.

	* glade/XML.custom (CustomHandler): implement as a property
	(SetCustomHandler): Mark this obsolete

	* glade/Global.custom (SetCustomHandler): deprecate in favor of
	XML.CustomHandler.

	* gnomedb/Editor.custom (SetText): implement as an Obsolete
	variant of the Text property

2005-05-02  Dan Winship  <danw@novell.com>

	Apply the parts of the generator reorganization from #69514 that
	don't actually affect the generated output
	
	* generator/PropertyBase.cs: new base class for fields and
	properties (mostly containing code formerly in Property.cs).

	* generator/Property.cs: derive from PropertyBase

	* generator/FieldBase.cs: base class for fields (containing some
	code formerly in Field.cs)

	* generator/StructField.cs: class for struct fields (the rest of
	what used to be Field.cs)

	* generator/StructBase.cs: s/Field/StructField/

	* gnome/Gnome.metadata: hide a few _get_ methods that the
	generator is just now noticing, to preserve the old output.

2005-05-02  Mike Kestner  <mkestner@novell.com>

	* generator/Property.cs : fix interface setter generation.
	[Fixes #74766]

2005-04-27  Ben Maurer  <bmaurer@ximian.com>
	
	* */Makefile.am: more build fixes
	
	* configure.in: amd64 build fix

2005-04-26  Miguel de Icaza  <miguel@novell.com>

	* gtkdotnet/Graphics.cs: Contribution from Sebastian Faltoni
	<sebastian.faltoni@gmail.com> that implements support for using
	System.Drawing on Windows.

2005-04-26  Mike Kestner  <mkestner@novell.com>

	* gtk/NodeStore.cs : implement IEnumerable.

2005-04-24  Dan Winship  <danw@novell.com>

	* pango/Attribute.cs: Base class for Pango attributes, a la
	Gdk.Event

	* pango/pango-symbols.xml: explain how to marshal PangoAttribute.

	* pango/AttrBackground.cs:
	* pango/AttrFallback.cs:
	* pango/AttrFamily.cs: 
	* pango/AttrFontDesc.cs:
	* pango/AttrForeground.cs:
	* pango/AttrLanguage.cs:
	* pango/AttrLetterSpacing.cs:
	* pango/AttrRise.cs:
	* pango/AttrScale.cs:
	* pango/AttrShape.cs:
	* pango/AttrSize.cs:
	* pango/AttrStretch.cs:
	* pango/AttrStrikethrough.cs:
	* pango/AttrStrikethroughColor.cs:
	* pango/AttrStyle.cs:
	* pango/AttrUnderline.cs:
	* pango/AttrUnderlineColor.cs:
	* pango/AttrVariant.cs:
	* pango/AttrWeight.cs: subclasses of Attribute, with proper
	constructors. These don't actually correspond one-to-one with
	the underlying types, but they're nicer this way.

	* pango/Pango.metadata: Hide Attribute and its subclasses from the
	generator. Also hide "Attr" (which previously contained
	non-working badly-named static methods to create Attributes)
	and AttrClass (which is not really useful outside of pango
	itself).

	* pango/AttrIterator.custom: use Pango.Attribute.GetAttribute.

	* pango/glue/attribute.c: glue for Attribute and its subclasses

	[Fixes #52575 and its semi-dup #46552]
	
2005-04-22  Dan Winship  <danw@novell.com>

	* gnome/Gnome.metadata: mark GnomeTriggerActionFunction's char**
	param const

	* glib/Marshaller.cs (Utf8PtrToString): Add an IntPtr[]->string[]
	overload, since that's what we actually need in the case where
	it's used (above). Leave the IntPtr[]->string[] overload of
	PtrToStringGFree in case anyone is using it manually.

	* gtk/Gtk.metadata: hide GtkModuleInitFunc and
	GtkModuleDisplayInitFunc; they are the signatures of user-defined
	methods that gtk only ever resolves via g_module_symbol(), so
	they're not useful from C#. (And the marshalling was all wrong
	anyway...)

	* glib/Type.cs: 
	* glib/TypeConverter.cs: 
	* glib/Value.cs: sort lists of GTypes into TypeFundamental order

2005-04-22  Mike Kestner  <mkestner@novell.com>

	* configure.in : bump version to 2.5.0 for trunk.

2005-04-21  Mike Kestner  <mkestner@novell.com>

	* configure.in : require gtk+ 2.6.
	* generator/ReturnValue.cs : invalidate Callback returns for now.
	* gtk/Gtk.metadata : some renames for conflicting new API.
	* parser/gapi2xml.pl : whitespace tweak for class VM regexen.
	* sources/Makefile.am : add new patch, kill atk patch, revise dirs.
	* sources/atkhyperlink.patch : kill unnecessary patch.
	* sources/gtkclipboard.patch : add new clipboard patch.
	* sources/gtk-sharp-sources.xml : parse gtk+-2.6.
	* */*-api.raw : regen pango, atk, gdk, and gtk for new versions.

2005-04-21  Dan Winship  <danw@novell.com>

	* parser/gapi_pp.pl: add "#if 0" to $eatit_regex

	* gdk/EventClient.cs (gtksharp_gdk_event_client_get_time):
	* glib/Object.cs (gtksharp_get_type_id):
	* glib/Value.cs (gtksharp_object_get_ref_count,
	g_value_take_boxed): 
	* gnome/PrintContext.custom (gnome_print_concat,
	gnome_print_glyphlist, gnome_print_setdash):
	* gtk/NodeStore.cs (gtksharp_node_store_new, stamp):
	* gtk/NodeView.cs (gtk_tree_view_new_with_model):
	* gtk/Widget.custom (gtksharp_gtk_widget_set_allocation):
	* pango/LayoutLine.custom (g_free): Remove unused
	prototypes/fields

2005-04-21  Mike Kestner  <mkestner@novell.com>

	* Makefile.include : make mcs shaddup about 169.

2005-04-20  Mike Kestner  <mkestner@novell.com>

	* generator/*.cs : cleanup the unused private member warnings.

2005-04-20  Mike Kestner  <mkestner@novell.com>

	* parser/gapi-parser.cs : add a directory element with child exclude
	elements to simplify source version updating. 
	* sources/gtk-sharp-sources.xml : switch to directory elements.

2005-04-19  Mike Kestner  <mkestner@novell.com>

	* gdk/Gdk.metadata : add a None member to ModifierType and fix the
	definition for ModifierMask since the parser barfs on it. 
	[Fixes #74594]

2005-04-17  Jeroen Zwartepoorte  <jeroen.zwartepoorte@gmail.com>

	* sample/PolarFixed.cs: (PolarFixed.PolarFixedChild): Fix compilation
	problem.

2005-04-15  Mike Kestner  <mkestner@novell.com>

	* configure.in : remove unnecessary libxml check.
	* parser/gapi-parser.cs : use a System.Xml to kill gapi_format_xml.
	* parser/formatXml.c : kill.
	* parser/Makefile.am : kill gapi_format_xml
	* */*-api.raw : enormous whitespace diff. sorry dawgs on mono-patches.

2005-04-15  Mike Kestner  <mkestner@novell.com>

	* parser/gapi-parser.cs : C# rewrite of the old perl driver script.
	* parser/gapi_parser.pl : kill.
	* parser/gapi2-parser.in : invoke via $(RUNTIME).
	* parser/Makefile.am : build rework for C# parser driver.
	* sources/Makefile.am : use $(RUNTIME) to invoke new parser assm.

2005-04-12  Mike Kestner  <mkestner@novell.com>

	* configure.in : bump version to 1.9.3 and tag.

2005-04-11  Mike Kestner  <mkestner@novell.com>

	* gdk/Pixbuf.custom : fix out params on RenderPixmapAndMask* methods.

2005-04-11  Dan Winship  <danw@novell.com>

	* generator/ClassBase.cs (ParseImplements): record both managed
	and unmanaged interface declarations.
	(Implements): check recursively

	* generator/ObjectGen.cs (Generate): output managed interfaces

	* gtk/Gtk.metadata: make Container implement IEnumerable

	* gtk/Container.custom (GetEnumerator): implement (a simplified
	form of Children).
	(AllChildren): add this (which accumulates the results of
	Forall()).
	(ForAll): mark ForAll(bool,CallbackInvoker) obsolete and add a
	ForAll(bool,Gtk.Callback) overload to replace it.

	* sample/PolarFixed.cs: new silly but fully-functional demo of
	how to subclass container.

	* sample/CustomNotebook.cs: kill this, since it was really
	complicated, and never fully functional.

	* sample/GtkDemo/DemoImages.cs (ToggleSensitivity): Use foreach
	directly on the container, rather than on its .Children.

2005-04-11  Mike Kestner  <mkestner@novell.com>

	* gtk/Quit.custom : obsolete AddFull and implement Add properly.
	* gtk/TreePath.custom : add ctor (int[] indices).
	* gtk/Gtk.metadata : hide Quit.Add* and some ellipsis methods that are
	implemented manually already.

2005-04-08  Dan Winship  <danw@novell.com>

	* configure.in: Add an --enable-debug flag, to build .mdb files
	for all of the assemblies

	* Makefile.include:
	* gconf/GConf/Makefile.am:
	* gconf/GConf.PropertyEditors/Makefile.am:
	* glib/Makefile.am:
	* gtkdotnet/Makefile.am (CLEANFILES): add $(ASSEMBLY).mdb
	$(ASSEMBLY): build with $(CSFLAGS). Always delete $(ASSEMBLY).mdb
	before building $(ASSEMBLY), so that if you first build with
	debugging enabled, then update, then rebuild without debugging
	enabled, you don't end up with an out-of-date .mdb file.

2005-04-08  Alp Toker  <alp@atoker.com>

	* atk/makefile.win32: gapi-cdecl-insert was called in the wrong place
	and broke the win32 build.

2005-04-07  Dan Winship  <danw@novell.com>

	* gtk/Object.custom (Raw): Always ref the object, even if it's not
	floating when we get it, since GLib assumes we hold a ref on it.
	[Fixes #74468]

	* gtk/Window.custom: remove refcount special-handling here

2005-04-06  Mike Kestner  <mkestner@novell.com>

	* gtk/FileFilter.custom : AddCustom delegate is destroy notified.
	* gtk/Gtk.metadata : hide FileFilter.AddCustom.  hide gtk_object_get|set.

2005-04-05  Mike Kestner  <mkestner@novell.com>

	* gtk/*.custom : persistent delegates for most of the remaining 
	"interesting" methods.

2005-04-05  Dan Winship  <danw@novell.com>

	* gdk/PixbufLoader.custom: Fix the new constructors to make sure
	they call Close() in the event of an exception, to prevent a
	g_warning.

2005-04-05  Mike Kestner  <mkestner@novell.com>

	* gtk/DestroyHelper.cs : implement an internal DestroyNotify handler 
	to release GCHandles.
	* gtk/*.custom : rework existing persistent delegate implementations
	to use destroy notify or PersistentData.

2005-04-05  Alp Toker  <alp@atoker.com>

	* gtk/Menu.custom: don't re-implement the Screen getter in Gtk.Menu.
	Instead just return base.Screen, which is implemented by Widget.

2005-04-04  Dan Winship  <danw@novell.com>

	* pango/Scale.cs: rename the size constants to not have
	underscores in their names (and add obsolete aliases for the old
	names).

	* sample/GtkDemo/DemoTextView.cs: use the new names

2005-04-04  Mike Kestner  <mkestner@novell.com>

	* gtk/Gtk.metadata : mark all the call scope callback params to quiet
	the warnings.

2005-04-04  Mike Kestner  <mkestner@novell.com>

	* gdk/Gdk.metadata : hide some manually implemented callback methods.
	* gdk/*.custom : implement several methods containing persistent
	callback parameters.
	* generator/BoxedGen.cs : set gen_info.CurrentType in Generate.
	* generator/ClassGen.cs : set gen_info.CurrentType in Generate.
	* generator/Ctor.cs : set gen_info.CurrentMember in Generate.
	* generator/GenerationInfo.cs : add CurrentMember and CurrentType.
	* generator/Method.cs : set gen_info.CurrentMember in Generate.
	* generator/MethodBody.cs : always generate null guarding for array
	parameters, and add a nag for callback parameters without a scope attr.
	* generator/ObjectGen.cs : set gen_info.CurrentType in Generate.
	* generator/OpaqueGen.cs : set gen_info.CurrentType in Generate.
	* generator/Parameters.cs : kill NullOk. add Scope property.
	* generator/StructGen.cs : set gen_info.CurrentType in Generate.
	* gtk/Gtk.metadata : kill a few null_ok attrs.
	* pango/Pango.metadata : mark the callback params as call scope. kill
	a couple null_ok attrs.

2005-04-01  Dan Winship  <danw@novell.com>

	* samples/GtkDemo/*.cs: General fixup and cleanup; Remove some
	gratuitous differences from the C version. Make comment and indent
	style consistent. Don't use "this." where not needed. Override
	OnDeleteEvent rather than connecting one's own DeleteEvent signal.

	* sample/GtkDemo/DemoApplicationWindow.cs (static
	DemoApplicationWindow): register the Gtk logo icon with
	StockManager so it shows up correctly in the toolbar.
	(AddActions): Register the radio items as radio items so they work
	right.

	* sample/GtkDemo/DemoHyperText.cs (EventAfter): handle
	link-clicking from Widget.WidgetEventAfter (as in the C version),
	rather than ButtonRelease, now that WidgetEventAfter is wrapped.

	* sample/GtkDemo/DemoImages.cs (DemoImages): use
	Gtk.Image.LoadFromResource (particularly to make the animation
	work right).
	(OnDestroyed): handle clean up (remove the timeout, etc)

	* sample/GtkDemo/DemoMain.cs (LoadStream): Fix handling of blank
	lines and whitespace to match the C version.

	* sample/GtkDemo/DemoPixbuf.cs (Expose): Use
	System.Runtime.InteropServices.Marshal.Copy() to copy
	pixbuf.Pixels to pass to DrawRgbImageDithalign, to make this more
	like the C version (and probably faster?)
	(timeout): Remove the FIXME since it seems to work now

	* sample/GtkDemo/DemoStockBrowser.cs: Simplify a bunch. Use
	reflection to get the C# names of the stock icons rather than
	trying to correctly re-mangle the ids. Display the Label with the
	accelerator underlined.

	* sample/GtkDemo/DemoTextView.cs (AttachWidgets): use
	Gtk.Image.LoadFromResource, so the image is properly loaded as an
	animation, not a static image. Don't set the combobox's "Active"
	property (for consistency with the C version).
	(InsertText): Fix miscellaneous differences with the C version.
	Remove some leftover cruft from earlier workarounds for gtk# bugs.

	* sample/GtkDemo/DemoTreeStore.cs (AddColumns): Make this more
	like the C version so the checkboxes are sensitized and hidden
	correctly on a per-row basis.

	* sample/GtkDemo/DemoUIManager.cs: Make the radio menu items work.

	* sample/GtkDemo/README: 
	* sample/GtkDemo/TODO: update

2005-04-01  Mike Kestner  <mkestner@novell.com>

	* gtk/TreeModelFilter.custom : manually implement SetVisibleFunc and
	SetModifyFunc to handle delegate persistence.
	* gtk/Gtk.metadata : hide methods.

2005-04-01  Mike Kestner  <mkestner@novell.com>

	* gtk/Clipboard.custom : manually implement SetWithData and
	SetWithOwner to handle delegate persistence.
	* gtk/Gtk.metadata : hide methods.

2005-03-31  Dan Winship  <danw@novell.com>

	* gdk/PixbufLoader.custom: Implement System.IO.Stream and
	resource-file constructors (using code formerly in Pixbuf.custom)

	* gdk/Pixbuf.custom: Redo the stream and resource ctors in terms
	of the PixbufLoader ones.

	* gdk/PixbufAnimation.custom: Add stream and resource ctors

	* gtk/Image.custom: Add stream and resource ctors

2005-03-31  Mike Kestner  <mkestner@novell.com>

	* glib/ManagedValue.cs : add null/NULL guarding to Copy, Free, 
	WrapObject, and ObjectForWrapper.  [Fixes #74197]

2005-03-30  Jeroen Zwartepoorte  <jeroen@xs4all.nl>

	* parser/gapi2xml.pl : parse gst type macros.

2005-03-30  Anthony Taranto  <voltron@emptyrhetoric.com>

	* gtk/Widget.custom : cause Allocation.Set to call SizeUpdate().
	* gtk/glue/widget.c : remove gtksharp_gtk_widget_set_allocation().

2005-03-29  Mike Kestner  <mkestner@novell.com>

	* gtk/TreeStore.custom : fix a CLS incompliance in the Append
	Prepend, Insert, InsertBefore, and InsertAfter methods by obsoleting
	them and adding new *Node methods that are CLS compliant.
	[Fixes #73876]

2005-03-29  Mike Kestner  <mkestner@novell.com>

	* generator/Parser.cs : add symbol type='marshal' support.
	* gdk/Event.cs : add GetEvent method to wrap arbitrary events.
	* gdk/gdk-symbols.xml : make Event, EventAny, and EventNoExpose
	marshal symbols using Event.GetEvent (). [Fixes #74184]

2005-03-29  Mike Kestner  <mkestner@novell.com>

	* glib/Marshaller.cs : special case ucs4 "0" conversion.
	[Fixes #74175]

2005-03-28  Mike Kestner  <mkestner@novell.com>

	* gdk/Pixbuf.custom  : add FromDrawable static method and obsolete
	CreateFromNative, which should've been static.  [Fixes #74155]

2005-03-28  Mike Kestner  <mkestner@novell.com>

	* generator/Signal.cs  : Dispose the values passed to 
	g_signal_chain_from_overriden in base VM invocations. [Fixes #73522]

2005-03-25  Mike Kestner  <mkestner@novell.com>

	* */makefile.win32 : add gapi-cdecl-insert to assembly target.

2005-03-25  Mike Kestner  <mkestner@novell.com>

	* generator/CallbackGen.cs : add CDeclCallback attrs to native dels.
	* generator/Signal.cs : add CDeclCallback attrs to native dels.

2005-03-25  Mike Kestner  <mkestner@novell.com>

	* */*.cs : tag native callback delegates with [CDeclCallback].
	* */*.custom : tag native callback delegates with [CDeclCallback].

2005-03-24  Mike Kestner  <mkestner@novell.com>

	* generator/CallbackGen.cs : don't create native delegates for nulls.
	* generator/ObjectGen.cs : revamp the ObjectManager code.
	* glib/Object.cs : use new ObjectManager.RegisterType overload.
	* glib/ObjectManager.cs : rewrite to kill the lameass LoadWithPartial
	hack and keep a GType to Type mapping for quicker lookup/activation.

2005-03-23  Mike Kestner  <mkestner@novell.com>

	* gapi-cdecl-insert : a little perl script to insert modopts
	* Makefile.am : dist the new script.
	for cdecl callback delegates on win32.
	* glade/makefile.win32 : use gapi-cdecl-insert
	* glade/XML.custom : add [GLib.CDeclCallback] to RawXMLConnectFunc.
	* glib/Makefile.am : add new file.
	* glib/makefile.win32 : use gapi-cdecl-insert
	* glib/CDeclCallbackAttribute.cs : new attr to tag delegates with
	that will be invoked from native code. We have to mangle the il
	with a modopt otherwise they are stdcall'd.
	* glib/ManagedValue.cs : add [GLib.CDeclCallback] to Copy/Free.
	switch to using GCHandles instead of the current IntPtr hack.

2005-03-15  Mike Kestner  <mkestner@novell.com>

	* gtk/Gtk.metadata : hide TreeSortable.SetSortFunc.
	* gtk/ListStore.custom : implement SetSortFunc for persistence.
	* gtk/Makefile.am : add custom file.
	* gtk/TreeModelSort.custom : implement SetSortFunc for persistence.
	* gtk/TreeSortable.custom : new file, add hidden method decls.
	* gtk/TreeStore.custom : implement SetSortFunc for persistence.

2005-03-15  John Luke  <john.luke@gmail.com>

	* glib/Object.cs: use IsDefined to check for ClassInitializer
	attribute, fixes a warning and is supposedly better for performance

2005-03-15  Dan Winship  <danw@novell.com>

	Re-fix for yesterday's fix that didn't actually work.

	* gtk/ITreeNode.cs: add a "child" arg to TreeNodeRemovedHandler

	* gtk/TreeNode.cs (RemoveChild, OnChildRemoved): update for that

	* gtk/NodeStore.cs (child_deleted_cb): use the passed-in child;
	GetNodeAtPath won't work because the parent node already removed
	the child from its list

2005-03-14  Mike Kestner  <mkestner@novell.com>

	* configure.in : rework the gtkhtml check for 3.6.

2005-03-14  Dan Winship  <danw@novell.com>

	* gtk/TreeNode.cs (AddNode): add an overload that takes a position

	* gtk/NodeStore.cs (AddNode): likewise
	(AddNode, child_added_cb): when adding a node, recursively connect
	to the node signals on its children
	(RemoveNode, child_deleted_cb): when removing a node, recursively
	remove its children from node_hash.

2005-03-12  Mike Kestner  <mkestner@novell.com>

	* glade/Glade.metadata : mark the XMLCustomWidgetHandler string params
	const-gchar*.  Wonder how many of these are gonna screw us?

2005-03-12  Mike Kestner  <mkestner@novell.com>

	* gtk/TreeViewColumn.custom : use PersistentData to hold the 
	CellDataFuncs.

2005-03-12  Mike Kestner  <mkestner@novell.com>

	* glib/Makefile.am : add new file.
	* glib/Object.cs : add protected PersistentData hash to hold data
	across GC cycles.
	* glib/WeakObject.cs : new object to hold managed refs weakly against
	the native object.
	* gtk/ListStore.custom : hold refs for DefaultSortFuncs.
	* gtk/TreeModelSort.custom : hold refs for DefaultSortFuncs.
	* gtk/TreeStore.custom : hold refs for DefaultSortFuncs.

2005-03-12  Mike Kestner  <mkestner@novell.com>

	* generator/CallbackGen.cs : don't derive Wrappers from DelegateWrapper
	any more.  It leaks delegates like crazy. We effectively now use call
	scope as the default for delegate parameters.
	* generator/MethodBody.cs : use new simpler Wrapper ctor.
	* glib/DelegateWrapper.cs : mark the ctor obsolete so people know to
	update any manually coded wrappers out there.
	* */*.custom : use new simpler Callback Wrapper ctors.

2005-03-11  Mike Kestner  <mkestner@novell.com>

	* glib/DelegateWrapper.cs : call g_object_set_data_full since we are
	using its sig, not set_data.

2005-03-10  Mike Kestner  <mkestner@novell.com>

	* generator/SymbolTable.cs : fix gssize and gsize, they aren't 32 bit
	like the docs say they are.

2005-03-10  Mike Kestner  <mkestner@novell.com>

	* glib/Marshaller.cs : don't use g_utf8_strlen to determine the byte
	count to be copied, it returns chars, not bytes.
	* glib/glue/unichar.c : implement a quick and dirty strlen glue func.

2005-03-10  Mike Kestner  <mkestner@novell.com>

	* gtk/Style.custom : add bg_pixmap accessors. remove IntPtr[] vars
	and s/6/5 for array sizes.
	* gtk/glue/style.c : add bg_pixmap field glue.
	[Fixes #73532]

2005-03-09  Mike Kestner  <mkestner@novell.com>

	* */*.custom : scrub for string usage in DllImports.
	* gnome/Makefile.am : remove IconTheme.custom, it's not generated.

2005-03-09  Mike Kestner  <mkestner@novell.com>

	* glib/Marshaller.cs : add IntPtr.Zero guarding.

2005-03-09  Alexandre Gomes  <alexmipego@hotmail.com>

	* gtk/Gtk.metadata: Set GetVisibleRect param to be passed as out.

2005-03-08  Mike Kestner  <mkestner@novell.com>

	* */*.cs : scrub for StringToPtrAnsi and string usage in DllImports.
	* */*.custom : begin the scrub here too.
	* generator/ConstStringGen.cs : implement IManualMarshaler and move to
	100% IntPtr marshaling.
	* generator/Ctor.cs : call Body.Finish too.
	* generator/IManualMarshaler.cs : new interface for generatables that
	marshal manually and need cleanup.
	* generator/Makefile.am : new file.
	* generator/MethodBody.cs : use IManualMarshaler if applicable.

2005-03-07  Mike Kestner  <mkestner@novell.com>

	* generator/MethodBody.cs : remove an unused var.
	* generator/ReturnValue.cs : privatize a couple props. Refactor the
	SymbolTable lookup logic to be generatable based.

2005-03-04  Mike Kestner  <mkestner@novell.com>

	* generator/ImportSignature.cs : out param handling fix.
	* generator/Makefile.am : kill StringGen.cs.
	* generator/MethodBody.cs : simplify out param handling.
	* generator/StringGen.cs : kill it, now using MarshalGen.
	* generator/SymbolTable.cs : make non-const strings use an appropriate
	MarshalGen.  Non-const strings are now correctly marshaled as Utf8.
	* glib/Marshaller.cs : add some utf8-fu for strdup/free marshaling.
	Add a method to alloc/copy structs to native memory, unused yet.
	* gtk/Gtk.metadata : partially fix a broken delegate.

2005-03-04  Mike Kestner  <mkestner@novell.com>

	* generator/Method.cs : refactor out some retval logic.
	* generator/ReturnValue.cs : add FromNative and IsVoid members.

2005-03-03  Mike Kestner  <mkestner@novell.com>

	* gdk/Gdk.metadata : remove unnecessary null_ok rules.
	* generator/Ctor.cs : don't add null params to CreateNativeObject call
	for InterfaceGen or OpaqueGen in addition to ObjectGen.
	* generator/Field.cs : simplify Object/Opaque gen.
	* generator/Method.cs : remove OpaqueGen special casing.
	* generator/OpaqueGen.cs : make FromNative null_ok robust.
	* generator/Signal.cs : remove arg marshaling ClassBase special case.
	* gtk/Gtk.metadata : remove unnecessary null_ok rules.

2005-03-03  Mike Kestner  <mkestner@novell.com>

	* generator/ClassBase.cs : use "as" instead of a cast in FromNative.
	* generator/Method.cs : remove the if/else checks for Object retvals.
	* glib/Object.cs : return null immediately for NULL in GetObject.

2005-03-03  Mike Kestner  <mkestner@novell.com>

	* generator/ClassBase.cs : add null checking to CallByName. No sense
	manually adding this for the ones that need it. Better to have g_criticals
	then NullRefExceptions anyway.
	* generator/MethodBody.cs : simplify out handle generation.
	[A babystep toward #68820]

2005-02-28  Dan Winship  <danw@novell.com>

	* gtk/Container.custom (ChildType): fix this to just call
	gtk_container_child_type().

	* gtk/glue/container.c (gtksharp_container_base_child_type): kill

2005-02-28  Mike Kestner  <mkestner@novell.com>

	* glib/Idle.cs : add locking on the source_handlers.
	* glib/Source.cs : add locking on the source_handlers.
	* glib/Timeout.cs : add locking on the source_handlers.

2005-02-25  Mike Kestner  <mkestner@novell.com>

	* glib/Source.cs : remove from the hash by key.
	* glib/Idle.cs : remove from the hash by key.

2005-02-23  Dan Winship  <danw@novell.com>

	* sources/gnomedb.patch: Patch over a bug in gnome-db-editor.h

	* gnomedb/gnomedb-api.raw: Regen

2005-02-23  Dan Winship  <danw@novell.com>

	* parser/gapi2xml.pl (parseTypeToken): don't parse punctuation
	into the type name. [Fixes #72925]

	* gtk/gtk-api.raw: Regen, exposing the previously-broken
	AccelGroup.AccelActivate, AccelMap.Changed,
	ActionGroup.ConnectProxy, ActionGroup.DisconnectProxy,
	ActionGroup.PreActivate, ActionGroup.PostActivate, and
	Widget.EventAfter.

	* gtk/Gtk.metadata: Give proper names to the parameters of those
	signals

2005-02-23  Dan Winship  <danw@novell.com>

	* generator/Field.cs (Validate): new, to check that a field has a
	valid type (or is hidden).

	* generator/StructBase.cs (Validate): new, to check that all of
	the struct fields have valid types

	* generator/BoxedGen.cs (Generate):
	* generator/StructGen.cs: (Generate): Call Validate() and bail out
	if it fails; it's no good to generate a struct with the wrong
	layout.

	* gdk/gdk-symbols.xml: add a line for GdkKey -> Gdk.Key. (There's
	no actual C type GdkKey, but we can use metadata to change uints
	to GdkKeys, which will then become Gdk.Keys.)

	* gtk/AccelKey.custom: remove the "Key" field (which was being
	added in the wrong place in the struct), since it's properly
	generated now.

	* gtk/Gtk.metadata: Fix the line that renames AccelKey.AccelKey
	to AccelKey.Key

	* gnomevfs/Gnomevfs.metadata: hide the (mis-parsed) "action" field
	in MimeAction, leaving the struct in the same broken state it was
	in with the old generator code

	* parser/gapi2xml.pl: add a hack to allow "foo_bar_get_type()"
	rather than "FOO_TYPE_BAR" in G_TYPE_CHECK_INSTANCE_CAST macros,
	allowing large parts of libgda that were previously misparsed to
	be parsed correctly

	* gda/gda-api.raw: Regen

	* gda/Gda.metadata: Make Gda.Value opaque, since it's mostly a
	union and we're horribly butchering its layout.

2005-02-22  Raja R Harinath  <rharinath@novell.com>

	* Makefile.include: Use $(top_builddir)/ instead of ../ so that it
	is usable from directories two-or-more deep.

2005-02-18  Mike Kestner  <mkestner@novell.com>

	* gtk/Gtk.metadata : remove an incorrect and harmful rule on 
	ClipboardGetFunc.  [Fixes #69013]

2005-02-17  Mike Kestner  <mkestner@novell.com>

	* */Makefile.am : define SYMBOLS if it isn't already to fix breakage
	with older automakes. 

2005-02-15  Dan Winship  <danw@novell.com>

	* generator/ObjectGen.cs (GenChildProperties): If the class has an
	ancestor that also defines child properties, make its child
	properties class be a subclass of that ancestor's child properties
	class. (Eg, make Gtk.ButtonBox.ButtonBoxChild be a subclass of
	Gtk.Box.BoxChild.)

2005-02-14  Mike Kestner  <mkestner@novell.com>

	* gdk/Gdk.metadata : mark the color in Rgb.FindColor ref.

2005-02-11  Mike Kestner  <mkestner@novell.com>

	* gtk/Gtk.metadata : hide Menu.SetScreen.
	* gtk/Menu.custom : manually implement Screen prop.

2005-02-11  Dan Winship  <danw@novell.com>

	* gtk/Gtk.metadata: Hide StyleGetProperty and StyleGetValist since
	they're generated wrong, and StyleGet to avoid an ellipsis
	warning. (Also hide the deprecated ellipsis method "Set".)

	* gtk/Widget.custom (StyleGetProperty): implement manually, a la
	Gtk.Container.ChildGetProperty.

	* gtk/glue/widget.c (gtksharp_widget_style_get_property): glue for that

	* generator/MethodBase.cs (Validate): use CName rather than always
	saying "in ctor"

2005-02-10  Jeroen Zwartepoorte  <jeroen@xs4all.nl>

	* sample/Actions.cs: Remove obsolete & unsafe GLib.Object.Data usage.

2005-02-10  Mike Kestner  <mkestner@novell.com>

	* configure.in : update version for 1.9.2 release.

2005-02-09  Mike Kestner  <mkestner@novell.com>

	* gtk/Widget.custom : use a static method for the ParentSet hack
	so we don't leak objects because the delegate holds an object ref.

2005-02-07  Ben Maurer  <bmaurer@ximian.com>

	* gdk/Point.custom, gdk/Rectangle.custom: misc. new apis to make
	this more like the S.D structs.

2005-02-03  Mike Kestner  <mkestner@novell.com>

	* gtk/NodeStore.cs : use CreateNativeObject to allow subclassing.
	[Fixes #71749]

2005-02-03  Mike Kestner  <mkestner@novell.com>

	* glib/ObjectManager.cs (GetValidParentType): return null if
	G_TYPE_INVALID is returned from glue. [Fixes #72150]

2005-02-02  Mike Kestner  <mkestner@novell.com>

	* generator/Signal.cs : kill unnecessary BaseName prop.

2005-02-02  Mike Kestner  <mkestner@novell.com>

	* generator/Makefile.am : remove source file.
	* generator/Signal.cs : generate marshaling callbacks and use new
	GLib.Signal marshaling class for events.
	* generator/SignalHandler.cs : kill. byebye SignalCallback subclasses.
	* glib/Makefile.am : update source files.
	* glib/GLibSharp.voidObjectIntPtrSignal.cs : kill.
	* glib/Object.cs : mark the old Before/After props Obsolete. Use
	GLib.Signal for the notify prop methods.
	* glib/Signal.cs : new signal marshaling class.  It manages all the 
	ConnectBefore/After stuff internally and connects itself to the native
	object using GCHandles and DestroyNotify lifecycle management.
	* glib/SignalCallback.cs : mark Obsolete.
	[Fixes #72018 and #69847]

2005-02-01  Fredrik Nilsson  <jymdman@home.se>

	* glib/Marshaller.cs : DateTime marshaling fix.

2005-01-31  Mike Kestner  <mkestner@novell.com>

	* gtk/FileChooserDialog.custom : move backend to first param to
	avoid conflicts with button names in overloaded ctor.

2005-01-31  Mike Kestner  <mkestner@novell.com>

	* generator/SymbolTable.cs : handle unsigned-*.
	* parser/gapi2xml.pl : handle const unsigned * parameters. Also fix
	a G_GNUC_PRINTF parsing bug exposed by a GMime.
	* */*-api.raw : regen.
	[Fixes #71825]

2005-01-28  Mike Kestner  <mkestner@novell.com>

	* generator/ReturnValue.cs : use ToNativeReturnType for ToNativeType
	instead of MarshalType.
	* generator/Signal.cs : deal with boxed return values. beef up return
	handling in the default handler generation code.
	* generator/SignalHandler.cs : use ToNative return types for native 
	callbacks. Remove redundant casting/conversion in callback impl.
	[Fixes #71899]

2005-01-28  Dan Winship  <danw@novell.com>

	* glib/Object.cs (AddNotification, RemoveNotification): methods to
	subscribe to the "notify" signal (with property details). [#71684]
	* glib/GLibSharp.voidObjectIntPtrSignal.cs: autogenerated, for
	notifications
	* glib/NotifyHandler.cs: sort of autogenerated

2005-01-28  Mike Kestner  <mkestner@novell.com>

	* gtk/Dialog.custom : add a params array for button info to the ctor.
	* gtk/FileChooserDialog.custom : add a params array for button info to 
	both ctors.  Chain them to IntPtr.Zero.
	* gtk/Gtk.metadata : hide the ellipsis ctors for the dialog types.
	[Fixes #71818]
	* sample/GtkDemo/DemoDialog.cs : make the InteractiveDialog use the
	new Dialog ctor as it does in the c version.

2005-01-27  Mike Kestner  <mkestner@novell.com>

	* gtk/NodeSelection.cs : use new GetSelectedRows() overload.
	* gtk/TreeSelection.custom : add a GetSelectedRows overload without the
	out model param. [Fixes #71814]

2005-01-27  Mike Kestner  <mkestner@novell.com>

	* gtk/NodeView.cs : fix the value creation in the ctor.

2005-01-26  Mike Kestner  <mkestner@novell.com>

	* glib/Value.cs : add a private debugging DllImport for ref_counts
	since the glue is there already.  g_value_get_object returns an
	unowned ref, so don't pretend like we own it. Make get_Val work for
	GObject subclasses. [Fixes #71125]

2005-01-26  Mike Kestner  <mkestner@novell.com>

	* gtk/NodeView.cs : always use CreateNativeObject.

2005-01-26  Mike Kestner  <mkestner@novell.com>

	* gtk/Gtk.metadata : hide 3 IM related internal types. [Fixes #71021]

2005-01-26  Mike Kestner  <mkestner@novell.com>

	* generator/*.cs : refactoring of Parameters class. Added IEnumerable
	to Parameters and gracefully handle elem == null instead of special
	casing parms == null all over the place. Parameter logic is now Count
	driven. [Fixes #71750]

2005-01-26  Dan Winship  <danw@novell.com>

	* generator/Property.cs (Generate): Remove a redundant WriteLine (that
	resulted in there being 2 blank lines before every property).

	* generator/Signal.cs (Generate): s/Write/WriteLine/ to fix a
	weirdly-formatted if statement in the generated code.

2005-01-25  John Luke  <john.luke@gmail.com>

	* sample/CustomNotebook.cs:
	* sample/CustomWidget.cs: use Widget.WidgetFlags prop to avoid
	obsolete warning

2005-01-25  Mike Kestner  <mkestner@novell.com>

	* gnome/About.custom : implement a subclassable ctor.
	* gnome/Gnome.metadata : hide About ctor, fix About.Construct parms.
	* gnome/Makefile.am : add the new custom.
	[Fixes #71271]

2005-01-25  Mike Kestner  <mkestner@novell.com>

	* gdk/Gdk.metadata : hide all the Pixbuf.SaveTo methods.
	* gdk/Pixbuf.custom : implement the SaveTo methods.
	[Fixes #71430]

2005-01-25  Mike Kestner  <mkestner@novell.com>

	* gtk/Gtk.metadata : hide all the SignalFunc using Toolbar methods.
	* gtk/Makefile.am : add the new custom.
	* gtk/Toolbar.custom : implement the SignalFunc methods. Deal with
	null for Widget params in *Element.
	[Fixes #71428]

2005-01-24  Jeroen Zwartepoorte  <jeroen@xs4all.nl>

	* generator/MethodBody.cs : fix out LPUGen params.

2005-01-24  Mike Kestner  <mkestner@novell.com>

	* gda/Makefile.am : add new custom.
	* gda/XmlConnection.custom : add backcompat static ctor.
	* generator/ClassBase.cs : refactor lookup logic to here from Ctor
	and improve the collision resolution.
	* generator/Ctor.cs : refactor to use MethodBase.
	* generator/Makefile.am : add new file.
	* generator/MethodBase.cs : new base class for ctors and methods.
	* generator/Method.cs : refactor to use MethodBase.
	* generator/StructBase.cs : move some logic from here to Ctor.
	* gnome/CanvasPathDef.custom : add backcompat static ctor.
	* gnome/GPPath.custom : add backcompat static ctor.
	* gnome/Makefile.am : add new custom.
	* gtk/Gtk.metadata : mark a colliding Button ctor shared.

2005-01-23  Jeroen Zwartepoorte  <jeroen@xs4all.nl>

	* gtk/ActionGroup.custom: Add a string index for the GetAction method.

2005-01-20  Dan Winship  <danw@novell.com>

	* glib/Marshaller.cs (StringFormat): Calls String.Format and makes
	sure the output has no unescaped "%"s. (For wrapping printf-style
	unmanaged methods with String.Format-style managed ones.)

	* gtk/MessageDialog.custom (MessageDialog): use it. #71405. Also,
	use gtk_message_dialog_new_with_markup by default, and add an
	overloaded ctor that lets you use the non-markup version.

	* gtk/Gtk.metadata: hide the GtkMessageDialog ctors so we don't
	get ellipsis warnings about them.

	* sample/GtkDemo/DemoApplicationWindow.cs:
	* sample/GtkDemo/DemoDialog.cs: simplify the MessageDialog usage;
	don't need to call String.Format separately now.

2005-01-18  Mike Kestner  <mkestner@novell.com>

	* generator/Method.cs : deal with owned retvals.
	* generator/ReturnValue.cs : add Owned prop.
	* gnome/Gnome.metadata : mark Thumbnail.ScaleDownPixbuf return owned.
	[Fixes #71335]

2005-01-18  Mike Kestner  <mkestner@novell.com>

	* gtk/gtk-api.raw : regen.
	* parser/gapi2xml.pl : deal with G_GNUC_PRINTF.

2005-01-17  Mike Kestner  <mkestner@novell.com>

	* gtk/Style.custom : add Light, LightColors, Mid, MidColors, Dark,
	and DarkColors.
	* gtk/glue/style.c : add get_light and get_dark

2005-01-17  Mike Kestner  <mkestner@novell.com>

	* gtk/Gtk.metadata : hide Stock.
	* gtk/Makefile.am : add new file.
	* gtk/StockManager.cs : stock item management methods.

2005-01-14  Dan Winship  <danw@novell.com>

	* glib/Object.cs (ConnectDefaultHandlers): Don't call a signal's
	ConnectionMethod if it's already been called for a superclass of
	the current class. #71278

2005-01-13  Zac Bowling  <zac@zacbowling.com>

	* makefile.win32 : new "gac" target for automatic for gacutil calls,
	added copying of gtk-sharp.snk to each folder being built to fix fresh
	builds and after cleaning, added support for switching C#
	compilers, and added handling of spaces in filenames for mcs builds
	* gtkdotnet/makefile.win32 : add one more reference to fix mcs builds.
	
2005-01-13  Mike Kestner  <mkestner@novell.com>

	* configure.in : make vte check conditional on gnome.
	* gtkdotnet/Makefile.am : add some references.

2005-01-13  Dan Winship  <danw@novell.com>

	* generator/ObjectGen.cs: Make ContainerChild constructors
	"protected internal" rather than just "internal", so the classes
	can be subclassed nicely.

2005-01-13  Zac Bowling  <zac@zacbowling.com>

	* gtkdotnet/makefile.win32 : fixed references to build on Win32
	
2005-01-12  Mike Kestner  <mkestner@novell.com>

	* sample/gnomevfs/Makefile,am : conditionally build.

2005-01-12  Mike Kestner  <mkestner@novell.com>

	* sample/gnomevfs/*.cs : s/Test.Gnome.VFS/TestGnomeVfs to avoid
	namespace collision problems with current mcs.

2005-01-11  Ben Maurer  <bmaurer@ximian.com>

	* configure.in: There might be multiple S.D assemblies (eg, if you
	build the 2.0 crap, you get a 1.1 and a 2.0). So use head -n1 when
	looking at gacutil

2005-01-11  Mike Kestner  <mkestner@novell.com>

	* configure.in : add test for System.Drawing. expand gtkdotnet.
	* Makefile.am : add gtkdotnet.
	* makefile.win32 : add gtkdotnet.
	* gtkdotnet/* : new .Net extensions assembly. Moved the sample
	sysdraw.cs Graphics class in here under the Gtk.DotNet namespace.
	* sample/sysdraw.cs : moved to gtkdotnet/Graphics.cs.
	* sample/drawing-sample.exe.config.in : killed.
	* sample/DrawingSample.cs : use Gtk.DotNet.Graphics.
	* sample/Makefile.am : make drawing-sample.exe build conditional
	on gtk-dotnet presence.

2005-01-11  Mike Kestner  <mkestner@novell.com>

	* gdk/Window.custom : add AddFilterForAll and RemoveFilterForAll
	methods to handle the window==null native case.
	[Fixes #71065]

2005-01-11  Mike Kestner  <mkestner@novell.com>

	* glib/Argv.cs : add automatic progname handling.
	* gdk/Global.custom : kill obsolete warnings by using GLib.Argv.

2005-01-11  Mike Kestner  <mkestner@novell.com>

	* gdk/Gdk.metadata : kill Colors since its methods are deprecated
	and it doesn't exist in 1.0.

2005-01-08  Ben Maurer  <bmaurer@ximian.com>

	* Makefile.include (install-data-local, uninstall-local): make
	this actually work for things that are disabled.

2005-01-08  Mike Kestner  <mkestner@novell.com>

	* configure.in : kill a ton of redundant stuff.
	* AssemblyInfo.cs.in : moved here, only need one.
	* Makefile.include : rules for building generated assemblies.
	* Makefile.am : removed gtk-sharp-2.0.pc handling.
	* */AssemblyInfo.cs.in : killed
	* */Makefile.am : refactored out a ton of rules to an include.
	* */*-pc.in : added Cflags entries pointing to the gapi files.
	* generator/CodeGenerator.cs : add -I: synonym --include.
	* gnomevfs/gnome-vfs-api.raw : remamed from gnomevfs-api.raw.
	* gtk/gtk-sharp-2.0.pc.in : moved here from top.
	* parser/gapi-fixup.cs : add --symbol arg to merge sym files.
	* sources/gtk-sharp-sources.xml : remamed gnome-vfs-api.raw.

2005-01-07  Mike Kestner  <mkestner@novell.com>

	* sample/Makefile.am : mdb cleanup.
	* sample/GtkDemo/Makefile.am : mdb cleanup.

2005-01-07  Mike Kestner  <mkestner@novell.com>

	* configure.in : check for panelapplet in enable_gnome and remove
	all the stuff for a separate panelapplet-sharp assembly.
	* Makefile.am : remove panelapplet dir from build.
	* gnome/BonoboUIVerb.cs : moved from panelapplet.
	* gnome/Gnome.metadata : add rules from panelapplet.
	* gnome/Makefile.am : add new files.
	* gnome/PanelApplet.custom : moved from panelapplet.
	* gnome/PanelAppletFactory.cs : moved from panelapplet.
	* gnome/glue/panelapplet.c : moved from panelapplet.
	* gnome/glue/Makefile.am : add new file.
	* gnomedb/GnomeDb.metadata : hide a newly parsed "obsolete" type.
	* gtk/Gtk.metadata : hide a newly parsed "obsolete" callback type.
	* panelapplet : kill dir.
	* parser/gapi2xml.pl : update callback name sanity check.
	* sources/gtk-sharp-sources.xml : move panelapplet parse into gnome.
	* */*-api.raw : regen.

2005-01-07  Dan Winship  <danw@novell.com>

	* gtk/Gtk.metadata: Hide the Gtk.Image ctors generated from
	gtk_image_new_from_icon_set and gtk_image_new_from_stock.

	* gtk/Image.custom: Implement them here, taking into account the
	fact that the "icon_size" property is mysteriously an int rather
	than a Gtk.IconSize.

	* gtk/Makefile.am (customs): add Image.custom

	* gtk/Gtk.metadata: gtk_window_set_focus accepts NULL

2005-01-06  Larry Ewing  <lewing@novell.com>

	* gtk/StockItem.custom: add a ctor for StockItem. 

	* gtk/Makefile.am: add StockItem.custom to the build.
	
2005-01-06  Dan Winship  <danw@novell.com>

	* gtk/Gtk.metadata: Rename gtk_stock_add() back to
	Gtk.StockManager.Add like it was in 1.0; Gtk.Stock.Add already
	means something else. [#71044]

2005-01-06  Mike Kestner  <mkestner@novell.com>

	* gtk/Gtk.metadata : hide GtkSignal and SignalRunType.

2005-01-06  Mike Kestner  <mkestner@novell.com>

	* gnomevfs/gnomevfs-symbols.xml : FileSize is a long long.
	* generator/SymbolTable.cs : map longlong to C# long.

2005-01-05  Mike Kestner  <mkestner@novell.com>

	* gtk/gtk-api.raw : regen.
	* sources/gtk-sharp-sources.xml : hide xembed.h and gtkxembed.h.

2005-01-05  Mike Kestner  <mkestner@novell.com>

	* gtk/TreeView.custom : add back the TreeCellDataFunc overloads for
	backward compat.
	* gtk/TreeViewColumn.custom : add back the TreeCellDataFunc overloads for
	backward compat.

2005-01-05  Mike Kestner  <mkestner@novell.com>

	* generator/Field.cs : deal with LPGen/LPUGen fields.

2005-01-05  Mike Kestner  <mkestner@novell.com>

	* gtk/gtk-api.raw : regen.
	* sources/gtk-sharp-sources.xml : exclude gtkiconthemeparser.h.
	[Fixes #70898]

2005-01-05  Mike Kestner  <mkestner@novell.com>

	* gtk/Gtk.metadata : hide some internal Image*Data structs.

2005-01-05  Alp Toker  <alp@atoker.com>

	* gtk/TextBuffer.custom : Mark SetText obsolete in favour of the Text
	property, and use Text in SetText in the meantime.

2005-01-04  Mike Kestner  <mkestner@novell.com>

	* gtk/gtk-api.raw : regen'd.
	* sources/gtk-sharp-sources.xml : exclude file system backend source.
	[Fixes #70904, #70897, and #70900]

2005-01-04  Mike Kestner  <mkestner@novell.com>

	* gtk/Gtk.metadata : mark out params for IMContext.GetSurrounding
	and GetPreeditString.
	[Fixes #70995]

2005-01-04  Mike Kestner  <mkestner@novell.com>

	* gtk/CellLayout.custom : declare SetAttributes and SetCellDataFunc.
	* gtk/CellView.custom : impl SetAttributes and SetCellDataFunc.
	* gtk/ComboBox.custom : impl SetAttributes and SetCellDataFunc.
	* gtk/EntryCompletion.custom : impl SetAttributes and SetCellDataFunc.
	* gtk/Gtk.metadata : hide some methods to be manually implemented.
	* gtk/Makefile.am : add new customs.
	* gtk/NodeCellDataFunc : use CellLayoutDataFuncNative.
	* gtk/TreeView.custom : use CellLayoutDataFunc not TreeCellDataFunc.
	* gtk/TreeViewColumn.custom : impl SetAttributes and SetCellDataFunc.
	[Fixes #70941]

2005-01-04  Mike Kestner  <mkestner@novell.com>

	* gtk/Gtk.metadata : set preferred on CellViewMenuItem.NewWithText.
	[Fixes #70938]

2005-01-03  Mike Kestner  <mkestner@novell.com>

	* gtk/NodeStore.cs : expose TreeModelFlags.ListOnly if the TreeNode
	has ListOnly set.
	* gtk/TreeNodeAttribute.cs : add ListOnly named value.

2004-12-30  Mike Kestner  <mkestner@novell.com>

	* glib/Object.cs : mark the Data hashtable obsolete.

2004-12-30  Mike Kestner  <mkestner@novell.com>

	* gtk/Gtk.metadata : hide TreeView.InsertColumnWith*.
	* gtk/TreeView.cs : manual implementations of InsertColumn overloads
	for WithAttributes and WithDataFunc.

2004-12-30  Alp Toker  <alp@atoker.com>

	* README.generator: Close tag fix for example XML.

2004-12-28  Jeroen Zwartepoorte  <jeroen@xs4all.nl>

	* sample/gnomevfs/TestVolumes.cs: Update sample.

2004-12-28  Jeroen Zwartepoorte  <jeroen@xs4all.nl>

	* gnomevfs/Gnomevfs.metadata: Hide some more API.
	* gnomevfs/VfsStreamAsyncResult.cs: Make Done property internal.
	* gnomevfs/VolumeMonitor.custom: Hide GList API.

2004-12-28  Jeroen Zwartepoorte  <jeroen@xs4all.nl>

	* gnomevfs/Directory.cs: PInvoke the _uri methods directory instead of
	using the ToString() methods.
	* gnomevfs/FileInfo.cs: Make the FileInfoNative field internal.
	* gnomevfs/Gnomevfs.metadata: Hide a bunch of unwanted API.
	* gnomevfs/Uri.custom: New API.
	* gnomevfs/Vfs.cs: Idem.

2004-12-27  Mike Kestner  <mkestner@novell.com>

	* generator/CallbackGen.cs : use ReturnValue and more of Parameter.
	* generator/GenBase.cs : remove unused NSElem prop.

2004-12-27  Jeroen Zwartepoorte  <jeroen@xs4all.nl>

	* gnomevfs/Directory.cs: s/uint/FilePermissions/.
	* gnomevfs/Gnomevfs.metadata: Make a bunch of API more user-friendly &
	C# like.
	* gnomevfs/Monitor.cs: Add internal MonitorEventType enum.
	* gnomevfs/Uri.custom: Move a bunch of API from Vfs.cs to Uri.
	* gnomevfs/Vfs.cs: Only put initialize & shutdown methods in here (plus
	some debug API).
	* gnomevfs/VfsStream.cs: Use new Uri API.
	* sample/gnomevfs/TestUnlink.cs: Fix sample.

2004-12-27  Mike Kestner  <mkestner@novell.com>

	* generator/EnumGen.cs : rework for a single pass thru ChildNodes.
	* generator/Parameters.cs : simplify PassAs logic.
	* generator/SimpleBase.cs : mark abstract.

2004-12-27  Mike Kestner  <mkestner@novell.com>

	* generator/AliasGen.cs : derive from SimpleBase.
	* generator/ConstStringGen.cs : derive from SimpleBase.
	* generator/GObjectGen.cs : kill. now uses ManualGen.
	* generator/GStringGen.cs : kill. now uses MarshalGen.
	* generator/GUnicharGen.cs : kill. now uses MarshalGen.
	* generator/LPGen.cs : derive from SimpleGen.
	* generator/Makefile.am : update source files.
	* generator/ManualGen : make this general for handle types.
	* generator/MarshalGen : new CallByName/FromNative formatter class.
	* generator/SymbolTable.cs : needed some reorganizing and some
	restructuring of types to use MarshalGen.
	* generator/TimeTGen.cs : kill. now uses MarshalGen.

2004-12-26  Mike Kestner  <mkestner@novell.com>

	* generator/Makefile.am : add new file.
	* generator/SimpleBase.cs : new class for non-generated type mappers.
	* generator/*Gen.cs : first refactoring of "Simple" generatable types.
	Derive them all from SimpleBase. More to come.

2004-12-26  Mike Kestner  <mkestner@novell.com>

	* generator/CustomMarshalerGen.cs : kill bad idea unused class.
	* generator/Makefile.am : remove CustomMarshalerGen.cs.
	* generator/Method.cs : remove CustomMarshalerGen reference.

2004-12-26  Mike Kestner  <mkestner@novell.com>

	* generator/*Gen.cs : implement IGeneratable fully on GenBase
	with abstract methods where necessary to refactor a ton of redundant
	code.

2004-12-23  Mike Kestner  <mkestner@novell.com>

	* glib/ClassInitializerAttribute.cs : new attr for identifying type.
	inialization methods to be run by RegisterGType.
	* glib/Makefile.am : add file.
	* glib/Object.cs : add private method to invoke ClassInitializers.
	* gtk/glue/widget.c : some new glue for binding registration.
	* gtk/BindingAttribute.cs : new attr for registering key bindings.
	* gtk/Makefile.am : add file.
	* gtk/Widget.custom : add ClassInitializer method to scan types
	for [Binding] and register key bindings.

2004-12-22  Dan Winship  <danw@novell.com>

	* generator/Signal.cs: fix some WriteLine()s that should have been
	Write()s

2004-12-22  Dan Winship  <danw@novell.com>

	* sources/gtk-sharp-sources.xml: exclude a bunch of uninstalled
	gtk headers.

	* gtk/gtk-api.raw: regen

	* gtk/Gtk.metadata: Remove some explicit hiding of things that
	shouldn't have been there anyway. Hide a few types that just show
	up as unusable stubs.

2004-12-22  Mike Kestner  <mkestner@novell.com>

	* gdk/gdk-api.raw : update enum values.
	* gnome/gnome-api.raw : update enum values.
	* gtk/gtk-api.raw : update enum values.
	* pango/pango-api.raw : update enum values.
	* parser/gapi2xml.pl : pull whitespace out of enum prefixing logic.
	[Fixes #70593]

2004-12-21  Mike Kestner  <mkestner@novell.com>

	* glib/Argv.cs : argv marshaling class.
	* glib/Makefile.am : add file.
	* glib/Marshaller.cs : mark the argv methods obsolete.
	* gtk/Application.cs : use GLib.Argv. [Fixes #68812]

2004-12-21  Dan Winship  <danw@novell.com>

	* generator/CallbackGen.cs:
	* generator/CodeGenerator.cs: 
	* generator/ManagedCallString.cs:
	* generator/Property.cs: Remove unused vars

	* generator/Method.cs (GetHashCode): have to implement this since
	we're overriding Equals.

	* generator/CallbackGen.cs: print a message when generating a
	broken struct-returning callback. (Currently affects
	GtkSharp.TextSegSplitFuncNative and
	GtkSharp.TextSegCleanupFuncNative)

	* gdk/glue/device.c: 
	* gdk/glue/dragcontext.c: Add missing prototypes

	* gtk/Gtk.metadata: Mark SeparatorToolItem.Draw "new". Re-rename
	CheckMenuItem.Toggled to EmitToggled rather than Toggle, since
	that's a better description of what it does.

	* gtk/CheckMenuItem.custom: implement a "Toggle" method that does
	what the documentation claims it does.

	* gtk/NodeStore.cs: remove unused var

	* gnome/Gnome.metadata: mark DateEdit.Flags, Dialog.Default, and
	PropertyBox.State "new". Hide GnomePixmapEntry.GnomeEntry and
	GnomePixmapEntry.GtkEntry since they do exactly the same thing as
	the methods of the same names inherited from GnomeFileEntry.

	* gnome/glue/canvas-proxy.c:
	* gnome/glue/canvas-proxy.h:
	* gnome/glue/canvas-proxy-marshal.c:
	* gnome/glue/canvas-proxy-marshal.h:
	* gnome/glue/canvas-proxy-marshal.list: Remove unused code

	* gnome/glue/Makefile.am (libgnomesharpglue_2_la_SOURCES): update

	* panelapplet/PanelApplet.metadata: mark PanelApplet.Flags "new"

	* sample/CanvasExample.cs: 
	* sample/CustomCellRenderer.cs: 
	* sample/CustomNotebook.cs: 
	* sample/DrawingSample.cs:
	* sample/Fifteen.cs: 
	* sample/GladeTest.cs: 
	* sample/GtkDemo/DemoHyperText.cs: 
	* sample/GtkDemo/DemoPixbuf.cs: 
	* sample/ScribbleXInput.cs: remove unused vars, use
	GLib.Timeout.Add rather than the deprecated Gtk.Timeout.Add
	
2004-12-21  Jeroen Zwartepoorte  <jeroen@xs4all.nl>

	* gnomevfs/Async.cs:
	* gnomevfs/Directory.cs:
	* gnomevfs/Sync.cs:
	* gnomevfs/Vfs.cs: Make the constructors private so they don't show up
	in monodoc (these classes aren't meant to be instantiated).

2004-12-21  Jeroen Zwartepoorte  <jeroen@xs4all.nl>

	* gnomevfs/Gnomevfs.metadata: Hide the auto-generated ModuleCallback
	stuff in favor of the more developer friendly custom bindings.
	* gnomevfs/Makefile.am:
	* gnomevfs/ModuleCallbackAuthentication.cs:
	* gnomevfs/ModuleCallbackFillAuthentication.cs:
	* gnomevfs/ModuleCallbackFullAuthentication.cs:
	* gnomevfs/ModuleCallbackSaveAuthentication.cs:
	* gnomevfs/ModuleCallbackStatusMessage.cs: Complete the module callback
	implementations.

2004-12-20  Mike Kestner  <mkestner@novell.com>

	* gdk/Gdk.metadata : mark a couple array params.
	* generator/Field.cs : remove the MarshalAs hack. We have to
	do something much more evil since MarshalAs can't hang.
	* generator/ImportSignature.cs : deal with out LP(U)Gen params.
	* generator/LPGen.cs : moved from SSizeTGen and generalized.
	* generator/LPUGen.cs : moved from SizeTGen and generalized.
	* generator/Makefile.am : update sources.
	* generator/MethodBody.cs : deal with out LP(U)Gen params.
	* generator/Parameters.cs : deal with out LP(U)Gen params.
	* generator/SymbolTable.cs : make all longs and size_t types LP(U)Gens.

2004-12-20  Dan Winship  <danw@novell.com>

	* generator/GUnicharGen.cs: generatable for gunichar, using
	GLib.Marshaller.CharToGUnichar and .GUnicharToChar [#70704]

	* generator/SymbolTable.cs (SymbolTable): add a GUnicharGen.

	* generator/Makefile.am (sources): add GUnicharGen.cs

	* parser/gapi2xml.pl (addPropElem): g_param_spec_unichar() has
	type "gunichar" not "unichar".

	* gtk/gtk-api.raw: Regen

	* glib/Marshaller.cs: Import CharToGUnichar's glue method by the
	right name

2004-12-20  Dan Winship  <danw@novell.com>

	* gtk/Gtk.metadata: Don't rename GtkStock to StockManager, hide
	Lookup (so we can customize it) and AddStatic (since it can't work
	right from managed code), and tweak the params of Add.

	* gtk/Stock.custom: Implement Lookup() using a special
	ConstStockItem struct so the p/invoke layer won't try to free
	static strings. [#70589]

	* sample/GtkDemo/DemoStockBrowser.cs: update this to work with
	that. (It used to crash.)

2004-12-20  Mike Kestner  <mkestner@novell.com>

	* generator/Property.cs : generate Interface properties.
	* gtk/ComboBox.custom : remove dup model prop.
	* gtk/TreeView.custom : remove dup model prop.

2004-12-20  Jeroen Zwartepoorte  <jeroen@xs4all.nl>

	* gnomevfs/Makefile.am:
	* gnomevfs/ModuleCallback.cs: 
	* gnomevfs/ModuleCallbackAuthentication.cs:
	* gnomevfs/ModuleCallbackFullAuthentication.cs:
	* gnomevfs/Vfs.cs: Use a custom VfsException for Result errors.
	* gnomevfs/VfsException.cs: new custom Exception class.
	* sample/gnomevfs/Makefile.am:
	* sample/gnomevfs/TestCallback.cs:
	
	Implement custom bindings for the ModuleCallback mechanism. Atm, only
	the GNOME_VFS_MODULE_CALLBACK_AUTHENTICATION and
	GNOME_VFS_MODULE_CALLBACK_FULL_AUTHENTICATION callbacks are implemented.
	Also added a test-case using the full authentication callback (tested
	using the sftp: method). [Partially fixes #70602]

2004-12-18  Mike Kestner  <mkestner@novell.com>

	* configure.in : bump version in preparation for 1.9.1 release.

2004-12-18  Mike Kestner  <mkestner@novell.com>

	* gtk/ColorSelectionDialog.custom : fix some incorrect object wrapping
	and mark the ColorSelectionButton nested class Obsolete with a heinous
	warning message. [Fixes #68450]

2004-12-18  Mike Kestner  <mkestner@novell.com>

	* generator/Field.cs : add MarshalAs attrs for (u)longs.

2004-12-18  Mike Kestner  <mkestner@novell.com>

	* gconf/GConf/ChangeSet.cs : add internal Handle prop.
	* gconf/GConf/Engine.cs : new class to expose the default gconf engine
	perform changeset commits and reverses.

2004-12-17  Mike Kestner  <mkestner@novell.com>

	* gtk/ListStore.custom : dispose a bunch of GLib.Values.
	* gtk/TreeStore.custom : ditto.  Reworked and expanded from a patch
	by Ben "valgrind-boy" Maurer. [Fixes #69925]

2004-12-17  Mike Kestner  <mkestner@novell.com>

	* glade/XML.custom (BindFields) : support multiple autoconnects
	in different roots by not writing null widgets to the tagged
	fields. [Fixes #68455]

2004-12-17  Mike Kestner  <mkestner@novell.com>

	* gtk/Gtk.metadata : hide Object and Widget.Destroy.
	* gtk/Object.custom : manual virtual Destroy impl.
	* gtk/Widget.custom : manual virtual Destroy impl.
	* gtk/Window.custom : hold a managed ref for all toplevels. Release
	it in a Destroy override.  Window is frequently subclassed and is
	never parented, so this keeps a managed ref around to avoid GC.
	[Fixes #70120]

2004-12-17  Mike Kestner  <mkestner@novell.com>

	* gdk/Gdk.metadata : mark out param on Window.GetFrameExtents.
	* gdk/WindowAttr.custom : new typed Mask prop.
	* gtk/Widget.custom : new typed WidgetFlags prop. mark Flags obsolete.

2004-12-17  Mike Kestner  <mkestner@novell.com>

	* gtk/Makefile.am : add new file.
	* gtk/glue/makefile.win32 : add missing file.
	* gtk/NodeCellDataFunc.cs : new callback delegate type and marshaler
	for NodeStore tree views using GtkTreeCellDataFuncs.
	* gtk/NodeStore.cs : add internal GetNode overload by TreeIter.
	* gtk/NodeView.cs : add AppendColumn overload that uses data funcs.
	* gtk/TreeViewColumn.custom : manual implementation for SetCellDataFunc
	to support both TreeIter and ITreeNode models.  We need to hold a ref
	to a delegate for each cell renderer on a column. [Fixes #63062]
	* sample/NodeViewDemo.cs : use a NodeCellDataFunc for one of the 
	cell renderers in the tree.

2004-12-17  Dan Winship  <danw@novell.com>

	* generator/Field.cs (StudlyName): Fall back to using "cname" if
	"name" isn't defined (ie, when using the latest generator against
	api files output by an older parser).

2004-12-17  Dan Winship  <danw@novell.com>

	* generator/ClassBase.cs (IgnoreMethod): Don't ignore GetFoo and
	SetFoo methods if they aren't in the right form to be turned into
	property accessors. (Causes 13 previously ignored methods to now
	be wrapped. See doc/ChangeLog.)

	* gtk/Gtk.metadata: Fix up a few of those newly-exposed methods

2004-12-16  Dan Winship  <danw@novell.com>

	* generator/ManagedCallString.cs (Setup, Finish, ToString): Add
	new methods to allow arbitrary setup and teardown code around the
	managed call. When passing a type with "complicated" marshalling
	requirements as a ref or out param, first assign the value to a
	temporary variable (in Setup), then pass the temp as the ref or
	out param (in ToString), and then assign the new value back to the
	original argument (in Finish).

	* generator/Signal.cs: 
	* generator/SignalHandler.cs: Update to generate correct glue for
	signals with "ref" or "out" params. (#70566)

	* generator/VirtualMethod.cs: Update for ManagedCallString change

	* generator/IGeneratable.cs: add comments explaining what each
	member does

	* gtk/Gtk.metadata: mark Editable.InsertText's "position" arg pass-by-ref

	* sample/Size.cs: connect to the SizeRequested event and override
	it, to test/demo the changes

2004-12-16  Dan Winship  <danw@novell.com>

	* parser/gapi_pp.pl: Don't strip out /*< public >*/ and
	/*< private >*/ comments.

	* parser/gapi2xml.pl: Use those comments to determine the
	accessibility of struct/object fields, and set the "access"
	attribute on fields with non-default accessibiliy (private for
	structs, public for objects). Also, output a StudlyName for each
	field as well as a c_name.

	* */*-api.raw: Regen

	* generator/Field.cs (StudlyName): Use the parser-generated studly
	name rather than studlifying Name, which might have been mangled
	to avoid conflicts with an all-lowercase keyword.
	(Generate): Respect the access property on all field types rather
	than always making certain types public. Don't bother outputting
	wrapper properties for private fields, since the only code that
	could use them is the generated code, which won't.

	Part of #69514. See doc/ChangeLog for the (very minimal) fallout
	from these changes.

2004-12-16  Mike Kestner  <mkestner@novell.com>

	* sample/NodeViewDemo.cs : rework of TreeViewDemo to use NodeStore.
	* sample/TreeViewDemo.cs : added some timing and node counting fu.

2004-12-16  Duncan Mak  <duncan@ximian.com>

	* gtk/Makefile.am (sources): Added NodeSelection and NodeView.
	* gtk/NodeSelection.cs: New file, an implementation of
 	TreeSelection that exposes ITreeNodes instead of TreeIters.
	* gtk/NodeStore.cs : added internal GetIter and GetPath methods for 
	NodeSelection. Reworked [TreeNodeValue] lookup logic.
 	out what the Type of data the store holds.
	* gtk/NodeView.cs: New subclass of TreeView utilizing NodeStore and
	NodeSelection.
	* gtk/TreeIter.custom : new internal UserData prop.
	* gtk/TreeNodeValueAttribute.cs: Set AllowMultiple to true.
	* gtk/TreeView.custom: Obsoleted constructor that uses a NodeStore as
 	parameter. NodeView should be used instead.
 
2004-12-16  Tambet Ingo  <tambet@ximian.com>

	* glib/Opaque.cs : hold a weakref in the hash, not a strong ref.

2004-12-15  Mike Kestner  <mkestner@novell.com>

	* gnome/Gnome.metadata : resolve a collision that was causing
	Print class methods to be lost.

2004-12-13  Mike Kestner  <mkestner@novell.com>

	* configure.in : make gtkhtml conditional on enable_gnome. 
	[Fixes #70502]

2004-12-09  Mike Kestner  <mkestner@novell.com>

	* gtkhtml/HTML.custom : remove obsolete attr for Write overload.
	* gtkhtml/HTMLStream.custom : ditto.

2004-12-09  Mike Kestner  <mkestner@novell.com>

	* gtkhtml/HTML.custom : add an back-compat obsolete overload for Write.
	* gtkhtml/HTMLStream.custom : add an obsolete overload for Write.

2004-12-09  Mike Kestner  <mkestner@novell.com>

	* generator/Makefile.am : new files.
	* generator/MethodBody.cs : fix for length param code.
	* generator/SizeTGen.cs : smarter size_t marshaling.
	* generator/SSizeTGen.cs : smarter ssize_t marshaling.
	* generator/SymbolTable.cs : use the new generatables.

2004-12-08  John Luke  <john.luke@gmail.com>

	* sources/README: update versions of the libs

2004-12-08  Mike Kestner  <mkestner@novell.com>

	* art/Art.metadata : mark some ints as bools. [Fixes #61047]

2004-12-08  Jeroen Zwartepoorte  <jeroen@xs4all.nl>

	* sample/Makefile.am: Readded TestVfs.cs back and make it conditional.
	* sample/TestVfs.cs: New sample contributed by Tamara Roberson.
	[Fixes #70262]

2004-12-07  Mike Kestner  <mkestner@novell.com>

	* gtk/glue/style.c : add missing method and prototype. [Fixes #70216]

2004-12-07  Mike Kestner  <mkestner@novell.com>

	* */*.cs : s/glue-2.0/glue-2 so that dllimport works on win32.
	* */*.custom : s/glue-2.0/glue-2
	* */glue/makefile.win32 : s/glue-2.0/glue-2
	* */glue/Makefile.am : s/glue-2.0/glue-2

2004-12-06  John Luke  <john.luke@gmail.com>

	* gtk/Gtk.metadata: set with_mnemonic as the preferred ctor
	* doc/en/Gtk/Expander.xml: update

2004-12-06  John Luke  <john.luke@gmail.com>

	* gtk/Action.custom
	* gtk/ActionGroup.custom
	* gtk/UIManager.custom
	* gtk/Gtk.metadata
	* doc/en/Gtk/ActionGroup.xml
	* file doc/en/Gtk/Action.xml
	* doc/en/Gtk/UIManager.xml: replace List and SList with arrays
	and update the docs

2004-12-06  Mike Kestner  <mkestner@novell.com>

	* generator/SymbolTable.cs : add off_t as an IntPtr.

2004-12-06  Mike Kestner  <mkestner@novell.com>

	* generator/SignalHandler.cs : s/[]/Array in BaseName. [Fixes #69383]

2004-12-06  Mike Kestner  <mkestner@novell.com>

	* doc/en/*/*.xml : docs for new GValue members and size_t changes.
	* generator/SymbolTable.cs : add ssize_t and make size_t a UIntPtr
	instead of the current broken int mapping on 64 bit platforms.
	* gtkhtml/HTMLStream.custom : fix size_t related overload.
	[fixes #69574]

2004-12-03  Dan Winship  <danw@novell.com>

	* gdk/gdk-symbols.xml: alias GdkBitmap to GdkPixmap [Fixes #68824]

	* gdk/Gdk.metadata: Remove the earlier GdkBitmap hack now that
	it's aliased. Also move Gdk.Bitmap.CreateFromData to
	Gdk.Pixmap.CreateBitmapFromData

	* gdk/Pixbuf.custom (RenderPixmapAndMask,
	RenderPixmapAndMaskForColormap, RenderThresholdAlpha):
	s/Bitmap/Pixmap/

	* sample/GtkDemo/DemoTextView.cs: uncomment the fg/bg stipple
	code, since that works now

	* parser/gapi-fixup.cs: Add an "add-node" rule. This turned out to
	not actually be needed for this fix, but we know we'll need it
	later, so here it is.

2004-12-03  Jorge Garcia <jgarcia@ac.upc.es>

	* glib/Type.cs:          add Int64 and UInt64 support.
	* glib/TypeConverter.cs: add Int64 and UInt64 support.
	* glib/Value.cs:         add Int64 and UInt64 support.

2004-12-03  Mike Kestner  <mkestner@novell.com>

	* gtk/Dialog.custom : correct return value for AddButton overload.
	[Fixes #70121]

2004-12-03  Mike Kestner  <mkestner@novell.com>

	* gtk/Gtk.metadata : mark accel_group null_ok on ImageMenuItem ctor.
	[Fixes #69041]

2004-12-03  Dan Winship  <danw@novell.com>

	* gtk/Gtk.metadata: Pass TextIters by ref almost everywhere.
	[Fixes #70187]. Kill two varargs warnings.

	* gtk/TextBuffer.custom: Update for that, and also implement
	InsertWithTagsByName

	* sample/GtkDemo/DemoHyperText.cs:
	* sample/GtkDemo/DemoTextView.cs: Remove kludges for broken
	TextIter handling. Also fix the i18n demo bits by translating the
	octal-encoded UTF-8 to hex-encoded UTF-16.

2004-12-03  Mike Kestner  <mkestner@novell.com>

	* gtk/Gtk.metadata : hide junk methods in Global. [Fixes #60895]

2004-12-03  Mike Kestner  <mkestner@novell.com>

	* gtk/Gtk.metadata : hide Visibility enum. [Fixes #60704]

2004-12-01  Todd Berman  <tberman@off.net>

	* generator/StructGen.cs: Check to see if a GType is going to be
	generated. If not, generate a GType.Pointer. This fixes bug
	#70017.
	* glib/TypeConverter.cs: Remove the .IsValueType check, as those
	now have GType properties.
	* gda/Gda.metadata: Change GdaValue.GType to GdaValue.GdaType.
	* doc/en/Gda/Value.xml: Regenerated to reflect new API.

2004-11-30  Dan Winship  <danw@novell.com>

	* sample/GtkDemo/DemoImages.cs: Fix some crashers discovered while
	trying to use this as a test case to figure out whether or not I'd
	broken Gtk#. Sigh. :)

2004-11-30  Mike Kestner  <mkestner@novell.com>

	* glib/glue/value.c : add back some code lost in the merge of
	2-4-branch. [Fixes #70045]

2004-11-26  Jeroen Zwartepoorte  <jeroen@xs4all.nl>

	* gtk/ActionEntry.cs:
	* gtk/ActionGroup.custom:
	* gtk/Gtk.metadata:
	* gtk/Makefile.am:
	* gtk/RadioActionEntry.cs:
	* gtk/ToggleActionEntry.cs:
	* gtk/UIManager.custom:
	* sample/Actions.cs: Updated to use the new *ActionEntry code. Reflects
	testactions.c from gtk+ now.
	
	Added C# syntactic sugar for easily defining Action's for the UIManager.
	Derived from the same ActionEntry structs in gtk+.

2004-11-22  Dan Winship  <danw@novell.com>

	* generator/ClassBase.cs: 
	* generator/ObjectGen.cs: Move child property handling from
	ClassBase to ObjectGen (as suggested by Mike) since it's only
	used there

2004-11-18  Mike Kestner  <mkestner@novell.com>

	* generator/InterfaceGen.cs : beginnings of a real
	implementation for GInterfaces.  Not quite ready yet,
	so it's not active in generation.

2004-11-18  Mike Kestner  <mkestner@novell.com>

	* generator/Makefile.am : add new file.
	* generator/Method.cs : add Declaration property.
	* generator/VirtualMethod.cs : new class to generate virtual
	methods for Interfaces and objects. Unfinished.

2004-11-18  Mike Kestner  <mkestner@novell.com>

	* generator/ClassBase.cs : remove a "new" string in the
	ChildProp class holder decl to fix build warnings.

2004-11-18  Mike Kestner  <mkestner@novell.com>

	* atk/Atk.metadata : mark an out param on Value.

2004-11-18  Mike Kestner  <mkestner@novell.com>

	* generator/*Gen.cs : add ToNativeReturnType to deal with
	the g_free string nonsense in the virtual method case.

2004-11-18  Mike Kestner  <mkestner@novell.com>

	* generator/AliasGen.cs : make this a SimpleGen.

2004-11-18  Mike Kestner  <mkestner@novell.com>

	* parser/gapi2xml.pl : fix a missing semi in a vm regex.
	* */*-api.raw : regen with missing vms.

2004-11-18  Dan Winship  <danw@novell.com>

	Redo child property handling; now we generate classes to hold the
	child properties for a given widget in a container, and generate
	the child properties as properties on those classes.
	
	* parser/gapi2xml.pl (addPropElem): don't prepend "child_" to
	child prop names any more

	* generator/ClassBase.cs (ClassBase): keep childprops separate
	from properties
	(GenChildProperties): create a subclass of Gtk.ContainerChild
	containing the container type's child properties, and override the
	Container indexer to return that type.

	* generator/ObjectGen.cs (Generate): call GenChildProperties

	* generator/Property.cs:
	* generator/ChildProperty.cs: Simplify these a bunch, since child
	properties are now represented as C# properties as well. Also add
	[GLib.Property(cname)] and [Gtk.ChildProperty(cname)] attributes.

	* glib/Makefile.am (sources): add PropertyAttribute.cs

	* glib/PropertyAttribute.cs: attribute used to label
	GObject properties

	* gtk/Makefile.am (sources): add ChildPropertyAttribute.cs

	* gtk/gtk-api.raw: regenerate for parser changes (remove
	"Child"/"child_" from child property names).

	* gtk/ChildPropertyAttribute.cs: attribute used to label
	GtkContainer child properties

	* gtk/Container.custom: define the ContainerChild class, and an
	indexer to return instances of it.

2004-11-17  Jorn Baayen  <jorn@nl.linux.org>

	* gtk/FileChooserDialog.custom : set TransientFor, not Parent.
	[Fixes #69626]

2004-11-17  Mike Kestner  <mkestner@novell.com>

	* gnome/Makefile.am : kill unused file.
	* gnome/voidObjectAffineSVPintSignal.cs : kill old file.

2004-11-17  Mike Kestner  <mkestner@novell.com>

	* generator/Makefile.am : add new file.
	* generator/Method.cs : refactoring to use ReturnValue.
	* generator/MethodBody.cs : remove unnecessary code.
	* generator/ReturnValue.cs : class for redundant retval handling.
	* generator/Signal.cs : refactoring for ReturnValue.
	* generator/SignalHandler.cs : refactoring for ReturnValue.

2004-11-16  Dan Winship  <danw@novell.com>

	* glib/Value.cs: add new constructors for enum and boxed values
	that take the name of the type rather than an object/property
	name pair; this way they work for both GObject properties and
	GtkContainer child properties.

	* glib/glue/value.c (gtksharp_value_create_from_type_name): glue
	for that

	* glib/Opaque.cs (GetOpaque): Fix this.

	* generator/Property.cs (Generate): Use the new GLib.Value
	constructors. (Fixes setting of enum-valued child properties.)

2004-11-15  Dan Winship  <danw@novell.com>

	* gtk/glue/container.c (gtksharp_container_get_focus_child): New
	glue method to get container->focus_child

	* gtk/Gtk.metadata: hide SetFocusChild

	* gtk/Container.custom (FocusChild): implement with both getter
	and setter

2004-11-15  Mike Kestner  <mkestner@novell.com>

	* gtk/Gtk.metadata : hide the Get/Set Color methods that are marked
	deprecated but didn't exist in 1.0.

2004-11-13  Duncan Mak  <duncan@ximian.com>

	* generator/SymbolTable.cs: Add support for GDestroyNotify, so
	that `gtk_cell_layout_set_cell_data_func' will be generated in
	Gtk.ComboBox.

2004-11-13  Mike Kestner  <mkestner@novell.com>

	* */*-api.raw : rerun the parser for new vm-age and cleanups.
	* parser/gapi_pp.pl : suppress union types, since we can't generate
	them.  smarter get_type regex. ignore #errors.
	* parser/gapi2xml.pl : generate vm elements for GInterfaces. Deal
	with G_CONST_RETURN in vms. deal with "struct _foo" types in method
	prototypes.
	* gtk/ComboBox.custom : remove now correctly generated dllimport.

2004-11-13  Mike Kestner  <mkestner@novell.com>

	* sources/gda.patch : fix broken signal defs.
	* sources/gnomedb.patch : fix broken signal defs.
	* sources/Makefile.am : apply new patches, and dist some others.

2004-11-12  Mike Kestner  <mkestner@novell.com>

	* parser/gapi_pp.pl : fix multi-line extern parsing.

2004-11-12  Mike Kestner  <mkestner@novell.com>

	* parser/gapi_pp.pl : fix a struct parsing bug.

2004-11-12  Mike Kestner  <mkestner@novell.com>

	* sources/gtk-sharp-sources.xml : exclude a couple more pango headers.

2004-11-09  Mike Kestner  <mkestner@novell.com>

	* */Makefile.am : make the Obsolete warnings shaddup.

2004-11-09  Mike Kestner  <mkestner@novell.com>

	* configure.in : conditional stuff for gnomevfs
	* doc/Makefile.am : conditionally update panelapplet and gnomevfs.
	* doc/en/*/* : update to add PanelApplet and Gnome.Vfs stubs.
	* gnomevfs/Makefile.am : make conditional
	
2004-11-08  Dan Winship  <danw@novell.com>

	* glib/Object.cs (CreateNativeObject): virtualize
	(Object(GType)): Mark this ctor Obsolete

	* gtk/Gtk.metadata: disable the generated GType ctor on Gtk.Widget

	* gtk/Widget.custom (Widget, CreateNativeObject,
	Widget_ParentSet): Connect to our own ParentSet event from
	CreateNativeObject and the GType ctor, and keep a static Hashtable
	of parented widgets, so that adding a managed widget to a
	container keeps both the GObject and the managed object alive.

	* generator/ObjectGen.cs (GenCtors): handle the disable_gtype_ctor
	flag. Also, mark GType ctors [Obsolete]

	* generator/ChildProperty.cs: 
	* generator/Property.cs: Fix child property names.

2004-11-07  Jeroen Zwartepoorte  <jeroen@xs4all.nl>

	* gtk/Gtk.metadata: Fix some TreeModelFilter stuff (similar to
	TreeModelSort).

2004-11-05  Jeroen Zwartepoorte  <jeroen@xs4all.nl>

	* gnomevfs/*.cs: Add copyright/LGPL header.
	* gnomevfs/*.custom: Idem.
	* gnomevfs/Mime.cs: Obsolete, replaced by MimeType.cs.
	* gnomevfs/MimeActionType.cs: Obsolete, generated now.
	* gnomevfs/OpenMode.cs: Idem.
	* gnomevfs/Result.cs: Idem.
	* gnomevfs/SeekPosition.cs: Idem.

2004-11-05  Dan Winship  <danw@novell.com>

	* parser/gapi2xml.pl (parseInitFunc, addPropElem): handle
	GtkContainer child properties

	* generator/Property.cs:
	* generator/ChildProperty.cs: make Property subclassable and add a
	"ChildProperty" subclass.

	* generator/Makefile.am (sources): add ChildProperty.cs

	* generator/ClassBase.cs: handle "childprop" nodes by creating
	ChildProperty objects.

	* glib/Value.cs (explicit operator EnumWrapper): use
	g_value_get_flags() rather than g_value_get_enum() when
	appropriate.

	* glib/glue/value.c (glibsharp_value_holds_flags): glue for that

	* gtk/gtk-api.raw: regen to pick up child properties

	* gtk/Gtk.metadata: 
	* gtk/Container.custom: hide the auto-generated
	Gtk.Container.ChildGetProperty and implement a nicer one by hand.

	* gtk/glue/container.c (gtksharp_container_child_get_property):
	utility function to set up an appropriate GValue for us

2004-11-05  Tambet Ingo  <tambet@ximian.com>

	* generator/OpaqueGen.cs: Add optional "parent" attribute to Opaque
	types.

2004-11-04  Jeroen Zwartepoorte  <jeroen@xs4all.nl>

	* gnomevfs/Directory.cs: Add async GetEntries Uri alias.
	* gtk/FileChooserDialog.custom: Add nice custom properties for Uris.
	ListFilters, ListShortcutFolders and ListShortcutFolderUris.
	* gtk/FileChooserWidget.custom: Idem.
	* gtk/Gtk.metadata: Idem.

2004-11-04  Todd Berman  <tberman@off.net>

	* glib/ListBase.cs: In Empty, call FreeList, not Dispose.

2004-11-04  Todd Berman  <tberman@off.net>

	* glib/ListBase.cs: Make sure to properly check if it is a
	GLib.Object subclass.

2004-11-04  Todd Berman  <tberman@off.net>

	* doc/en/GLib/ListBase.xml: Add documentation for ListBase.Empty
	* glib/ListBase.cs: Add ListBase.Empty, frees the children and the
	list.
	* glib/Markup.cs: Fix Alex's tomboy crash, sending -1 instead of
	Length.
	* gtk/FileChooserDialog.custom:
	* gtk/FileChooserWidget.custom: properly free the list.

2004-11-03  Todd Berman  <tberman@off.net>

	* gtk/FileChooserDialog.custom:
	* gtk/FileChooserWidget.custom: Properly implement .Filenames. The old
	code was a really bad c&p job.

2004-11-02  Jeroen Zwartepoorte  <jeroen@xs4all.nl>

	* gnomevfs/AsyncDirectoryLoadCallback.cs:
	* gnomevfs/AsyncDirectoryLoadCallbackNative.cs:
	* gnomevfs/Directory.cs: Implement asynchronous directory loading.
	* gnomevfs/FileInfo.cs: Clear the FileInfoNative struct in the
	destructor.
	* gnomevfs/Makefile.am: Add new callback files.
	* sample/gnomevfs/TestDirectory.cs: Add async test.

2004-11-01  Jeroen Zwartepoorte  <jeroen@xs4all.nl>

	* gnomevfs/Directory.cs: New Create and Delete methods. Free the
	FileInfo List returned by gnome_vfs_directory_list_load.
	* gnomevfs/FileInfo.cs: Copy the FileInfoNative struct so the original
	can be properly freed.
	* gnomevfs/Vfs.cs: Move MakeDirectory and RemoveDirectory to Directory.

2004-11-01  Jeroen Zwartepoorte  <jeroen@xs4all.nl>

	* gnomevfs/Directory.cs: Bind gnome_vfs_directory_list_load as a static
	FileInfo[] GetEntries (uri) method.
	* gnomevfs/FileInfo.cs: Add internal FileInfoNative constructor to
	create a FileInfo class based on an existing FileInfoNative struct.
	* gnomevfs/Makefile.am:
	* sample/gnomevfs/Makefile.am:
	* sample/gnomevfs/TestDirectory.cs:

2004-10-30  Todd Berman  <tberman@off.net>

	* gtk/ComboBox.custom:
	* gtk/FileChooserDialog.custom:
	* gtk/FileChooserWidget.custom: Fix c&p error with filename.

2004-10-29  Todd Berman  <tberman@off.net>

	* gtk/ComboBox.custom: Add a header.
	* gtk/FileChooserDialog.custom: Add subclassing support, and a header.
	* gtk/FileChooserWidget.custom: Add a header.

2004-10-29  Todd Berman  <tberman@off.net>

	* gtk/FileChooserDialog.custom: Add Filenames property to return
	the data as a string[] instead of a GSList.
	* gtk/FileChooserWidget.custom: Same as above.
	* gtk/Makefile.am: Add FileChooserWidget.custom

2004-10-30  Jeroen Zwartepoorte  <jeroen@xs4all.nl>

	* sources/gtk-sharp-sources.xml: Invalid XML due to unremoved -->
	closing comment tag.

2004-10-29  Todd Berman  <tberman@off.net>

	* gtk/FileChooserDialog.custom: Allow a null parent.

2004-10-29  Todd Berman  <tberman@off.net>

	* gconf/GConf/gconf-sharp-2.0.pc.in: s/PACKAGE/PACKAGE_VERSION/ to fix 
	-pkg:gtk-sharp

2004-10-29  Todd Berman  <tberman@off.net>

	* gtk-sharp-2.0.pc.in: s/PACKAGE/PACKAGE_VERSION/ to fix -pkg:gtk-sharp

2004-10-26  Dan Winship  <danw@novell.com>

	* gdk/Gdk.metadata: Remap all "out Gdk.Bitmap" params to be
	Gdk.Pixmaps instead, because the former will crash. Also fix the
	"data" param to Pixmap.CreateFromXpmD and
	Pixmap.ColormapCreateFromXpmD

	* gtk/Style.custom (TextAAGC, SetTextAAGC, LightGC, SetLightGC,
	DarkGC, SetDarkGC, MidGC, SetMidGC): add these to go along with
	BaseGC, SetBaseGC, etc.

	* gtk/glue/style.c: add the glue methods needed for the above

2004-10-21  Mike Kestner  <mkestner@ximian.com>

	* generator/SymbolTable.cs : map unsigned int to uint.  [Fixes #67732]

2004-10-21  Mike Kestner  <mkestner@ximian.com>

	* configure.in : guard against broken installs where enable_gnome
	fails but enable_gnomedb succeeds. [Fixes #67986]

2004-10-20  Dan Winship  <danw@novell.com>

	* gdk/Window.custom: add a new constructor that takes a
	Gdk.WindowAttributesType rather than an int for attributes_mask.

2004-10-18  Dan Winship  <danw@novell.com>

	* generator/OpaqueGen.cs: Don't build the (IntPtr raw) constructor
	if "disable_raw_ctor" is set on the opaque type.

	* gtk/Gtk.metadata: Make GtkTargetList opaque (fixes a crash in
	Gtk.Drag.Begin), hide the generated constructor and ref/unref
	methods, and fix up the interpretation of AddTable.

	* gtk/TargetList.custom (TargetList, ~TargetList): Implement the
	suppressed constructors and add a finalizer, which handle
	refcounting the underlying struct.
	(Add, Find, Remove): convenience overloads that take string
	instead of Gdk.Atom.

	* gtk/Makefile.am (customs): add TargetList.custom

2004-10-07  Mike Kestner  <mkestner@ximian.com>

	* gdk/Makefile.am : add missing custom file.
	* gdk/Pixmap.custom : add overloads for *CreateFromXPM* methods which
	default transparency mask and color.

2004-10-07  Todd Berman  <tberman@off.net>

	* gtk/Gtk.metadata: Mark ComboBox.GetActiveIter as an out param.

2004-10-06  John Luke  <john.luke@gmail.com>

	* gtk/Action.custom: add overload for string, string, null, null
	* gtk/UIManager.custom: add overload to get the UI from a resource
	* gtk/Makefile.am: add the 2 new custom files
	* sample/Action.cs: remove using GtkSharp, make ui_info const, quit on Quit

2004-10-05  Todd Berman  <tberman@off.net>

	* gtk/ComboBox.custom: Add SetCellDataFunc to allow you to set a
	CellLayoutDataFunc on a ComboBox.

2004-10-05  Todd Berman  <tberman@off.net>

	* gtk/ComboBox.custom: new file, to allow get/set access to 'model'.
	* gtk/Makefile.am: add ComboBox.custom.

2004-10-05  Mike Kestner  <mkestner@ximian.com>

	* gtk/Gtk.metadata : hide Selection.GetTargets.
	* gtk/SelectionData.custom : impl Targets prop and add Selection,
	Target, and Type field accessors.
	* gtk/glue/selectiondata.c : field accessor glue.

2004-10-04  Todd Berman  <tberman@off.net>

	* Merge forward patch from Miguel to fix delegate marshalling in
	1.1.1. Original Changelog follows

2004-10-04  Todd Berman  <tberman@off.net>

	* */*.pc.in: Fix the Requires to use -2.0

2004-09-29  Mike Kestner  <mkestner@ximian.com>

	* gtk/Gtk.metadata : hide some ellipsis methods, add pass_as attrs.
	* gtk/Object.custom : new IsFloating property.
	* gtk/glue/object.c : new gtksharp_object_set_floating glue.

2004-09-29  Mike Kestner  <mkestner@ximian.com>

	* generator/GStringGen.cs : new generatable impl for GStrings.
	* generator/InterfaceGen.cs : better error reporting.
	* generator/Makefile.am : add new source file.
	* generator/Method.cs : better error reporting.
	* generator/SymbolTable.cs : add new GString igen.

2004-09-29  Mike Kestner  <mkestner@ximian.com>

	* glib/GString.cs : new marshaling class for GStrings.  Used by
	generator to map GString params and returns onto managed strings.
	* glib/Makefile.am : add new file.

2004-09-27  Mike Kestner  <mkestner@ximian.com>

	* gtk/Button.custom : add a ctor (Widget). reworked from patch by
	John Luke.
	[Fixes #66228]

2004-09-26  Mike Kestner  <mkestner@ximian.com>

	* glib/Idle.cs : proxy hash keys are uints, not ints.

2004-09-24  Mike Kestner  <mkestner@ximian.com>

	* gtk/Bin.custom : make Child get/set.
	* gtk/Gtk.metadata : hide the Bin.get_child method.
	[Fixes #66232]

2004-09-23  Mike Kestner  <mkestner@ximian.com>

	* gtk/Widget.custom : new OnSetScrollAdjustments VM. 
	* gtk/glue/widget.c : glue for new VM.

2004-09-18  Miguel de Icaza  <miguel@ximian.com>

	* glib/Source.cs: Add new base class to hold the method to be
	called, and the proxy handler we use to keep references to them
	and avoid a collection.
	Exposes a new variables that references all the active Timeouts
	and Idle handlers to avoid collection/
	* glib/Timeout.cs: Implement TimeoutProxy that acts as a filter to
	remove the proxy when the timeout is removed.
	Register a TimeoutProxy when we create a timeout.
	* glib/Idle.cs: Implement IdleProxy that acts as a filter to
	remove the proxy when the idle handler is removed.
	Register an IdleProxy when we create a timeout.

2004-09-17  Mike Kestner  <mkestner@ximian.com>

	* configure.in : bump version and tag for 1.0.2.

2004-09-17  Mike Kestner  <mkestner@ximian.com>

	* configure.in : bump version and tag for 1.0.2.

2004-09-17  Mike Kestner  <mkestner@ximian.com>

	* configure.in : use either gtkhtml 3.0 or 3.2

2004-09-14  Mike Kestner  <mkestner@ximian.com>

	* gdk/* : remaining API audit fixes.

2004-09-09  Mike Kestner  <mkestner@ximian.com>

	* gdk/Device.custom : manual GetHistory impl.
	* gdk/Display.custom : manual GetPointer overloads.
	* gdk/Gdk.metadata : hides and array params.
	* gdk/Makefile.am : add new file.
	* gdk/TextProperty.cs : new manual impl of methods.

2004-09-03  Mike Kestner  <mkestner@ximian.com>

	* configure.in : expand new doc/updater makefile
	* gtk/Gtk.metadata : hide Init.Check and AbiCheck*.
	* gtk/Init.custom : manual Init.Check impl.
	* gtk/Makefile.am : add Init.custom.

2004-08-31  Mike Kestner  <mkestner@ximian.com>

	* gdk/Gdk.metadata : mark out params on *CreateWithXpm*.
	[Fixes #61116]

2004-08-31  Mike Kestner  <mkestner@ximian.com>

	* gtk/NodeStore.cs : add GType prop to expose native gtype.
	[Fixes #61226]

2004-08-31  Mike Kestner  <mkestner@ximian.com>

	* glib/Marshaller.cs : fix utc offseting for time_tToDateTime.
	[Fixes #60960]

2004-08-30  Tambet Ingo  <tambet@ximian.com>

	* glib/ListBase.cs : indexing bugfix for CopyTo.

2004-08-28  John Luke  <john.luke@gmail.com>

	* gdk/Gdk.metadata: change Gdk.KeyVal name return-type from
	gchar* to const-gchar*, so we do not try to modify it (call gfree).
	[Fixes #64421]

2004-08-27  Jeroen Zwartepoorte  <jeroen@xs4all.nl>

	* gnomevfs/Async.cs: Add Priority enum. Add methods which take an Uri
	object (similar to Sync methods).
	* gnomevfs/Vfs.cs: Add Truncate bindings.
	* gnomevfs/VfsStream.cs: Major fixes. Don't use the AsyncWaitHandle for
	blocking until an operation has finished. Fix (a)sync reading & writing.
	You either use sync/async throughout the code. Can't mix sync and async
	gnome-vfs method calls (different Handle objects).
	* gnomevfs/VfsStreamAsyncResult.cs: Throw NotSupportedException when
	AsyncWaitHandle property is accessed.
	* sample/gnomevfs/Makefile.am: New test programs.
	* sample/gnomevfs/TestAsync.cs:
	* sample/gnomevfs/TestAsyncStream.cs:
	* sample/gnomevfs/TestSyncStream.cs:

2004-08-26  Manuel V. Santos  <mvsl@telefonica.net>

	* gdk/Device.custom : glue to expose object fields.
	* gdk/DeviceAxis.custom : expand the ToString to incl use: 
	* gdk/EventButton.custom : fix for Axes prop.
	* gdk/EventMotion.custom : fix for Axes prop.
	* gdk/Gdk.metadata : hide some accessors on Device.
	* gdk/Makefile.am : add new custom.
	* gdk/glue/Makefile.am : add new .c
	* gdk/glue/makefile.win32 : add new .o
	* gdk/glue/device.c : ditto.
	* gtk/InputDialog.custom : glue to expose button fields.
	* gtk/Makefile.am : add new custom.
	* gtk/glue/Makefile.am : add new .c
	* gtk/glue/makefile.win32 : add new .o
	* gtk/glue/inputdialog.c : ditto.
	* sample/ScribbleXInput.cs : new sample using extension events.

2004-08-25  Mike Kestner  <mkestner@ximian.com>

	* generator/Signal.cs : use typeof instead of Type.GetType to
	specify the event args type.
	* glib/ObjectManager.cs : beef up the type lookup code using
	Assembly.LoadWithPartialName to fix a very popular win32 bug.
	[Fixes #61139 and friends]  Thanks to John Luke for expert
	patch testing on win32.

2004-08-25  John Luke  <john.luke@gmail.com>

	* glib/MainLoop.cs: MainLoop implementation by Jeroen
	[Fixes #61493]

2004-08-24  Mike Kestner  <mkestner@ximian.com>

	* gtk/Gtk.metadata : kill TreeDataList and TreeDataSortHeader
	internal types.

2004-08-24  Larry Ewing  <lewing@ximian.com>

	* gtk/Gtk.metadata : Style.PaintPolygon has an array of points.

2004-08-24  John Luke  <john.luke@gmail.com>

	* gtk/Makefile.am: add Menu.custom
	* gtk/Menu.custom: new custom for Popup () overload
	[Fixes #60668]
	* rsvg/Pixbuf.custom: new custom file
	* rsvg/Makefile.am: add Pixbuf.custom to build
	* rsvg/Tool.cs: remove double ; that cause warnings
	* rsvg/rsvg-sharp.pc.in: add Requires: gtk-sharp art-sharp
	[Fixes #60894]
	* gdk/PixbufLoader.custom: add Write () overload
	[Fixes #62681]

2004-08-24  Larry Ewing  <lewing@ximian.com>

	* gdk/Pixbuf.custom : add RenderThresholdAlpha overload which defaults
	to the entire pixbuf width/height.
	[Fixes #60703]

2004-08-24  Mike Kestner  <mkestner@ximian.com>

	* gdk/Drawable.custom : add a DrawPolygon overload with bool filled
	and mark the old int filled overload Obsolete.
	[Fixes #60702]

2004-08-23  Todd Berman  <tberman@off.net>

	* panelapplet/BonoboUIVerb.cs:
	* panelapplet/ContextMenuItem.cs:
	* panelapplet/Makefile.am:
	* panelapplet/PanelApplet.custom: Remove the ContextMenuItem and the
	need for the glue. Add BonoboUIVerb to directly call the setup_menu
	function. Leave the glue library for now, as I think getting the
	proper orientation stuff setup will require some glue work.
	* sample/panelapplet/testapplet.cs: Update sample to reflect new
	api. Need to make this installable.

2004-08-22  Jeroen Zwartepoorte  <jeroen@xs4all.nl>

	* gnomevfs/Makefile.am: Remove ADDITIONAL_API variable.

2004-08-20  Mike Kestner  <mkestner@ximian.com>

	* atk/Atk.metadata : mark an array param on Relation ctor.

2004-08-19  Borja Sanchez Zamorano  <borsanza@yahoo.es>

	* gtk/Gtk.metadata : hide some methods on TextBuffer.
	* gtk/TextBuffer.custom : pass -1 for the text length to some
	more methods.

2004-08-19  Jeroen Zwartepoorte  <jeroen@xs4all.nl>

	* gnomevfs/Makefile.am: Add Monitor.cs.
	* gnomevfs/Monitor.cs: New custom class wrapping the gnome_vfs_monitor_*
	methods.
	* sample/gnomevfs/Makefile.am: Added TestMonitor.cs.
	* sample/gnomevfs/TestMonitor.cs: Test case for using the new Monitor
	class.

2004-08-18  John Luke  <john.luke@gmail.com>

	* AUTHORS: fix my name
	* glade/XML.custom: remove doc comments (in monodoc)
	add overload ctor for the most common case so far
	[Fixes #62238]

2004-08-18  John Luke  <john.luke@gmail.com>

	* pango/Pango.metadata : hide a couple methods on Layout.
	* pango/Layout.custom : impl SetText and SetMarkup w/ length=-1.
	[Fixes #63057]

2004-08-18  Mike Kestner  <mkestner@ximian.com>

	* gtk/Gtk.metadata : unhide ExpanderStyle.
	* doc/en/Gtk/Style.xml : doc PaintExpander.
	* doc/en/Gtk/ExpanderStyle.xml : new enum docs.
	[Fixes #60480] metadata patch from Jeroen Zwartepoorte.

2004-08-17  Mike Kestner  <mkestner@ximian.com>

	* pango/Pango.metadata : metadata for the pango audit.
	* pango/*.custom : customizations to fix audited API.
	* doc/en/* : docs for some api changes and additions.
	* glib/Marshaller.cs : some gunichar marshal-fu.
	* glib/glue/unichar.c : a new glue method.

2004-08-14  Todd Berman  <tberman@off.net>

	* gnomevfs/VfsStream.cs: if ErrorEof is returned in Read, return 0
	instead of throwing an exception.

2004-08-13  John Luke  <john.luke@gmail.com>

	* gtk/Gtk.metadata: mark Gtk.StockManager.Lookup param as ref
	patch by jaspervp@gmx.net (Jasper van Putten)
	[Fixes #61893]

2004-08-13  Mike Kestner  <mkestner@ximian.com>

	* gtk/Gtk.metadata : hide Insert and SetText for manual impl.
	* gtk/TextBuffer.custom : pass -1 for length to Insert and SetText.
	Adapted from a patch by borsanza@yahoo.es (Borja Sanchez Zamorano).
	[Fixes #62985]

2004-08-10  Todd Berman  <tberman@off.net>

	* gnomevfs/AssemblyInfo.cs.in: use the .snk, not the .pub.

2004-08-10  Jeroen Zwartepoorte  <jeroen@xs4all.nl>

	* glib/MainLoop.cs:
	* gnomevfs/.cvsignore:
	* gnomevfs/Async.cs:
	* gnomevfs/FileInfo.cs:
	* gnomevfs/Gnomevfs.metadata:
	* gnomevfs/Makefile.am:
	* gnomevfs/MimeType.cs:
	* gnomevfs/Sync.cs:
	* gnomevfs/Uri.custom:
	* gnomevfs/VfsStream.cs:
	* gnomevfs/VfsStreamAsyncResult.cs:
	* gnomevfs/VolumeMonitor.custom:
	* gnomevfs/Xfer.cs:
	* gnomevfs/XferProgressCallback.cs:
	* gnomevfs/XferProgressCallbackNative.cs:
	* gnomevfs/filesize.diff:
	* gnomevfs/gnomevfs-api.raw:
	* sample/gnomevfs/.cvsignore:
	* sample/gnomevfs/Makefile.am:
	* sample/gnomevfs/TestInfo.cs:
	* sample/gnomevfs/TestMime.cs:
	* sample/gnomevfs/TestSync.cs:
	* sample/gnomevfs/TestSyncCreate.cs:
	* sample/gnomevfs/TestSyncWrite.cs:
	* sample/gnomevfs/TestUnlink.cs:
	* sample/gnomevfs/TestVolumes.cs:
	* sample/gnomevfs/TestXfer.cs:
	
	Commit new gnomevfs files and samples. Also the GLib.MainLoop addition
	for programs which don't want to use Gtk.Application.Run (), but still
	use the GLib main loop.

2004-08-04  Raja R Harinath  <rharinath@novell.com>

	* configure.in (GTKHTML): Use SOVERSION=11 for GtkHTML 3.1.18.
	* gda/Makefile.am ($(API)): Remove duplicated $(srcdir).

2004-07-30  Mike Kestner  <mkestner@ximian.com>

	* parser/gapi2xml.pl : char const * fixes for clahey's gsf binding.

2004-07-28  Jeroen Zwartepoorte  <jeroen@xs4all.nl>

	* */*: merge from HEAD again.

2004-07-24  Mike Kestner  <mkestner@ximian.com>

	* gdk/Gdk.metadata : hide Window.Destroy.
	* gdk/Window.custom : manually impl Destroy since it releases our ref.
	* glib/Object.cs : support unset of Raw values.

2004-07-22  Mike Kestner  <mkestner@ximian.com>

	* glib/Value.cs : allow null for ctor(GLib.Object).

2004-07-18  Todd Berman  <tberman@off.net>

	* panelapplet/Makefile.am: We dont actually use gnome-sharp.dll, remove
	it.

2004-07-16  John Luke  <jluke@cfl.rr.com>

	* gtk/Gtk.metadata:
	* glade/Glade.metadata: mark return type as const-gchar* for
	Gtk.Global.CheckVersion and Glade.Global.ModuleCheckVersion
	so Gtk# does not try to free them.  Thanks to
	jaspervp@gmx.net (Jasper van Putten) for identifying the Glade
	part. Fixes bugs #61329 and #60954

2004-07-12  Martin Willemoes Hansen  <mwh@sysrq.dk>

	* gnome/Gnome.metadata: Fixed typo i to 1
	  Remove unnessesary disabledefaultconstructor
	* gnome/PrintJob.custom: Change ctor to an overload ctor

2004-07-11  Todd Berman  <tberman@off.net>

	* panelapplet/ContextMenuItem.cs: New struct to hold context menu
	item information.
	* panelapplet/Makefile.am: added new file.
	* panelapplet/PanelApplet.custom: add glue accessor to set the context
	menu.
	* panelapplet/glue/panelapplet.c: new glue functionality to setup a
	context menu.
	* sample/panelapplet/testapplet.cs: expand sample to show context menu
	code.

2004-07-10  Todd Berman  <tberman@off.net>

	* panelapplet/panelapplet-sharp-2.0.pc.in: fix path.

2004-07-09  Mike Kestner  <mkestner@ximian.com>

	* gdk/Gdk.metadata : mark gc param of Drawable.DrawPixbuf null_ok.

2004-07-09  Todd Berman  <tberman@off.net>

	* Makefile.am:
	* configure.in:
	Add panelapplet stuff to configure.in and the subdirs.
	* generator/ClassBase.cs:
	* generator/ObjectGen.cs:
	Add a new attribute 'abstract' to allow a class to be defined to be
	abstract. PanelApplet.PanelApplet uses this.
	* panelapplet/.cvsignore:
	* panelapplet/AppletFactory.cs:
	* panelapplet/AssemblyInfo.cs.in:
	* panelapplet/Makefile.am:
	* panelapplet/PanelApplet.cs:
	* panelapplet/PanelApplet.custom:
	* panelapplet/PanelApplet.metadata:
	* panelapplet/panelapplet-api.raw:
	* panelapplet/panelapplet-sharp-2.0.pc.in:
	* panelapplet/panelapplet-sharp.dll.config.in:
	* panelapplet/glue/.cvsignore:
	* panelapplet/glue/Makefile.am:
	* panelapplet/glue/panelapplet.c:
	Initial import of the panelapplet code. This code is largely
	untested, and will need a good amount of glue. For sure glue code is
	needed for the context menu items.
	* sample/panelapplet/CSharpTestApplet_Factory.server:
	* sample/panelapplet/monodoc.png:
	* sample/panelapplet/testapplet.cs:
	A small testcase for the panelapplet. There is no makefile yet, and
	the server needs some help as it uses an absolute path that will only
	work on my box. When I get back to Toronto (so some point this weekend)
	I will fix this code to build/install properly and add a README file
	to help with any potential issues.
	* sources/Makefile.am:
	* sources/gtk-sharp-sources.xml:
	Add the panelapplet-sharp stuff to the build here.

2004-07-06  Todd Berman  <tberman@off.net>

	* sources/gtk_tree_model_signal_fix.patch: duh, this is the real patch.

2004-07-06  Todd Berman  <tberman@off.net>

	* sources/Makefile.am:
	* sources/gtk_tree_model_signal_fix.patch: a new hacky patch to fix
	the signal generation on the tree model structs.
	* */*-api.raw: regen.
	* glib/Object.cs: merge forward a small patch.

2004-07-06  Todd Berman  <tberman@off.net>

	* Makefile.am:
	* configure.in:
	* gtk-sharp-2.0.pc.in:
	* gtk-sharp.pc.in:
	* art/.cvsignore:
	* art/Makefile.am:
	* art/art-sharp-2.0.pc.in:
	* art/art-sharp.pc.in:
	* gconf/GConf/.cvsignore:
	* gconf/GConf/Makefile.am:
	* gconf/GConf/gconf-sharp-2.0.pc.in:
	* gconf/GConf/gconf-sharp.pc.in:
	* gda/.cvsignore:
	* gda/Makefile.am:
	* gda/gda-sharp-2.0.pc.in:
	* gda/gda-sharp.pc.in:
	* glade/.cvsignore:
	* glade/Makefile.am:
	* glade/glade-sharp-2.0.pc.in:
	* glade/glade-sharp.pc.in:
	* gnome/.cvsignore:
	* gnome/Makefile.am:
	* gnome/gnome-sharp-2.0.pc.in:
	* gnome/gnome-sharp.pc.in:
	* gnomedb/.cvsignore:
	* gnomedb/Makefile.am:
	* gnomedb/gnomedb-sharp-2.0.pc.in:
	* gnomedb/gnomedb-sharp.pc.in:
	* gnomevfs/.cvsignore:
	* gnomevfs/gnome-vfs-sharp-2.0.pc.in:
	* gnomevfs/gnome-vfs-sharp.pc.in:
	* gtkhtml/.cvsignore:
	* gtkhtml/Makefile.am:
	* gtkhtml/gtkhtml-sharp-2.0.pc.in:
	* gtkhtml/gtkhtml-sharp.pc.in:
	* rsvg/.cvsignore:
	* rsvg/Makefile.am:
	* rsvg/rsvg-sharp-2.0.pc.in:
	* rsvg/rsvg-sharp.pc.in:
	* sample/rsvg/Makefile.am:
	* vte/.cvsignore:
	* vte/Makefile.am:
	* vte/vte-sharp-2.0.pc.in:
	* vte/vte-sharp.pc.in:
	Make gtk-sharp-2.0 parallel installable with gtk-sharp. Now you can
	install both and do -pkg:gtk-sharp-2.0 or similar to compile against
	the gtk-sharp-2.0 assemblies.

	Basically this change comprised some small configure.in changes to
	change the $(PACKAGE) to gtk-sharp-2.0, and check for the appropriate
	versions of the gnome 2.6 based libraries.

	Also, every .pc file was renamed -2.0.pc to allow for the parallel
	install, and the .cvsignore and Makefile.am rules were updated to
	reflect this change.

2004-07-05  John Luke  <jluke@cfl.rr.com>

	* sample/VteTest.cs: improve the scrolling in the sample
	and pass on the Environment variables

2004-07-02  Mike Kestner  <mkestner@ximian.com>

	* configure.in : dist the HACKING file from now on.

2004-07-01  Mike Kestner  <mkestner@ximian.com>

	* sample/rsvg/Makefile.am : add an art-sharp /r.

2004-06-30  John Luke  <jluke@cfl.rr.com>

	* vte/Vte.metadata: remove unneeded metadata and add comments

2004-06-29  Mike Kestner  <mkestner@ximian.com>

	* configure.in : bump version to 1.0 and tag.  Woot!

2004-06-25  Mike Kestner  <mkestner@ximian.com>

	* */*.cs : add lgpl license blurb and clean up (c)'s.
	* */*.custom : add lgpl license blurb and clean up (c)'s.
	* */glue/*.c : add lgpl license blurb and clean up (c)'s.
	file adds without license from now on are punishable by wedgie.

2004-06-25  Mike Kestner  <mkestner@ximian.com>

	* generator/*.cs : add gpl license blurb and clean up (c)'s.
	* parser/* : ditto
	* doc/*.cs : ditto
	* doc/gen-handlerargs-docs.cs : add little scripty.

2004-06-25  Mike Kestner  <mkestner@ximian.com>

	* configure.in : tag and bump version to 0.99.

2004-06-23  Todd Berman  <tberman@off.net>

	* doc/*/*.xml: s/GtkSharp.SignalArgs/GLib.SignalArgs/;

2004-06-22  Mike Kestner  <mkestner@ximian.com>

	* configure.in : GLIB check for gobject, not glib.

2004-06-20  Jeroen Zwartepoorte  <jeroen@xs4all.nl>

	* gdk/Gdk.metadata: Fix merging errors.
	* gnome/CanvasItem.custom: Idem.
	* gtk/Widget.custom: Idem.

2004-06-20  Jeroen Zwartepoorte  <jeroen@xs4all.nl>

	* *: Merge with HEAD.

2004-06-17  Larry Ewing  <lewing@ximian.com>

	* gdk/Makefile.am (sources): add Pixdata.custom
	* gdk/Pixdata.custom: add new file to fix Serialize.
	* gnome/CanvasItem.custom: remove the incorrect custom bindings.
	* gnome/Gnome.metadata: stop hiding the AffineRelative and
	AffineAbsolute the generator gets them right they are not out
	params.
	* gdk/Gdk.metadata: mark the Pixdata byte stream as and array hide
	the broken serialize method.

2004-06-18  John Luke  <jluke@cfl.rr.com>

	* sample/rsvg/Makefile.am:  do not reference gnome-sharp and art-sharp
	* sample/rsvg/svghelloworld.cs: rework with just gtk (no gnome deps)

2004-06-15  Mike Kestner  <mkestner@ximian.com>

	* gtk/Gtk.metadata : hide the button_new_from_stock ctor.
	* gtk/Button.custom : add a manual ctor implementation.

2004-06-14  Mike Kestner  <mkestner@ximian.com>

	* configure.in : another "really frozen this time" release.
	* gdk/Gdk.metadata : mark a couple array params on Pixbuf.Savev.
	* gdk/Pixbuf.custom : add a Save implementation.

2004-06-14  Mike Kestner  <mkestner@ximian.com>

	* configure.in : bump the version to 0.97, tag.

2004-06-12  Todd Berman  <tberman@sevenl.net>

	* glib/ObjectManager.cs: change CreateInstance overload being used
	to properly pick up protected ctors.

2004-06-11  Todd Berman  <tberman@sevenl.net>

	* gtk/Container.custom:
	* gtk/CellRenderer.custom:
	* gnome/CanvasItem.custom: mark Override* private.
	* doc/en/*/*.xml: update to remove Override* methods.

2004-06-11  Mike Kestner  <mkestner@ximian.com>

	* doc/en/*/*.xml : update to remove Override* methods.
	* generator/Signal.cs : make the Override* methods private.  They
	should not ever be called manually and it saves about 800 "do not
	call this method" doc entries.

2004-06-11  Mike Kestner  <mkestner@ximian.com>

	* configure.in : require mono-0.96, bump the version, tag.

2004-06-11  Mike Kestner  <mkestner@ximian.com>

	* configure.in : remove the mint usage for darwin.

2004-06-11  Mike Kestner  <mkestner@ximian.com>

	* configure.in : deal with a csc-ism in source paths.
	* */Makefile.am : use the GENERATED_SOURCES var.
	* */glue/Makefile.am : add -no-undefined for win32 dll builds.

2004-06-10  Mike Kestner  <mkestner@ximian.com>

	* configure.in : break the monodoc dep, even though it was optional
	it was a pain in the backside.
	* doc/Makefile.am : add assemble target to build docs using monodoc.
	we now have two manual targets which use monodoc, but aren't required
	for the default build (update and assemble).

2004-06-10  Mike Kestner  <mkestner@ximian.com>

	* configure.in : AC_SUBST GACUTIL_FLAGS. require mono-0.95 (though
	it's really cvs bleeding edge.)
	* * AssemblyInfo.cs.in : s/pub/snk.  delaysign=no.
	* * Makefile.am : s/pub/snk.  portability fixes to csc from John 
	Luke.  Switch to GACUTIL_FLAGS.
	* doc/Makefile.am : don't build docs, install raw xml to the prefix.
	
2004-06-10  Todd Berman  <tberman@sevenl.net>

	* gtk/Container.custom: add C# glue for virtualizing ChildType ()
	* gtk/glue/container.c: add C glue for virtualizing ChildType ()
	* gtk/Gtk.metadata: hide Container.ChildType ()
	* gtk/Widget.custom: Add ClearFlag, and SetFlag convenience methods.
	Also add various IsFlag bool properties for checking for flags.
	* gtk/glue/widget.c: Fix setting flags.
	* doc/*: updated Widget docs.

2004-06-09  Todd Berman  <tberman@sevenl.net>

	* gdk/Gdk.metadata: mark Window.SetBackPixmap as null_ok.
	* glib/Object.cs: in set_Raw, if value == IntPtr.Zero, dont put that
	in the weakref hashtable, as it creates later issues with gtk+
	returning null and gtk# mistaking if for an object.

2004-06-08  Mike Kestner  <mkestner@ximian.com>

	* gnomedb/Application.cs : add a missing DllImport.

2004-06-08  Mike Kestner  <mkestner@ximian.com>

	* gdk/Gdk.metadata : mark array param on Drawable.*Image.

2004-06-08  Mike Kestner  <mkestner@ximian.com>

	* gdk/Gdk.metadata : mark array param on Drawable.DrawGrayImage.

2004-06-07  Mike Kestner  <mkestner@ximian.com>

	* */Makefile.am : s|--unsafe|/unsafe to remove a mcs-ism that jluke
	exposed in his cygwin build patch.

2004-06-07  Jeroen Zwartepoorte  <jeroen@xs4all.nl>

	* configure.in: Add pango pkg-config check.
	* pango/Layout.custom: Updated custom code to new opaque LayoutLine.
	* pango/LayoutLine.custom: Properties for LayoutLine struct fields.
	* pango/Makefile.am:
	* pango/Pango.metadata: Make LayoutLine opaque [Fixes #59666].
	* pango/glue/.cvsignore:
	* pango/glue/Makefile.am:
	* pango/glue/layoutline.c: glue for the LayoutLine struct fields.
	* pango/glue/makefile.win32:
	* pango/glue/win32dll.c:

2004-06-07  Todd Berman  <tberman@sevenl.net>

	* gtk/Widget.custom: expose some easy bool properties for checking
	certain WidgetFlags. Make Allocation a settable property.
	* gtk/glue/widget.c: bit of glue to make Allocation settable.
	* gdk/Window.custom: expose UserData as a usable IntPtr property.
	* gdk/Gdk.metadata: hide old GetUserData/SetUserData methods.
	* doc/*: ran the updater.

2004-06-07  Jeroen Zwartepoorte  <jeroen@xs4all.nl>

	* gtk/Widget.custom: Add FocusLineWidth property.
	* gtk/glue/widget.c: (gtksharp_gtk_widget_set_flags),
	(gtksharp_gtk_widget_style_get_int): glue for getting an integer style
	property.

2004-06-07  John Luke  <jluke@cfl.rr.com>
 
 	* doc/Makefile.am: install the docs if monodoc is there
 
2004-06-07  Peter Williams  <peter@newton.cx>

	* configure.in (MONODOC_REQUIRED_VERSION): Fix missing 'test' in
	shell if statement.

2004-06-07  Jeroen Zwartepoorte  <jeroen@xs4all.nl>

	* gtk/Widget.custom: Add the AddAccelerator method back which got
	removed by accident during the last merge.
	* sample/CustomNotebook.cs: New sample showing of a custom Notebook.

2004-06-07  Jeroen Zwartepoorte  <jeroen@xs4all.nl>

	* *: Merge with HEAD.

2004-06-04  Todd Berman  <tberman@sevenl.net>

	* glib/Object.cs: ConnectDefaultHandlers needs to look at public api
	as well	for virtual methods.
	* gtk/CellRenderer.custom:
	* gtk/Container.custom:
	* gnome/CanvasItem.custom: Add DefaultSignalHandler to remove the need
	for the static ctor.

2004-06-04  Todd Berman  <tberman@sevenl.net>

	* gnome/CanvasItem.custom: Changed from OnXXX vmethods to XXX vmethods
	* gnome/CanvasProxy.cs: removed, unused code
	* gnome/GtkSharp.BoundsHandler.cs: removed
	* gnome/GtkSharp.DrawHandler.cs: removed
	* gnome/GtkSharp.PointHandler.cs: removed
	* gnome/GtkSharp.RenderHandler.cs: removed
	* gnome/GtkSharp.UpdateHandler.cs: removed
	* gnome/Makefile.am: updated to reflect removing of old files.
	* gtk/CellRenderer.custom: Changed from OnXXX vmethods to XXX vmethods,
	and added StartEditing vmethod
	* gtk/Container.custom: Changed from OnForall to ForAll
	* gtk/Gtk.metadata: hide CellRenderer.GetSize and StartEditing
	* gtk/glue/cellrenderer.c: new glue for CellRenderer.StartEditing
	override.
	* sample/CustomCellRenderer.cs: updated signatures to reflect new
	code.

2004-06-02  Vladimir Vukicevic  <vladimir@pobox.com>

	* gdk/Pixbuf.custom : Pixels prop isn't unsafe

2004-06-02  Mike Kestner  <mkestner@ximian.com>

	* generator/Field.cs : add field hiding, for manual impl.
	* generator/StructBase.cs : support disable_new, for manual impl.

2004-06-01  Jeroen Zwartepoorte  <jerone@xs4all.nl>

	* sample/CustomWidget.cs: remove custom GType stuff.

2004-06-01  Mike Kestner  <mkestner@ximian.com>

	* generator/ObjectGen.cs : generate protected ctor () for all 
	GLib.Objects that don't have any ctors.
	* gtk/CellRenderer.custom : remove ctor ().
	* gtkhtml/Gtk.metadata : add a disable_void_ctor rule for HTML.

2004-06-01  Jeroen Zwartepoorte  <jeroen@xs4all.nl>

	* configure.in: Merge with HEAD again.
	* gdk/Gdk.metadata:
	* gnome/CanvasItem.custom:
	* gtk/Gtk.metadata:
	* sample/.cvsignore:
	* sample/CustomWidget.cs: Inherit from Gtk.Bin and make it a better
	suited sample.

2004-06-01  Mike Kestner  <mkestner@ximian.com>

	* gtk/Gtk.metadata : mark SizeRequest requisition as out, not ref.
	[Fixes #59388]

2004-06-01  Jeroen Zwartepoorte  <jeroen@xs4all.nl>

	* sample/CustomWidget.cs: Fixed Widget.SizeRequest usage. Works properly
	now.

2004-05-31  Mike Kestner  <mkestner@ximian.com>

	* configure.in : Bump version to 0.93 and tag.

2004-05-31  Jeroen Zwartepoorte  <jeroen@xs4all.nl>

	* gtk/Gtk.metadata: unhide WidgetFlags.
	* gtk/Widget.custom: add setter for GdkWindow prop. Add Flags prop.
        * gtk/glue/widget.custom: setter for window, accessors for flags.
	[Fixes #59337]

2004-05-31  Jeroen Zwartepoorte  <jeroen@xs4all.nl>

	* gdk/Gdk.metadata: fix member names in WindowClass.
	[Fixes #59336]

2004-05-31  Jeroen Zwartepoorte  <jeroen@xs4all.nl>

	* gdk/Gdk.metadata: mark dest rects as out for Intersect and Union.
	[Fixes #59341]

2004-05-31  Jeroen Zwartepoorte  <jeroen@xs4all.nl>

	* gtk/Gtk.metadata: Unhide the GtkWidgetFlags enum.
	* gtk/Makefile.am: Remove WidgetFlags.cs.
	* gtk/WidgetFlags.cs: Obsolete.

2004-05-31  Jeroen Zwartepoorte  <jeroen@xs4all.nl>

	* sample/CustomWidget.cs: The Gtk.Requisition is passed by reference in
	the OnSizeRequested handler.

2004-05-31  Jeroen Zwartepoorte  <jeroen@xs4all.nl>

	* *: Merge changes from HEAD again.

2004-05-31  Jeroen Zwartepoorte  <jeroen@xs4all.nl>

	* gtk/Container.custom: Merged fix for Container.Forall handler.
	* gtk/Makefile.am: Added WidgetFlags.cs.
	* gtk/Widget.custom: Added Flags property and setter to GdkWindow.
	* gtk/WidgetFlags.cs: Enumeration of widget flags (from widget.h).
	* gtk/glue/container.c: (gtksharp_container_invoke_gtk_callback): Fixes
	for Container.Forall handler.
	* gtk/glue/widget.c: (gtksharp_gtk_widget_set_window),
	(gtksharp_gtk_widget_get_state), (gtksharp_gtk_widget_get_flags),
	(gtksharp_gtk_widget_set_flags): Added new API which is needed to write
	custom gtk widgets.
	* parser/gapi_pp.pl: Match #if !defined (*_DISABLE_DEPRECATED) properly.
	* sample/CustomWidget.cs: new sample for creating a custom Gtk widget.
	* sample/Makefile.am: Added CustomWidget.cs sample.

2004-05-29  Mike Kestner  <mkestner@ximian.com>

	* gnome/CanvasItem.custom : for OnUpdate, Art.SVP can be NULL
	so treat it as an IntPtr with Zero checks and manual marshaling.

2004-05-28  Vladimir Vukicevic  <vladimir@pobox.com>

	* gtk/CellRenderer.custom: fix GetSize_cb, cell_area can be NULL
	coming from Gtk (so can't use ref Gdk.Rectangle, have to use
	IntPtr)

2004-05-28  Miguel de Icaza  <miguel@ximian.com>

	* Added System.Drawing samples.

2004-05-28  Mike Kestner  <mkestner@ximian.com>

	* configure.in : bump for next version, tagged 0.92.

2004-05-28  Vladimir Vukicevic  <vladimir@pobox.com

	* gtk/Gtk.metadata : s/out/ref on TreeModel.NextIter.

2004-05-28  Mike Kestner  <mkestner@ximian.com>

	* generator/ObjectGen.cs : adjust to ObjectManager ns change.
	* glib/ManagedValue.cs : move to GLib and internalize.
	* glib/Object.cs : adjust to ObjectManager ns change.
	* glib/ObjectManager.cs : move to GLib.
	* glib/TypeConverter.cs : move to GLib.  return ManagedValue.GType
	when we can't match a type instead of GType.None.
	* gtk/*.custom: adjust for new TypeConverter ns and behavior.

2004-05-28  Mike Kestner  <mkestner@ximian.com>

	* gtk/Makefile.am : add new custom.
	* gtk/Settings.custom: add props for unparsed API.

2004-05-27  Mike Kestner  <mkestner@ximian.com>

	* glib/Object.cs: mark GType property public.

2004-05-27  Jeroen Zwartepoorte  <jeroen@xs4all.nl>

	* gtk/Gtk.metadata: Hide the GtkCtree class (old gtk+ 1.x junk).

2004-05-26  Mike Kestner  <mkestner@ximian.com>

	* gtkhtml/Gtk.metadata : hide Gtk.HTML the ctors.
	* gtkhtml/HTML.custom : new manual impl for ctors.
	* gtkhtml/Makefile.am : add new custom [Fixes #59148]

2004-05-25  Jeroen Zwartepoorte  <jeroen@xs4all.nl>

	* gnome/Gnome.metadata: Don't hide the GtkEntry and GnomeEntry
	properties.
	* gtk/Accel.custom: Add custom methods for backwards compatibility of
	the gtk_accel_map_* methods. [Fixes #58954]

2004-05-25  Dan Winship  <danw@ximian.com>

	* gtk/Gtk.metadata : mark a ref param in SizeRequested

2004-05-25  Mike Kestner  <mkestner@ximian.com>

	* */Makefile.am : rm generated/* in generated-stamp target.

2004-05-25  Mike Kestner  <mkestner@ximian.com>

	* configure.in : don't expand the GAPI Makefile.
	* parser/Makefile.am : remove SUBDIRS.
	* parser/gapi2xml.pl : remove GAPI::Metadata usage.
	* parser/GAPI/* : kill. long live gapi-fixup.

2004-05-25  Mike Kestner  <mkestner@ximian.com>

	* gtk/Container.custom : use glue to invoke the GtkCallback in
	Forall.
	* gtk/glue/container.c : add gtksharp_container_invoke_gtk_callback.

2004-05-23  Mike Kestner  <mkestner@ximian.com>

	* generator/SignalHandler.cs : put back the ObjectGen hack
	for param wrapping.  [Fixes #58876]

2004-05-23  Jeroen Zwartepoorte  <jeroen@xs4all.nl>

	* atk/atk-api.xml: Removed.
	* gdk/gdk-api.xml: Idem.
	* glade/glade-api.xml: Idem.
	* gnome/IconTheme.cs: s/GLibSharp/GLib/
	* gnome/gnome-api.xml: Removed.
	* gtk/Adjustment.custom: Obsolete custom property code.
	* gtk/glue/adjustment.c: (gtksharp_gtk_adjustment_set_bounds): Idem.
	* gtk/gtk-api.xml: Removed.
	* pango/pango-api.xml: Idem.

2004-05-23  Jeroen Zwartepoorte  <jeroen@xs4all.nl>

	Merge changes from HEAD since yesterday.

2004-05-22  Mike Kestner  <mkestner@ximian.com>

	* configure.in : require mono-0.91.99.  Sorry, but we need to
	require mono cvs until beta2 because of some recent breakage in 
	Gnome.Program custom code while reflecting against the runtime.

2004-05-22  Todd Berman  <tberman@sevenl.net>

	* gnome/Program.custom: Change the Mono.Runtime stuff to reflect
	its new internal nature. This fixes MD, gnunit, and all gnome#
	programs that were blowing up for no reason.

2004-05-23  Jeroen Zwartepoorte  <jeroen@xs4all.nl>

	* *: Merge changes from HEAD again.

2004-05-22  Radek Doulik  <rodo@ximian.com>

	* gtk/TreeView.custom(GetPathAtPos): change Gtk.TreeViewColumn
	column parameter to out[put] as gtk_tree_view_get_path_at_pos
	returns column address to column parameter
	(GetPathAtPos): use GLib.Object.GetObject so that we don't create
	new TreeViewColumn object duplicates

2004-05-19  Mike Kestner  <mkestner@ximian.com>

	* gtk/Container.custom : add CallbackInvoke and use it in OnForall.

2004-05-19  Mike Kestner  <mkestner@ximian.com>

	* generator/Makefile.am : add TimeTGen.cs 
	* generator/SymbolTable.cs : use new TimeTGen.
	* generator/StringGen.cs : s/GLibSharp/GLib
	* generator/TimeTGen.cs : generatable to marshal time_t.
	* glib/time_t_CustomMarshaler.cs : kill
	* glib/Makefile.am : remove time_t_CustomMarshaler.cs
	* glib/Markup.cs : s/GLibSharp/GLib
	* glib/Marshaller.cs : move to GLib namespace. Add methods to
	marshal time_t to and from DateTime.
	* glib/glue/time_t.c : kill
	* glib/glue/Makefile.am : remove time_t.c
	* glib/glue/makefile.win32 : remove time_t.o
	* gnome/*.custom : use GLib.Marshaller instead of the time_t custom
	marshaler.
	* gtk/*.custom : s/GLibSharp/GLib

2004-05-18  Zoltan Varga  <vargaz@freemail.hu>

	* glib/time_t_CustomMarshaler.cs: Fix custom marshalling after runtime
	changes.

2004-05-18  Vladimir Vukicevic  <vladimir@pobox.com

	* gnome/Print.custom: Cast .Pixels usage to a (byte *)

2004-05-17  Vladimir Vukicevic  <vladimir@pobox.com>

	* gdk/Pixbuf.custom: Changed Pixbuf.Pixels to return an IntPtr instead
	of a byte * -- anyone who needs a byte * can do the cast in an unsafe
	context already.

2004-05-18  Todd Berman  <tberman@sevenl.net>

	* samples/Scribble.cs: Im bored, you can erase, etc

2004-05-18  Mike Kestner  <mkestner@ximian.com>

	* glib/MissingIntPtrCtorException.cs : new exception to throw if 
	unable to access an IntPtr ctor on a GLib.Object subclass.  We need
	an IntPtr ctor to be able to wrap arbitrary object handles.
	* glib/Object.cs : have NativeType call LookupGType.
	* glib/ObjectManager.cs : throw the new exception in a try/catch.

2004-05-17  Mike Kestner  <mkestner@ximian.com>

	* generator/ObjectGen.cs : Generate a .cctor that calls the assembly's
	ObjectManager.Initialize method if the class will need to be registered
	with GLib.ObjectManager.  Enhance the Initialize method to allow 
	multiple invocations.

2004-05-17  Mike Kestner  <mkestner@ximian.com>

	* generator/SignalHandler.cs : fix some broken/redundant generation in
	the Object/Struct wrapping for sig params.
	* glib/Object.cs : internalize/protect lots of API that shouldn't need
	to be used by non-subclass/non-glib code. Return GType.Object as GType.
	* glib/Value.cs : use internal GLib.Object.NativeType prop.
	* sample/TestDnd.cs : use ToString instead of TypeName.

2004-05-14  Todd Berman  <tberman@sevenl.net>

	* glib/Object.cs: make static GLib.Object.LookupGType protected for now.
	* gtk/CellRenderer.custom: code to allow for subclassing and
	implementing a custom cell renderer.
	* gtk/Makefile.am: add custom to build.
	* gtk/glue/Makefile.am: add glue to build.
	* gtk/glue/cellrenderer.c: glue code to override get_size and render
	from cellrenderer.
	* sample/CustomCellRenderer.cs: new sample to show how to implement a
	custom cell renderer.
	* sample/Makefile.am: add CustomCellRenderer sample.

2004-05-13  Todd Berman  <tberman@sevenl.net>

	* *.pc.in: add .dll to the end of the Libs: references, and convert
	them to be absolute paths.

2004-05-11  Mike Kestner  <mkestner@ximian.com>

	* *.pc.in : add Requires so that dependent libs are pulled in too.

2004-05-11  Mike Kestner  <mkestner@ximian.com>

	* gconf/GConf/NotifyWrapper.cs : add some defensive null checking.
	[fixes #57902]

2004-05-11  Mike Kestner  <mkestner@ximian.com>

	* gtk/SelectionData.custom : add a Set overload without length param.

2004-05-10  Mike Kestner  <mkestner@ximian.com>

	* gtk/Gtk.metadata : mark some Dialog API params as ResponseType 
	instead of int.
	[fixes #58240]

2004-05-10  Mike Kestner  <mkestner@ximian.com>

	* glib/Value.cs : fix GBoxed GLib.Value setting.
	[fixes #58229]

2004-05-10  Mike Kestner  <mkestner@ximian.com>

	* gtk/Gtk.metadata : change return-type on Global.EventsPending
	to a bool to avoid compat problems in 2.4.  Also rename to
	GetEventsPending so that it's generated as a property.
	[fixes #58292]

2004-05-10  Mike Kestner  <mkestner@ximian.com>

	* gtk/Gtk.metadata : hide some ctors and map some prop names.
	* gtk/Makefile.am : add new customs.
	* gtk/ItemFactory.custom : implement ctor for subclassing.
	* gtk/Plug.custom : implement ctors for subclassing.

2004-05-09  Jeroen Zwartepoorte  <jeroen@xs4all.nl>

	* gdk/Gdk.metadata: Misc fixes for getting Muine to build & run.
	* gtk/FileSelection.custom: Add this back.
	* gtk/Gtk.metadata: Misc fixes for getting Muine to build & run.

2004-05-08  Jeroen Zwartepoorte  <jeroen@xs4all.nl>

	* gconf/GConf.PropertyEditors/Makefile.am: Reinclude the OptionMenu
	property editor.
	* gdk/Gdk.metadata:
	* gdk/Pixbuf.custom: Add backwards compatible implementations of
	GetFromDrawable, RenderPixmapAndMask and a couple of others which are 
	now static in gtk+ 2.4. These methods have the same API as the ones 
	generate for gtk+ 2.2.
	* gdk/gdk-api.raw:
	* generator/ClassBase.cs: Generate an [Obsolete] tag for deprecated
	code.
	* generator/ClassGen.cs: Idem.
	* generator/Method.cs: Idem.
	* generator/ObjectGen.cs: Idem.
	* gnome/Gnome.metadata:
	* gnome/IconData.cs:
	* gnome/IconTheme.cs: GnomeIconTheme inherits directly from GtkIconTheme
	in libgnomeui-2.6. This breaks the parser, so it won't generate the
	proper code. This is a manual class implementation for backward
	compatibility with gtk+ 2.2 version of gtk#.
	* gnome/IconTheme.custom: Removed
	* gnome/Makefile.am:
	* gnome/gnome-api.raw:
	* gtk/Gtk.metadata:
	* gtk/IconTheme.custom: Added custom methods previously found in
	../gnome/IconTheme.custom.
	* gtk/gtk-api.raw:
	* pango/pango-api.raw:
	* parser/gapi2xml.pl: Check for "deprecated" prefixes and add a
	deprecated attribute to the appropriate elements when found.
	* parser/gapi_pp.pl: Prefix everything that's in a #ifndef
	*_DISABLE_DEPRECATED block with "deprecated".
	* sample/GtkDemo/DemoMain.cs: s/File/System.IO.File/ since there's now
	also a Gtk.File class.
	* sample/GtkDemo/DemoSizeGroup.cs: Use the original OptioMenu code.
	* sample/GtkDemo/DemoTextView.cs: s/File/System.IO.File/.
	* sample/Makefile.am:
	* sources/gtk-sharp-sources.xml: Add a bunch of <exclude>s to the Gtk
	namespace so it won't generate API for _really_ old deprecated widgets
	like GtkCList, GtkCTree etc.
	
	This commit adds support for deprecated widgets to gtk#. This is
	necessary since some widgets have been deprecated from gtk+ 2.2->2.4,
	but are still in use (any program that uses Gtk.OptionMenu, Gtk.Combo
	and methods in Gtk.Toolbar to name a few). This is done in C# by using
	the [Obsolete] metadata tag.

2004-05-07  Todd Berman  <tberman@sevenl.net>

	* gnome/Makefile.am: add DruidPageEdge.custom
	* gnome/Gnome.metadata: hide DruidPageEdge ctors
	* gnome/DruidPageEdge.custom: subclassable ctors.

2004-05-07  Todd Berman  <tberman@sevenl.net>

	* gnome/IconList.custom: subclassable ctor.
	* gnome/Gnome.metadata: hide IconList ctor.

2004-05-07  Mike Kestner  <mkestner@ximian.com>

	* gnome/Canvas.custom : PixelsPerUnit prop.
	* gnome/Gnome.metadata : hide Canvas.SetPixelsPerUnit.
	* gnome/glue/Makefile.am : get_pixels_per_unit.
	* gnome/glue/canvas.c : get_pixels_per_unit.
	* gtk/Container.custom : OnForall virtual method impl.
	* gtk/glue/Makefile.am : add container.c
	* gtk/glue/container.c : virtual method glue for forall.
	* gtk/glue/makefile.win32 : add container.o

2004-05-07  Todd Berman  <tberman@sevenl.net>

	* gnome/Gnome.metadata: map properties for with_flags DateEdit ctor,
	and hide the DateTime, bool, bool ctor
	* gnome/Makefile.am: Add DateEdit.custom.
	* gnome/DateEdit.custom: Add subclassable ctor for DateEdit and
	add enough overloads that accept variable parameter lists to make
	Mike Kestner sick.

2004-05-07  Todd Berman  <tberman@sevenl.net>

	* gnome/Gnome.metadata: Hide App ctor.
	* gnome/Makefile.am: add App.custom.
	* gnome/App.custom: New custom for subclassing.

2004-05-07  Todd Berman  <tberman@sevenl.net>

	* gnome/Gnome.metadata: Hide Scores ctor.
	* gnome/Makefile.am: add Scores.custom.
	* gnome/Scores.custom: New custom for overridable ctor.

2004-05-07  Mike Kestner  <mkestner@ximian.com>

	* gtk/Gtk.metadata : map some RadioButton ctor props.

2004-05-07  Mike Kestner  <mkestner@ximian.com>

	* gnome/Druid.custom : fix Todd's broken code.

2004-05-07  Mike Kestner  <mkestner@ximian.com>

	* gtk/Gtk.metadata : hide TextView with_buffer ctor. map some parms
	to props.
	* gtk/Makefile.am : add new custom.
	* gtk/TextView.custom : implement with_buffer ctor for subclassing.

2004-05-07  Todd Berman  <tberman@sevenl.net>

	* gnome/Gnome.metadata: Hide Druid with_window ctor, map About property.
	add some null_ok from bug #57948.
	* gnome/Druid.custom: implement with_window ctor for subclassing, and
	a 3 paramatered version for when you dont care about the returned
	window. another 3 parametered version for when you have want null
	parent, and a 2 parametered version for the null parent and the
